UNIT CodeSave;
{ 16.01.96 Alf Test der neuen Speicherungsmethode
  28.02.96 H+A eine DLL erzeugt, Typen -> LuchsTyp
  04.03.96 H   in Create BlockNr auf 1 gesetzt
  15.03.96 Alf Neue Prozeduren zu Konstanten-Speicherung
  19.10.96 Alf Code ist jetzt eine globale Variable
  }
INTERFACE

USES  LuchsTyp;

PROCEDURE CCreate( StartAdr : LongInt);
PROCEDURE CClose;
PROCEDURE speichern(VAR Work: T_WorkFile);
PROCEDURE CSpeichern(CName: T_FileName);  { Export ??? }
PROCEDURE CodiereCodebyte(b: Byte);
PROCEDURE CodiereCodeWord(w: Word);
PROCEDURE CodiereCodeLong(l: LongInt);
PROCEDURE Realconvert(Wert: Double; VAR Real_H,Real_L: Longint);
{ Codierecodereal berflssig: ????
PROCEDURE CodiereCodeReal(r: T_LuchsReal; VAR Code :T_Code);
}
PROCEDURE ersetzebyte(b: Byte; AdrInfo: T_Adrinfo);
PROCEDURE ersetzeword(w: Word; AdrInfo: T_Adrinfo);
PROCEDURE ersetzelong(l: LongInt; AdrInfo: T_Adrinfo);
PROCEDURE LiesAdresse(VAR AdrInfo: T_AdrInfo);
PROCEDURE KS_CodiereS_long(x : LongInt; Reg : Word);
PROCEDURE KS_CodiereS_Real(Wert: Double; Reg : Word);
PROCEDURE KS_CodiereS_Str(s : String);
PROCEDURE Ersetze_KS_Daten(Mit_Branch: Boolean);
PROCEDURE Test_KS_voll;

IMPLEMENTATION


PROCEDURE Setze_ein(VAR Block :T_CFeld; pos : Word; was : LongInt);
BEGIN
  Block[pos]   := was shr 24;
  Block[pos+1] := ( was AND $FF0000) shr 16;
  Block[pos+2] := ( was AND $FF00) shr 8;
  Block[pos+3] := was AND $FF
END;

PROCEDURE CCreate(StartAdr : LongInt);
VAR I : Word;
BEGIN
  for i := 0 to maxb DO code.Block[i] := $FF;
  Code.StartAdresse := StartAdr;
  Code.PC := StartAdr;
  Code.PSHX := false;
  Code.Ersatzliste := nil;
  Code.BlockNr := 0;
  Code.Position := 0;
  Code.KS.ZDat := 0;
  Code.KS.ZAdr := 0;
  Assign(Code.F, 'TEMPDATA.MCD');
  Rewrite(Code.F);
END;

PROCEDURE CClose;
VAR Anzahl : Word;
BEGIN
  IF Code.Position > 0
     THEN BEGIN
            Anzahl := (Code.Position-1) div 128 + 1;
            Blockwrite(Code.F, Code.Block, Anzahl);
          END;
  Close(Code.F);
END;

PROCEDURE NewBlock;
var i:word;
BEGIN
  Blockwrite(Code.F,Code.Block,PufferBlock);
  inc(Code.BlockNr);
  Code.Position := 0;
  FOR i:=0 TO MaxB DO Code.Block[i]:=$FF
END;

{
PROCEDURE Show_Ersatzliste(Ersatzliste: P_Ersatzliste);
VAR l,Anz:word;
    hilf: P_ErsStack;
BEGIN
  writeln('Ersatzlisten-Info');
  while Ersatzliste<>NIL DO
    begin write(' BlNr=',ersatzliste^.BlockNr);
          l:=0; hilf:=Ersatzliste^.Ersstack;
          WHILE hilf <> NIL DO
           BEGIN inc(l); hilf:=hilf^.next end;
          writeln(' Ersatzoperationen: ',l);
          Ersatzliste :=ersatzliste^.next; inc(l) end;
  readln;
END;
}

PROCEDURE Ersatz_ausfuehren(BlockNr : Word);

  FUNCTION suche_Block(BlockNr: Word; StartL : P_ErsatzListe;
                       VAR Found: P_ErsatzListe): Boolean;
  BEGIN
   suche_Block := true;
   IF StartL <> nil
      THEN IF StartL^.BlockNr = BlockNr
              THEN Found := StartL
              ELSE Suche_Block := Suche_Block(BlockNr,StartL^.Next,Found)
      ELSE Suche_block := false
  END;

  PROCEDURE Tausche_aus(VAR Ersatz :P_ErsStack; VAR Block: T_CFeld);
  VAR Hilf : P_ErsStack;
  BEGIN
    WHILE Ersatz <> nil DO
      BEGIN
        Hilf := Ersatz;
                Block[Ersatz^.Position] := Ersatz^.B;
        Ersatz := Ersatz^.next;

        dispose(Hilf)

      END
  END;


VAR Hilf, ERSL : P_Ersatzliste;
BEGIN
  IF suche_Block(BlockNr,Code.Ersatzliste, ERSL)
     THEN Tausche_aus(ERSL^.ErsStack, Code.Block);
END;

PROCEDURE dispose_ERSL(Ersl : P_ErsatzListe);
VAR Hilf : P_Ersatzliste;
BEGIN
  WHILE Ersl <> nil DO
    BEGIN Hilf := Ersl; Ersl := Ersl^.next; dispose(Hilf) END
END;

PROCEDURE CSpeichern(CName: T_Filename);
VAR f: File;
    Diskok: Boolean;
    Dateilaenge : LongInt;
    i, BlockZ, size, Anzahl    : Word;
BEGIN
  BlockZ := 0;
  Dateilaenge := Code.BlockNr;
  Dateilaenge := Dateilaenge * (MaxB+1) + Code.position;
  Assign(f,CName); rewrite(f); reset(Code.F);
  size := filesize(Code.f);
  FOR i:=0 TO 31 DO Setze_ein(Code.Block, i*4, 0);
  Setze_ein(Code.Block, 0, Code.Startadresse);
  Setze_ein(Code.Block, 4, Dateilaenge);
  Blockwrite(F, Code.Block, 1);
  WHILE not eof(Code.F) DO
    BEGIN
      IF size < Pufferblock
         THEN Anzahl := size
         ELSE Anzahl := PufferBlock;
      Blockread(Code.F, Code.Block, Anzahl);
      Ersatz_ausfuehren( BlockZ);
      Blockwrite(F, Code.Block, Anzahl);
      inc(BlockZ); dec(size, Anzahl)
    END;
  Close(F); Close(Code.F);
  dispose_ERSL(Code.Ersatzliste);
END;

PROCEDURE speichern(VAR Work: T_WorkFile);
BEGIN
  Work.Cname := Copy(Work.TName, 1, Length(Work.TName) - 3) + 'MCD';
  CSpeichern(Work.CName);
  Work.WCode := True
END;

PROCEDURE CodiereCodebyte(b: Byte);
VAR i: Integer;
    Taste: Char;ST : String;
BEGIN
  IF Code.Position>maxB THEN NewBlock;
  Code.Block[Code.Position]:=b;
  Inc(Code.Position); Inc(Code.PC);
END;

PROCEDURE CodiereCodeWord(w: Word);
BEGIN
  CodiereCodebyte(Hi(w));
  CodiereCodebyte(Lo(w))
END;

PROCEDURE CodiereCodelong(l: LongInt);
BEGIN
  CodiereCodeWord(l SHR 16);
  CodiereCodeWord(l AND $FFFF)
END;

PROCEDURE Realconvert(Wert: Double; VAR Real_H,Real_L: Longint);
TYPE T_reell=RECORD
                CASE Char OF
                  'R': (Intel   : Double);
                  'B': (b       : ARRAY[0..7] OF Byte);
                  'I': (R_L,R_H : LongInt);
             END;
VAR Reell: T_Reell;
    i    : Integer;
BEGIN
   Reell.Intel:=Wert;
   Real_H:=Reell.R_H; Real_L:=Reell.R_L;
END;

{
PROCEDURE CodiereCodeReal(r: T_LuchsReal; VAR Code:T_Code);
VAR i : Word;
BEGIN
  FOR i := 0 TO 7 DO
    CodiereCodeByte(R[i], Code)
END;
}

PROCEDURE LiesAdresse(VAR AdrInfo: T_AdrInfo);
BEGIN
  AdrInfo.BlockNr:=Code.BlockNr;
  AdrInfo.Position:=Code.Position
END;

{ -- Verwaltung der Ersatzliste fr bereits gespeicherte Blcke ---- }

PROCEDURE InErsatzliste(B: Byte; AdrInfo: T_AdrInfo);

 PROCEDURE Finde_Erzeuge_Block(BlockNr    : Word;
                               VAR ErsListe,
                                   Erspos : P_ErsatzListe);

   PROCEDURE neue_Zeile(BlockNr: Word; VAR ErsListe, ErsPos: P_ErsatzListe);
   BEGIN new(Ersliste);
         Ersliste^.BlockNr := BlockNr;
         Ersliste^.ErsStack := nil;
         Ersliste^.next := nil;
         ErsPos := ErsListe
   END;

 BEGIN
  IF ErsListe = nil
     THEN neue_Zeile(BlockNr, ErsListe, ErsPos)
      ELSE IF Ersliste^.BlockNr = BlockNr
             THEN Erspos := ErsListe
             ELSE Finde_Erzeuge_Block(BlockNr, ErsListe^.next, ErsPos)

 END;

VAR Hilf : P_ErsStack;
    ErsPos : P_ErsatzListe;
BEGIN
{
writeln('BlNr=',Adrinfo.Blocknr,' Pos=',AdrInfo.Position,': ',b);
}
  Finde_Erzeuge_Block(AdrInfo.BlockNr, Code.ErsatzListe,ErsPos);
  new(Hilf);
  Hilf^.B := B;
  Hilf^.Position := AdrInfo.Position;
  Hilf^.next := ErsPos^.ErsStack;
  ErsPos^.ErsStack := Hilf
END;

PROCEDURE ersetzebyte(b: Byte; AdrInfo: T_Adrinfo);
BEGIN
  IF AdrInfo.BlockNr = Code.Blocknr
     THEN Code.Block[AdrInfo.Position] := b
     ELSE InErsatzliste(b, AdrInfo);
END;

PROCEDURE ersetzeword(w: Word; AdrInfo: T_Adrinfo);
BEGIN
  IF AdrInfo.Position > maxB
     THEN BEGIN Inc(AdrInfo.BlockNr); AdrInfo.Position := 0 END;
  ersetzeByte(hi(w), AdrInfo);
  inc(AdrInfo.Position);
  IF AdrInfo.Position > maxB
     THEN BEGIN Inc(AdrInfo.BlockNr); AdrInfo.Position := 0 END;
  ersetzeByte(lo(w), AdrInfo)
END;

PROCEDURE ersetzelong(l: LongInt; AdrInfo: T_Adrinfo);
BEGIN
  ersetzeWord((l shr 8) shr 8, AdrInfo);
  inc(AdrInfo.Position,2);
  IF AdrInfo.Position > maxB
     THEN BEGIN Inc(AdrInfo.BlockNr); dec(AdrInfo.Position, maxB+1) END;
  ersetzeWord(l mod $10000, AdrInfo)
END;

{ ----- Speicherung von Konstanten im Code ----------------------- }

PROCEDURE Ersetze_KS_Daten(Mit_Branch: Boolean);
VAR i, Offset : Word;
    Adr : T_AdrInfo;
BEGIN
  IF Code.KS.ZDat <> 0 THEN
     BEGIN
       IF Code.PC mod 4 <> 0
          THEN CodiereCodeWord($9);
       IF Mit_Branch
          THEN BEGIN CodiereCodeWord($A000 + (4*Code.KS.ZDat) div 2 );  { BRA ??? }
                     CodiereCodeWord($9);                       { NOP nach BRA }
               END;
       Code.KS.Offs00 := Code.PC;
       FOR i := 0 TO Code.KS.ZDat - 1 DO
          CodiereCodeLong(Code.KS.Daten[i]);
       FOR i := 0 TO Code.KS.ZAdr - 1 DO
          BEGIN
            Adr.BlockNr := Code.KS.AdrFeld[i].BlockNr;
            Adr.Position   := Code.KS.AdrFeld[i].Pos-1;
            offset := (Code.KS.Offs00 - Code.KS.AdrFeld[i].PC) div 4
                      + Code.KS.AdrFeld[i].Offset;
            ErsetzeByte(offset, Adr)
          END;
  END;
  Code.KS.ZAdr   := 0;   { Puffer ist jetzt leer }
  Code.KS.ZDat   := 0;
END;

PROCEDURE Test_KS_voll;
BEGIN
(*
  IF (Code.KS.ZAdr = 256) OR
     (Code.PC - Code.KS.AdrFeld[0].PC > 700 ) OR (Code.KS.ZDat > 180)
     THEN Ersetze_KS_Daten(Mit_Branch)
*)
  IF (Code.KS.ZAdr >= 120) OR
     (Code.PC - Code.KS.AdrFeld[0].PC > 500 ) OR (Code.KS.ZDat > 100)
     THEN Ersetze_KS_Daten(Mit_Branch)

END;


PROCEDURE KS_Append(x: LongInt; mitAdr : Boolean);
VAR PC_Offs : T_KSAdr;
BEGIN
  Code.KS.Daten[Code.KS.ZDat] := x;
  PC_Offs.BlockNr     := Code.BlockNr;
  PC_Offs.Pos         := Code.Position;
  PC_Offs.PC          := Code.PC;
  PC_Offs.Offset      := Code.KS.ZDat;       { ab KS_Block }
  Inc(Code.Ks.ZDat);
  IF mitAdr
     THEN BEGIN Code.KS.AdrFeld[Code.KS.ZAdr] := PC_Offs;
                Inc(Code.KS.ZAdr)
          END
END;

PROCEDURE KS_CodiereS_long(x : LongInt; Reg : Word);
BEGIN
  IF (x >= -128) AND (x <= 127)
     THEN IF x >= 0
             THEN CodiereCodeWord($E000+$100*Reg+x)
             ELSE CodiereCodeWord($E000+$100*Reg+(x AND $FF))
     ELSE BEGIN
            CodiereCodeWord($D000+$100*Reg);
            KS_Append(x, true);
          {  Test_KS_voll(Code) }
          END
END;

PROCEDURE KS_CodiereS_Real(Wert : Double; Reg : Word);
VAR L1,L2 : LongInt;
BEGIN
  RealConvert(Wert,L1,L2);
  CodiereCodeWord($D000+ $100*Reg);
  KS_Append(L1, true);
  CodiereCodeWord($D000+ $100*(Reg+1));
  KS_Append(L2,True);
 { Test_Ks_voll(Code) }
END;


PROCEDURE KS_CodiereS_Str(s: String);
TYPE T_Help = Record CASE boolean OF
                       true : (str: String[255]);
                       False: (f: ARRAY[0..63] OF Longint);
                     END;
VAR i,j : Integer;
    Help: T_Help;
BEGIN
  CodiereCodeWord($C700);     (* mova Str,R0 *)
  FOR i:=0 TO 63 DO
      BEGIN j:=i*4;
            Help.str[j]  :=s[j+3];
            Help.str[j+1]:=s[j+2];
            Help.str[j+2]:=s[j+1];
            Help.str[j+3]:=s[j];
      END;
  FOR i := 0 TO length(s) div 4 DO
    KS_Append(Help.f[i], i=0);
{  Test_Ks_voll(Code) }
END;

END.

