unit Err_unit;

interface

uses
  Luchstyp,
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TErr_Form = class(TForm)
    Err_Memo: TMemo;
    Err_Label: TLabel;
    Clearbutton: TButton;
    EditButton: TButton;
    Fehlerlabel: TLabel;
    Dateilabel: TLabel;
    procedure ClearbuttonClick(Sender: TObject);
    procedure EditButtonClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

procedure Err_Ausgabe(Quelle: String);

var
  Err_Form: TErr_Form;

implementation

uses editwin;

{$R *.DFM}

procedure TErr_Form.ClearbuttonClick(Sender: TObject);
begin
   Err_Form.Close ; GlobVar.Err_aktiv:=False;
end;

procedure Err_Ausgabe(Quelle: String);
var i,l: Integer;
BEGIN
  Err_Form.Show; GlobVar.Err_aktiv:=True;
  Err_Form.Err_Memo.Clear;
  Err_Form.Editbutton.enabled:=not inputrec.include;
  Err_Form.Err_Label.Caption:=Quelle;
  Err_Form.Fehlerlabel.Caption:=InputRec.Fehlermeldung;
  Err_Form.Dateilabel.Caption:='Datei: '+InputRec.Dateiname;
  FOR i:=1 TO 6 DO {Err_Form.Err_Memo.Lines.Add(InputRec.Meldung[i]);}
    BEGIN l:=Length(InputRec.Meldung[i]);
          IF (l>0) AND (InputRec.Meldung[i]=#0)
             THEN InputRec.Meldung[i][1]:=' ';
          Err_Form.Err_Memo.Lines.Add(InputRec.Meldung[i])
    END
END;

procedure TErr_Form.EditButtonClick(Sender: TObject);
var Startzeile: String;
    StartPChar: ARRAY[0..255] OF Char;
begin
  IF SysInfo.Editorname=''
     THEN begin Editform.show;
                Editform.zsuch_nummer.text:=inttostr(inputrec.last.znr);
                Editform.zsuch_okclick(err_form)
          end
     ELSE BEGIN
            StartZeile:=SysInfo.Editorname+' '+Workfile.TName;
            IF WinExec(StrPCopy(StartPChar,StartZeile),SW_Show)<=32
               THEN Luchs_Info('Kann '+Sysinfo.Editorname+' nicht starten');
          END;
end;

procedure TErr_Form.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Screeninfo.ErrWin.WinTop:=Err_Form.Top;
  Screeninfo.ErrWin.WinLeft:=Err_Form.Left;
  Screeninfo.ErrWin.WinHeight:=Err_Form.Height;
  Screeninfo.ErrWin.WinWidth:=Err_Form.Width;
end;

procedure TErr_Form.FormActivate(Sender: TObject);
begin
  Err_Form.Top:=Screeninfo.ErrWin.WinTop;
  Err_Form.Left:=Screeninfo.ErrWin.WinLeft;
  Err_Form.Height:=Screeninfo.ErrWin.WinHeight;
  Err_Form.Width:=Screeninfo.ErrWin.WinWidth;
end;

end.
