UNIT  FileDOS;  { Fileauswahl fr DOS-System }
{  10.06.90  Selektion  der Fileart 1 = Text , -1 = code ,0 = all
                           Anzahl  Subdirs auf 40 erhht;
   19.10.96  Im Rahmen der DOS/Windows-Operation auf Bcke getestet
}


INTERFACE

USES Crt, Dos, LuchsTyp;

PROCEDURE Filer(Frage : T_Filename; Art : Integer;  VAR Work: T_WorkFile);

IMPLEMENTATION

PROCEDURE Maske(frage : T_Filename);
BEGIN
ClrScr;
Writeln('ͻ');
Write  (' Luchs - Filer  ', Frage,' <RET> = anderer Name');Crt.gotoxy(78,2); Writeln('');
Writeln('͹');
Writeln('                                                                            ');
Writeln('͹');
Writeln(' Dateien                                       Verzeichnisse    Laufwerk  ');
Writeln('Ķ');
Writeln('                                                                <F1> A:  ');
Writeln('Ĵ                      Ķ  <F2> B:  ');
Writeln('                                                                <F3> C:  ');
Writeln('                                                                <F4> D:  ');
Writeln('                                                                <F5> E:  ');
Writeln('                                                                <F6> F:  ');
Writeln('                                                                <F7> G:  ');
Writeln('                                                                <F8> H:  ');
Writeln('                                                                <F9> I:  ');
Writeln('                                                              Ķ');
Writeln('                                                               total     ');
Writeln('                                                                      kB ');
Writeln('                                                              Ķ');
Writeln('                      Ķ frei      ');
Writeln('                                                                      kB ');
Write  ('ͼ');
END;

PROCEDURE Convert(VAR N : T_Filename);
VAR i : Integer;
BEGIN
 { FOR i := 1 TO Length(N) DO N[i] := Upcase(N[i]) }
END;

PROCEDURE Filer(frage : T_Filename; Art : Integer; VAR Work: T_WorkFile);

CONST MaxF   = 250;
      maxD   = 40;

TYPE  T_PfadName      = String[55];
      T_StrArray      = ARRAY [0..maxf] OF  T_Bezeichner;
      T_DirArray      = ARRAY [0..maxd] OF T_Pfadname;

PROCEDURE ShowTitel(AktDisk:T_Pfadname);
BEGIN
   Crt.Gotoxy(3,4);  Write(Aktdisk, '':68 - Length(aktdisk));
END;

PROCEDURE Kommando(Sp, Fr : Longint);
BEGIN
   Crt.Gotoxy(68,19); Write(Sp div 1024:6);
   Crt.Gotoxy(68,22); Write(Fr div 1024:6);
END;

PROCEDURE Sortiere(VAR Namen : T_StrArray; anz : Integer);

  PROCEDURE Find_Min(VAR Namen : T_StrArray; Start, Ende : Integer;
                     VAR pos : Integer);
  VAR i : Integer; x : T_FileName;
  BEGIN
    pos := Start; x := Namen[pos];
    FOR i := Start+1 TO Ende DO
        IF Namen[i] < x THEN BEGIN pos := i; x := Namen[i] END
  END;

 PROCEDURE Vertausche (VAR a,b : T_FileName);
 VAR h : T_Filename;
 BEGIN
   h := a; a := b; b := h
 END;

VAR i,j : Integer;
BEGIN
   FOR i := 0 TO anz-1 DO
    BEGIN
       Find_min(Namen,i, anz,j);
       IF i <> j THEN Vertausche(Namen[i], Namen[j])
    END
END;

PROCEDURE DirSortiere(VAR Namen : T_DirArray; anz : Integer);

  PROCEDURE Find_Min(VAR Namen : T_DirArray; Start, Ende : Integer;
                     VAR pos : Integer);
  VAR i : Integer; x : T_PfadName;
  BEGIN
    pos := Start; x := Namen[pos];
    FOR i := Start+1 TO Ende DO
        IF Namen[i] < x THEN BEGIN pos := i; x := Namen[i] END
  END;

 PROCEDURE Vertausche (VAR a,b : T_PfadName);
 VAR h : T_Pfadname;
 BEGIN
   h := a; a := b; b := h
 END;

VAR i,j : Integer;
BEGIN
   FOR i := 0 TO anz-1 DO
    BEGIN
       Find_min(Namen,i, anz,j);
       IF i <> j THEN Vertausche(Namen[i], Namen[j])
    END
END;

PROCEDURE LiesFiles(VAR NamenArray : T_StrArray; VAR Maxfiles : Integer;
                    VAR DirArray   : T_DirArray; VAR Maxdir   : Integer;
                        Art        : Integer);
VAR FileName: T_FileName;
    Resultat: SearchRec;
    attribut :Byte;
    i          : Integer;
BEGIN
  CASE ART OF
    -1   : FileName := '*.MCD';
     0   : FileName := '*.*';
     1   : FileName := '*.MTX'
  END;
  i := -1;
  attribut := 0;                    (* nur die normalen Datein *)
  FindFirst(Filename,attribut,Resultat);
  WHILE (Doserror = 0) AND (i<MaxF) DO
      BEGIN inc(i);
            Namenarray[i] := Resultat.Name;
            Findnext(Resultat);
      END;
  maxFiles := i;
  i := -1;
  Dirarray[0]:='';
  attribut := Directory ;          (* nur die Direktory-Namen *)
  Filename := '*.*';
  FindFirst(Filename,attribut,Resultat);
  WHILE (Doserror <> 18) AND (i<MaxD) DO
      BEGIN IF Resultat.Name <>'.'
               THEN BEGIN inc(i);
                          Dirarray[i] := Resultat.Name
                    END;
            REPEAT Findnext(Resultat)
            UNTIL (Resultat.Attr = Directory) OR (DosError = 18)
      END;
  maxDir := i;
  Sortiere(Namenarray, maxFiles); DirSortiere(Dirarray, maxDir)
 END;

PROCEDURE Position(i : Integer);
VAR x,y : Integer;
BEGIN
  i := i mod 26;
  x := i div 13; y := i mod 13;
  Crt.Gotoxy(23 * x +3 , y +10 - 2* x)
END;

PROCEDURE WritePgUp;
BEGIN
  Crt.Gotoxy(4,8); Write('^   PgUp')
END;

PROCEDURE WritePgDn;
BEGIN
  Crt.Gotoxy(27,22); Write('v   PgDn')
END;

PROCEDURE DeletePgDn;
BEGIN
  Crt.Gotoxy(27,22); Write('        ')
END;

PROCEDURE DeletePgUp;
BEGIN
  Crt.Gotoxy( 4, 8); Write('        ')
END;


PROCEDURE WriteHome;
BEGIN
  Crt.Gotoxy(51,8); Write('^   Home')
END;

PROCEDURE WriteEnd;
BEGIN
  Crt.Gotoxy(51,22); Write('v   End')
END;

PROCEDURE DeleteEnd;
BEGIN
  Crt.Gotoxy(51,22); Write('        ')
END;

PROCEDURE DeleteHome;
BEGIN
  Crt.Gotoxy(51, 8); Write('        ')
END;


PROCEDURE ShowFiles(VAR NamenArray: T_StrArray; Seite, maxfile: Integer;
                    VAR maxch : Char);
VAR i, Start, Ende: Integer;
BEGIN
  Start := Seite * 26; Ende := (Seite + 1) * 26 -1;
  IF Ende >= maxfile THEN BEGIN Ende := maxfile; maxCh := Chr(65 + ende - Start);
                               DeletePgDn
                         END
                    ELSE BEGIN maxch := 'Z'; WritePgDn
                         END;
  FOR i := Start TO Ende DO BEGIN Position(i);
                                Write('<', Chr((i mod 26) + 65),
                                      '>    ',NamenArray[i],'':13-length(Namenarray[i]));
                            END;
  i := (Ende+1) ;
  if i = 0 THEN BEGIN position(i); Write('... no entry ...   '); i := 1 END;
  WHILE (i mod 26 <> 0)
     DO BEGIN Position(i); Write('                   '); i:= i+1 END;
  IF Seite > 0 THEN writePgUp ELSE DeletePgUp;
  Crt.Gotoxy(77,2)
END;

PROCEDURE DirPosition(I : Integer);
BEGIN
  Crt.Gotoxy(50, 10 + i mod 11)
END;

PROCEDURE ShowDir(VAR DirArray: T_DirArray; Seite, maxdir: Integer;VAR maxch : Char);
VAR i, Start, Ende: Integer;
BEGIN
  Start := Seite * 11; Ende := (Seite + 1) * 11 -1;
  IF Ende >= maxDir THEN BEGIN Ende := maxdir; maxCh := Chr(48 + ende - Start);
                              DeleteEnd
                         END
                    ELSE BEGIN maxch := ':'; WriteEnd END;
  IF (Maxdir=0) AND (Dirarray[0]<>'..')
     THEN BEGIN Dirposition(0); Write('... no entry ...') END
     ELSE FOR i := Start TO Ende DO
              BEGIN DirPosition(i);
                    Write('<', Chr((i mod 11) + 48),
                          '>   ',DirArray[i],'':10-length(Dirarray[i]));
              END;
  i := Ende+1;
  WHILE (i mod 11 <> 0)
     DO BEGIN DirPosition(i); Write('                '); i:= i+1 END;
  IF Seite > 0 THEN writeHome ELSE DeleteHome;
  Crt.Gotoxy(77,2)
END;


PROCEDURE Disk(C: Char;VAR AktDir: T_Pfadname);
VAR Reg : Registers;
BEGIN
  IF c in ['A'..'K']
     THEN BEGIN Reg.Ax := $0E00;
                Reg.Dx := Ord(c) - Ord('A');
                Intr($21,Reg);
                GetDir(0,AktDir);
                IF AktDir[Length(AktDir)]= '\'
                   THEN Delete(AktDir,Length(Aktdir),1);
          END
END;

 PROCEDURE Check_Workfile(Filename : T_Filename; VAR Work : T_Workfile);
 VAR  x : Integer;
      Suffix : T_Filename;
 BEGIN
  IF (Filename <>'') AND (pos('.',Filename) > 0)
     THEN BEGIN x := pos('.', Filename);
                suffix := copy(filename,x+1,3);
                IF (suffix = 'MTX') OR (suffix = 'PAS') OR
                   (suffix = 'mtx') OR (suffix = 'pas')
                   THEN BEGIN Work.WText := True;
                              Work.TName := filename;
                              Work.LName := Copy(filename,1,x)+'LST'
                        END
                   ELSE IF (Suffix = 'MCD') OR (suffix='mcd')
                           THEN BEGIN Work.WCode := True;
                                      Work.CName := filename
                                END
                           ELSE BEGIN Work.WCode := false;
                                      Work.WText := false
                                END
          END
 END;


VAR VolChanged, Dirchanged, neuanz, fertig : Boolean;
    Seite, maxfile,
    DirSeite, maxDir   : Integer;
    maxDch, maxFch     : Char;
    NamenArray         : T_StrArray;
    ch, chx            : Char;
    AktDir             : T_Pfadname;
    DirArray           : T_DirArray;
    Sp                 : Longint;
    Filename           : T_Filename;
BEGIN
   ClrScr; Maske(frage); Filename :='';
   GetDir(0,AKtDir);
   IF AktDir[Length(AktDir)]= '\' THEN Delete(AktDir,Length(Aktdir),1);
   VolChanged := True; DirChanged := True; fertig := false;
   REPEAT
      IF VolChanged THEN BEGIN Kommando(Disksize(0), Diskfree(0));
                               Dirchanged := True; VolChanged := false
                         END;
      IF Dirchanged THEN BEGIN ShowTitel(AktDir);
                               Seite := 0; DirSeite := 0;
                               LiesFiles( NamenArray, maxFile,
                                         DirArray, MaxDir, Art);
                               ShowFiles(NamenArray,Seite,maxfile,maxFch);
                               ShowDir(DirArray,DirSeite, maxdir,maxDch);
                               DirChanged := false
                         END;
      ch := Readkey;
      IF Ch = #0
         THEN BEGIN chx := ReadKey; neuanz := false;
                       CASE chx OF
                        #59 : BEGIN Disk('A', AktDir); Volchanged := True END;
                        #60 : BEGIN Disk('B', AktDir); Volchanged := True END;
                        #61 : BEGIN Disk('C', AktDir); Volchanged := True END;
                        #62 : BEGIN Disk('D', AktDir); Volchanged := True END;
                        #63 : BEGIN Disk('E', AktDir); Volchanged := True END;
                        #64 : BEGIN Disk('F', AktDir); Volchanged := True END;
                        #65 : BEGIN Disk('G', AktDir); Volchanged := True END;
                        #66 : BEGIN Disk('H', AktDir); Volchanged := True END;
                        #67 : BEGIN Disk('I', AktDir); Volchanged := True END;

                        #71 : IF DirSeite > 0
                                 THEN BEGIN Dec( DirSeite); neuanz := True END;
                        #73 : IF Seite > 0
                                 THEN BEGIN Dec(Seite); neuanz := True END;
                        #79 : IF Dirseite*11 < maxDir-10
                                 THEN BEGIN Inc(DirSeite); neuanz := True END;
                        #81 : IF Seite*26    < MaxFile-25
                                 THEN BEGIN Inc(Seite); neuanz := True END;
                       END;
                    IF neuanz THEN
                       BEGIN ShowFiles(NamenArray,Seite,maxfile,maxFch);
                             ShowDir(DirArray,DirSeite, maxdir,maxDch)
                       END
              END
         ELSE BEGIN ch := Upcase(ch);
      CASE ch OF
      #13      : BEGIN Crt.Gotoxy(3,4); Write('Dateiname :'); ClrEol;
                       Crt.Gotoxy(78,4); Write('');
                       Crt.Gotoxy(15,4); Readln(Filename);
                       Fertig := true
                 END;
      'A'..'Z' : IF ch <= maxFch
                    THEN BEGIN Filename := AktDir + '\' +
                               NamenArray[Ord(ch)- Ord('A') + 26* Seite];
                               Fertig := True
                         END;
      '0'..':'  : IF maxdir >= 0
                      THEN BEGIN IF ch IN ['0'..maxDCh]
                         THEN BEGIN IF DirArray[Ord(ch) - Ord('0') + 11 * DirSeite]
                                    = '..'
                                    THEN BEGIN
                                          REPEAT Delete(AktDir,Length(AktDir),1)
                                          UNTIL AktDir[Length(aktdir)] = '\';
                                          Delete(AktDir,Length(aktdir),1);
                                         END
                                    ELSE AktDir :=AktDir + '\' +
                                         DirArray[Ord(ch)-Ord('0') + 11 * Dirseite] ;
                                    IF Aktdir[Length(aktDir)] =':'
                                             THEN ChDir(AktDir + '\')
                                             ELSE ChDir(AktDir)
                              END;
                    DirChanged := True
                 END;
      #27      : fertig := true
      END;
   END
 UNTIL Fertig;
 Check_Workfile(Filename, Work);
END;

END. (* Implementation *)
