{  10.02.96 Alf Urversion aus MOPS-Basis Version 2.2
                Lesen aus Quelldatei und allgemeine Prozeduren aus
                der alten Scan-Unit werden jetzt hier verwaltet.
   25.02.96 A+H Neuentwicklung fr DLLs
   15.03.96 Alf Konstanten-Speicherung in T_Code neu. }

UNIT LuchsTyp;

INTERFACE
{$IFDEF Delphi }
USES   SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus;
{$ENDIF }

CONST Bef_Setadresse     =  0;
      Bef_SetByte        =  1;
      Bef_ReadByte       =  2;
      Bef_Setreg         =  3;
      Bef_Readreg        =  4;
      Bef_Quit           =  5;
      Bef_Go             =  6;
      Bef_Move           =  7;
      Bef_Verify         =  8;
      Bef_Abbruch        =  9;
      Bef_MonInsRam      = 10;
      Bef_LiesFlash      = 11;
      Bef_Sektorloeschen = 12;
      Bef_TestClear      = 13;
      Bef_Prog           = 14;
      Bef_Startsys       = 15;
      Adr_Standalone     =$18;   (* Startvektor des Anwenderprogramms  *)
      BR19200            =  6;   (* Vorteiler der Seriellschnittstelle *)
      BR38400            =  3;   (* Vorteiler der Seriellschnittstelle *)
      BR57600            =  2;
      BR115200           =  1;
      Maxfiles           =  6;   (* Anzahl gemerkter Text/Codenamen *)
      Mit_Branch         = True; (* fuer Ersetze_KS_Daten *)
      Ohne_Branch        = False;

TYPE Str4          = String[4];

     Str8          = String[8];
     Str80         = String[80];
     String255      = String[255];
     Str131        = String[131];
     T_Ident       = String[9];
     T_Bezeichner  = String[19];
     T_Meldungsstr = String[76];
     T_Filename    = String[79];
     T_Meldung     = ARRAY [1..6] OF T_Meldungsstr;
     T_StringPtr   = ^T_FileName;

     T_Assaufruf   = (Basicass,Pascalass,Ass);
     T_Workfile    = RECORD
                       TName, CName,
                       LName          : T_Filename;
                       WText, WCode   : Boolean;
                       TFehler        : Word;
                     END;
     T_LuchsReal   = ARRAY [0..7] OF Byte;
     T_LastText    = RECORD Satz : String255;
                            Txt: ARRAY [0 .. 2] OF String255;
                            Ptr, ZNr, INr: Integer
                     END;
     T_Input       = RECORD
			  z            : Char;
			  Quell, Incl  : Text;
                          Stacked      : Boolean;
			  Include      : Boolean;
                          Fehlermeldung,
                          Dateiname    : String;
			  Last         : T_LastText;
			  Meldung      : T_Meldung;
                          okMeldung    : String;
			  C_Ok         : Boolean;
                          Quellgroesse,Inclgroesse: Longint;
                          Quellpos,Inclpos        : Longint
		       END;
     T_GlobVar     = RECORD
                          Mon_Aktiv     : Boolean;
                          Host_ist_Slave: Boolean;
                          Edit_aktiv    : Boolean;
                          Err_aktiv     : Boolean;
                          Wait_for_Key  : Boolean;
                     END;
{ Typen fuer die Codeerzeugung ---------------------- }


     T_Dateiname = Record
                     Textname,Codename: ARRAY [1..Maxfiles] OF T_Filename;
                   end;

     T_SysInfo  = RECORD
                    Com,SlaveMaxX,SlaveMaxY         : Byte;
                    Win_Seriell                     : Boolean;
                    Codestart,Epromstart            : LongInt;
                    Speed, Baud          : Longint;
                    Baudrate,
                    ProgName,Infoname,Dateifilename,
                    ScreenInfoName,
                    SysName,
                    Editorname                      : T_Filename;
                    Dateiname                       : T_Dateiname;
                  END;
        T_Trap    = (  R_IntMult,R_IntDiv,R_IntMod,R_IntBool,
                    R_FloatBool,R_Writeline,R_WriteChr,R_Writestr,
                    R_Gotoxy,R_Uppercase,R_ReadChr,R_ReadString,
                    R_Keypress,R_StrPush,R_StrPull,R_StrLength,
                    R_StrConcat,R_StrCopy,R_StrLeft,R_StrRight,
                    R_StrCmp,R_StrPos,R_StrChr,
                    R_Asc,R_IntZuStr,R_SetClock,R_ReadClock,
                    R_LongAnd, R_LongOr, R_LongEor, R_LongNot,
                    R_Delay,R_Readtimer,
                    R_AndReal, R_OrReal, R_NotReal, R_NegReal, R_AbsReal,
                    R_FloatAdd,R_FloatSub,R_FloatMult,R_FloatDiv,
                    R_FloatInt,R_IntFloat,R_RealZuStr, R_StrzuReal,
                    R_FloatCmp,R_FloatTrunc,R_FloatFrac,R_FloatRound,
                    R_Floatquadrat,R_Floatwurzel,R_FloatSin,R_FloatCos,
                    R_FloatTan,R_FloatATan,R_FloatASin,R_FloatACos,
                    R_FloatExp,R_FloatLn,
                    R_LCDInit,
                    R_I2CInit,R_I2CStart,R_I2CRestart,R_I2CSend,
                    R_I2CReadA,R_I2CReadNA,R_I2CStop,R_I2CAck,
                    R_EEProgByte,R_EEProgWord,R_EEProgLong,R_EEProgReal,
                    R_EEProgStr,
                    R_EEReadByte,R_EEReadWord,R_EEReadLong,R_EEReadReal,
                    R_EEReadStr,
                    R_Tastinit,
                    R_SCI1Init,R_ADIN,R_ADIN16,R_DAOUT,
      { Alfred }    R_PullViel, R_PushViel, R_WriteInt,
                    R_SetPlus, R_SetMinus, R_SetMal, R_SetAkgB, R_SetBkgA,
                    R_SetIn, R_SetIncl, R_SetInViel,
                    R_TuNIX,
                    R_TaskStart, R_TaskStop, R_InitTask, R_TermTask,
                    R_Send, R_Wait, R_Awaited, R_Sleep,
                    R_IntMask, R_SetRegister,
                    R_GetMem, R_Freemem, R_Memavail, R_MaxAvail, R_FreeCount,
                    R_Randomize, R_Random,
                    R_GetBPort, R_GetWPort, R_GetLPort,
                    R_SetBPort, R_SetWPort, R_SetLPort,
                    R_Cmpviel, R_Writereal, R_Fakultaet,
                    R_SetIrqMask, R_GetIrqMask,
                    R_RSInit,R_RSReady,R_RSStat,
                    R_RSRead,R_RSSend,
                    R_GoHost,
                    R_Last
                    );


CONST maxB        = 255;
      PufferBlock = 2; { maxB = 128 * PufferBlock }

TYPE T_CFeld         = ARRAY [0..maxB] OF Byte;
     P_ErsatzListe   = ^T_ErsatzZeile;
     P_ErsStack      = ^T_ErsStack;
     T_ErsatzZeile   = RECORD BlockNr  : Word;
                              ErsStack : P_ErsStack;
                              next     : P_ErsatzListe
                       END;
     T_ErsStack      = Record Position : Word;
                              B        : Byte;
                              next     : P_ErsStack
                       END;
     T_KSAdr         = RECORD Blocknr, Pos, Offset : Word;
                              PC : LongInt; END;
     T_KSFeld        = ARRAY [0 .. 1023] OF LongInt;
     T_AdrFeld       = ARRAY [0 .. 255] OF T_KSAdr;
     T_KonstSpeicher = RECORD Daten : T_KSFeld;
                              AdrFeld : T_AdrFeld;
                              ZAdr, ZDat : Word;
                              Offs00   : LongInt
                       END;
     T_Code          = RECORD
                          PC, StartAdresse,
                          Laenge            : LongInt;
                          BlockNr           : Longint;
                          Position,
                          Size              : Word;
                          Block             : T_CFeld;
                          KS                : T_KonstSpeicher;
                          PSHX,Quickload    : Boolean;
                          ErsatzListe       : P_ErsatzListe;
                          Name              : T_Filename;
                          F                 : File
                       END;
     T_AdrInfo       = RECORD BlockNr, Position : Word
                       END;
{$IFDEF Delphi }
     T_Win           = RECORD
                         WinTop,WinLeft,WinHeight,WinWidth: Word;
                         WinFont: TFont;
                         fontgroesse: Word;
                         Pagebreite,pagehoehe: longint;
                       END;

     T_Screeninfo    = RECORD
                         MainWin,MonWin,ErrWin,EditWin: T_Win;
                       END;


VAR Screeninfo  : T_Screeninfo;

{$ENDIF}

VAR Sysinfo     : T_Sysinfo;
    GlobVar     : T_GlobVar;
    Workfile    : T_Workfile;
    InputRec    : T_Input;
    Code        : T_Code;
    StartDir    : Str131;


PROCEDURE Luchs_Dialog(s:String; Zahl:Longint);
PROCEDURE Luchs_Info(s:String);

IMPLEMENTATION

{$IFDEF Delphi}

PROCEDURE Luchs_Dialog(s:String;Zahl:Longint);
var nix: word; z: String;
begin
 str(Zahl,z);
 nix:=MessageDlg(s+' '+z,mtInformation, [mbOk], 0)
end;

PROCEDURE Luchs_Info(s:String);
var nix: word;
begin
 nix:=MessageDlg(s,mtInformation, [mbOk], 0)
end;

{$ELSE}

PROCEDURE Luchs_Dialog(s:String;Zahl:Longint);
var z: String;
begin
 str(Zahl,z);
 Writeln(s+' '+z); Readln
end;

PROCEDURE Luchs_Info(s:String);
begin
  Writeln(s); Readln
end;

{$ENDIF}


END.

