UNIT PAS7000;  { der PASCAL-Compiler }

{ 02.06.95 Alf aus MOPS-Version 2.2 abgeleitet
  13.06.95 Alf LongInt eingefhrt
  16.06.95 Alf Beim Display nur noch Tiefe benutzt
  16.03.96 Alf Generalanpassung auf Luchs
  27.07.96 -
  01.08.96 ALf Codererzeugung fuer LuchS
  19.10.96 Alf Einheitliche Version fuer DOS und Windows
  09.11.96 Alf Ersetze_Ks_Daten(ohne_branch) nach Prozeduren, usw.
  10.11.96 Alf Prozeduren erzeugen jetzt freien Speicher fr lok. Variablen
               selbst. Reihenfolge der Parameter umgekehrt
  26.06.97 Alf Swap fuer Real-Parameter eingefuehrt. Uebergabefehler
  24.10.97 Alf Pehler bei Parameteruebergabe R13 beseitigt
  25.10.97 Alf bei Strings + Chars jetzt Concat durch '+' erlaubt
  29.01.98 Alf Funtionsvariable bei integer u. Shortint ; negatives Vorzeichen}

INTERFACE

USES LuchsTyp;

PROCEDURE Pascal;

IMPLEMENTATION

{$IFDEF Delphi }
USES   CommWin, CodeSave, PasCode, PasScan, BAsmScan, PasDekl , Ass7000;
{$ELSE}
USES   CommDOS, CodeSave, PasCode, PasScan, BAsmScan, PasDekl , Ass7000;
{$ENDIF}

CONST FreeZeiger =-$5C;  { im Prozessor-RAM }
      LastTask   =-$50;
      maxTask    = 96;

{ ------------------------------------------------------------- }

PROCEDURE Pascal;

PROCEDURE Aktuelle_Parameter(    S      : T_BezStack;
                                 ProcBP : T_BezStack;
                                 Tiefe  : Word); FORWARD;

PROCEDURE Ausdruck(    S        : T_BezStack;
                   VAR ErgebTyp : T_TypBaum;
                       SollTyp  : T_TypBaum;
                       Tiefe    : Word); FORWARD;


FUNCTION TypCharString(VAR Soll, Ist : T_TypBaum):Boolean;

BEGIN
   TypCharString := true;
   IF (Soll = StringTypB) AND (Ist = CharTypB)
             THEN BEGIN CharToStringTop; Ist := StringTypB END
             ELSE TypCharString := false
END;

PROCEDURE Sizeof_Messung(S : T_BezStack);
VAR Help : T_BezStack; Nr   : LongInt;
BEGIN
  Scanner;
  Test_If(Scan.Token, RKauf, ' ( ');
  Scanner;
    IF Finde_Bezeichner(S, Scan.Wort, Help, Nr)
     THEN CASE Help^.Bez OF
              Var_Bez   :  Push_Integer(Help^.VTypZ^.Laenge);
              Typ_Bez   :  Push_Integer(Help^.TTypZ^.Laenge);
              ELSE         Push_Integer(0)
         END
     ELSE Fehler('Bezeichner unbekannt');
  Scanner;
  Test_If(Scan.Token, RKzu,')');
  Scanner
END;

PROCEDURE InitTask_P(S: T_BezStack;
                     VAR BezP: T_BezStack;
                     Tiefe  : Word);
VAR Ergebtyp : T_TypBaum;
BEGIN
  Scanner;
  Test_If(Scan.Token, RKauf, ' ( ');
  Scanner;
  Ausdruck(S, ErgebTyp, LongIntTypB, Tiefe);     (* Stackbedarf *)
  IF TypCharString(IntegerTypB, ErgebTyp)
     THEN
     ELSE Typen_gleich(ErgebTyp, LongIntTypB);
  Test_If(Scan.Token, Komma, ' , ');
  Scanner;
  Push_Integer(BezP^.PVarSpace);      (* Platz fr lokale Variablen *)
  Push_Integer(ProcAdr(BezP^.PrNr));  (* Ref fr lokale Variablen *)
  Ausdruck(S, ErgebTyp, LongIntTypB, Tiefe);     (* Startzeit *)
  IF TypCharString(LongIntTypB, ErgebTyp)
     THEN
     ELSE Typen_gleich(ErgebTyp, LongIntTypB);
  Test_If(Scan.Token, Komma, ' , ');
  Scanner;
  Ausdruck(S, ErgebTyp, LongIntTypB, Tiefe);     (* Intervallzeit *)
  IF TypCharString(LongIntTypB, ErgebTyp)
     THEN
     ELSE Typen_Gleich(ErgebTyp, LongIntTypB);
  Test_If(Scan.Token, RKzu,')');
  Push_Integer(BezP^.PAddr);       (* Startadresse *)
  Codiere_Trap(R_InitTask);
  Scanner
END;

PROCEDURE Funktionsaufruf_P(VAR S, BezP  : T_BezStack;
                               Tiefe  : Word);
VAR VarPlatz : LongInt;
BEGIN                    
  IF BezP^.Name = 'SIZEOF'
     THEN Sizeof_Messung(S)
     ELSE BEGIN
            IF BezP^.FuNr <> Sys_Proc
               THEN BEGIN
                      VarPlatz := BezP^.FTypZ^.Laenge;
                      machlangWort(VarPlatz);
                      GetVarSpace(VarPlatz);
                      Push_VarRegister(BezP^.FRegVars);
                      CodiereWord(Push_VR);
                      CodiereWord(Push_PR);
                   END;
                  IF BezP^.FParam <> BezP
                             THEN Aktuelle_Parameter(S, BezP, Tiefe)
                             ELSE Scanner;
                  LastOpcode_leer;
                  IF BezP^.FuNr = Sys_Proc
                     THEN Codiere_Trap(T_Trap(BezP^.Faddr))
                     ELSE Codiere_JSR(BezP^.Faddr, Tiefe, BezP^.FRegVars)
          END
END;

FUNCTION Finde_Komponente(    Suche  : T_Bezeichner;
                              KnotZ  : T_FeldListe;
                          VAR KTyp   : T_TypBaum;
                          VAR Offset : LongInt): Boolean;
VAR gefunden : Boolean;
BEGIN
  gefunden := false;
  WHILE (KnotZ <> nil) AND not gefunden AND InputRec.C_Ok DO
    BEGIN gefunden := Suche = KnotZ^.Komponente;
          IF gefunden THEN KTyp := KnotZ^.KompTyp
                      ELSE BEGIN Inc(Offset, KnotZ^.KompTyp^.Laenge);
                                 KnotZ := KnotZ^.next
                           END
    END;
  Finde_Komponente := gefunden;
END;

PROCEDURE Var_Verfolgung(    TypK     : T_TypBaum;
                             S        : T_BezStack;
                         VAR ErgebTyp : T_TypBaum;
                             Tiefe    : Word);

  PROCEDURE Komponenten(    TypK     : T_TypBaum;
                            S        : T_BezStack;
                        VAR ErgebTyp : T_TypBaum;
                            Tiefe    : Word);
  VAR KompTyp : T_TypBaum;
      Offset  : LongInt;
  BEGIN
     Scanner; Offset := 0;
     Test_If(Scan.Token, Bezeichner_T,'Komponenten-Bezeichner');
     IF InputRec.C_Ok AND Finde_Komponente(Scan.Wort, TypK^.Feld, KompTyp, Offset)
        THEN BEGIN
                Scanner;
                IF Offset > 0
                   THEN BEGIN CodiereWord(Pull_R1);
                              LastOpcode_leer;
                              KS_CodiereS_long(Offset, 0 );
                              CodiereWord($310C); { Add R0,R1 }
                              CodiereWord(Push_R1);
                        END;
                Var_Verfolgung(KompTyp, S, ErgebTyp, Tiefe)
             END
             ELSE Fehler('Komponente unbekannt')
  END;

  PROCEDURE Referenzierung(    TypK     : T_TypBaum;
                               S        : T_BezStack;
                           VAR ErgebTyp : T_TypBaum;
                               Tiefe    : Word);
  BEGIN
     Scanner;
     CodiereWord(Pull_R1);
     CodiereWord($6112);   { MOV.L @R1,R1 }
     CodiereWord(Push_R1);
     Var_Verfolgung(TypK^.Bezug, S, ErgebTyp, Tiefe)
  END;

  PROCEDURE Indizierung(    TypK     : T_TypBaum;
                            S        : T_BezStack;
                        VAR ErgebTyp : T_TypBaum;
                            Tiefe    : Word);
  VAR IstTyp : T_TypBaum;
      StrInd : Boolean;
      Laenge : LongInt;
  BEGIN
    Scanner;
    StrInd := TypK^.Art = String_Tp;
    IF InputRec.C_Ok THEN Ausdruck(S, IstTyp,nil, Tiefe);
    IF StrInd
       THEN IF IstTyp = IntegerTypB
               THEN
               ELSE Typen_Gleich(IstTyp, ShortIntTypB)
       ELSE Typen_Gleich(IstTyp, TypK^.Index^.Basis);   (* Index muss Subrange sein *)
    IF not StrInd
       THEN IF (TypK^.Index^.Start <> 0)
                THEN BEGIN Push_Integer(TypK^.Index^.Start);
                           Subtrahiere_IntStack
                     END;
    IF StrInd THEN Laenge := 1
              ELSE Laenge := TypK^.Wert^.Laenge;
    IF (Laenge = 2) OR (Laenge = 4) OR (Laenge = 8)
               THEN BEGIN CodiereWord(Pull_R1);
                          CodiereWord($4100);   { SHLL R1 }
                          IF (Laenge = 4) OR (Laenge = 8)
                             THEN CodiereWord($4100); { SHLL R1 }
                          IF Laenge = 8
                             THEN CodiereWord($4100);  { SHLL R1 }
                          CodiereWord(Push_R1);
                    END
               ELSE IF Laenge <> 1
                       THEN BEGIN Push_Integer(TypK^.Wert^.Laenge);     (* Lnge der Feldwerte *)
                                  Codiere_Trap(R_IntMult)
                            END;
    Addiere_IntStack;                  (* Zur Basis addieren  *)
    If  Scan.Token = Komma
        THEN Scan.Token := EKauf
        ELSE BEGIN
                Test_If(Scan.Token, EKzu, ']');
                Scanner
             END;
    IF StrInd THEN ErgebTyp := CharTypB
              ELSE Var_Verfolgung(TypK^.Wert, S, ErgebTyp, Tiefe)
   END;

BEGIN
  CASE TypK^.Art OF
     Array_Tp, String_Tp
                : IF Scan.Token = EKauf
                     THEN Indizierung(TypK, S, ErgebTyp, Tiefe)
                     ELSE ErgebTyp := TypK;
     Record_Tp  : IF Scan.Token = Punkt
                     THEN Komponenten(TypK, S, ErgebTyp, Tiefe)
                     ELSE ErgebTyp := TypK;
     Pointer_Tp : IF Scan.Token = Dach
                     THEN Referenzierung(TypK, S, ErgebTyp, Tiefe)
                     ELSE ErgebTyp := TypK;
     ELSE         ErgebTyp := TypK
     END;
END;

PROCEDURE Ausdruck(    S        : T_BezStack;
                   VAR ErgebTyp : T_TypBaum;
                       SollTyp  : T_TypBaum;
                       Tiefe  : Word);

   PROCEDURE Einfacher_Ausdruck(    S        : T_BezStack;
                                VAR ErgebTyp : T_TypBaum;
                                    Solltyp  : T_TypBaum;
                                    Tiefe  : Word);

      PROCEDURE Term(    S        : T_BezStack;
                     VAR ErgebTyp : T_TypBaum;
                         SollTyp  : T_TypBaum;
                         Tiefe  : Word);

         PROCEDURE Faktor(    S        : T_BezStack;
                          VAR ErgebTyp : T_TypBaum;
                              SollTyp  : T_TypBaum;
                              Tiefe    : Word);

         VAR BezKnot : T_BezStack;
             IstTyp  : T_TypBaum;
             Nr      : LongInt;
             Offset  : LongInt;
             Art     : Typ_Art;
             Wert    : LongInt;
             Stri    : String;
             RDummy  : Double;
BEGIN { Faktor }
  IF InputRec.C_Ok THEN
  CASE Scan.Token OF
       Bezeichner_T : IF Finde_Bezeichner(S, Scan.Wort, BezKnot, Nr)
			 THEN
			 CASE BezKnot^.Bez OF
			 Var_Bez : BEGIN
                                    Scanner;
                                    IF (BezKnot^.VTypZ^.Laenge > 4) OR
                                       (Scan.Token IN [Dach, Punkt, EkAuf ]) OR
                                       (Bezknot^.ProcNr <> Tiefe)
                                       THEN BEGIN
				             IF BezKnot^.Var_Param
				                THEN Push_RefVarAdr(BezKnot^.ProcNr, Tiefe, BezKnot^.Offset)
				                ELSE Push_VarAdr(BezKnot^.ProcNr, Tiefe, BezKnot^.Offset);
				             Var_Verfolgung(BezKnot^.VTypZ,S, ErgebTyp, Tiefe);
				             Push_Variable(ErgebTyp^.Laenge, ErgebTyp=StringTypB)
				            END
                                       ELSE BEGIN Load_Variable(BezKnot^.Offset, BezKnot^.VTypZ^.Laenge, BezKnot^.Var_Param);
                                                  ErgebTyp := BezKnot^.VTypZ
                                            END
                                    END;
			 Func_Bez : BEGIN FunktionsAufruf_P(S, BezKnot, Tiefe);
				     ErgebTyp := BezKnot^.FTypZ;
                                    END;
                         Typ_Bez  : IF BezKnot^.TTypZ^.Art = AufZaehl_Tp
				       THEN BEGIN ErgebTyp := BezKnot^.TTypZ;
                                                  Push_Integer(Nr);
                                                  Scanner
                                            END
                                       ELSE Fehler('Bezeichner nicht erlaubt');
                         Const_Bez: BEGIN IF BezKnot^.CTyp = Real_Tp
                                            THEN Push_Real(BezKnot^.Zahl)
                                            ELSE Push_Integer(BezKnot^.Wert);
                                          AZTnachPTR(BezKnot^.CTyp, ErgebTyp);
                                          Scanner
                                    END;
                         String_Cnst: BEGIN ErgebTyp := StringTypB;
                                        Push_String(BezKnot^.StrP^);
                                        Scanner;
                                      END;
			 ELSE Fehler('Bezeichner unbekannt')
                       END { CASE fr Bezeichner }
                  ELSE Fehler('Bezeichner unbekannt');
      RKauf : BEGIN Scanner;
                    Ausdruck(S, ErgebTyp,SollTyp, Tiefe);
                    Test_If(Scan.Token,RKzu, ')');
                    Scanner
              END;
      EKauf : BEGIN Scanner;
                    Create_Empty_set;
                    IstTyp := leere_MengeTypB;
                    WHILE InputRec.C_Ok AND (Scan.Token <> EKzu) DO
                      BEGIN
                        Ausdruck( S, IstTyp, ShortIntTypB, Tiefe);
			IF (Scan.Token = Komma) OR (Scan.Token = EKzu)
                            THEN BEGIN IF Scan.Token = Komma THEN Scanner;
                                      { Typentest ? }
				    Codiere_Trap(R_SetIncl)
                                 END
                            ELSE IF Scan.Token = Zweipunkte
                                    THEN BEGIN Scanner;
                                               Ausdruck(S, IstTyp, ShortIntTypB, Tiefe);
                                               Codiere_Trap(R_SetInViel);
                                               IF Scan.Token = Komma
                                                  THEN Scanner
                                         END
                      END; { WHILE innerhalb [] }
                      New(ErgebTyp); ErgebTyp^.Laenge := 1;
		      ErgebTyp^.Art := Set_Tp; ErgebTyp^.Element := IstTyp;  (* ??? *)
                      Scanner;
              END;
      Zahl_T : BEGIN ErgebTyp := LongIntTypB;         { ok }
                     LastOpcode_Leer;
                     KS_CodiereS_long(Scan.Zahl, 1);
                     CodiereWord(Push_R1);
		     Scanner
	       END;
      Real_T : BEGIN ErgebTyp := RealTypB;
                     LastOpcode_leer;
                     KS_CodiereS_Real(Scan.Wert, 2);
		     Push_RealRegister;
		     Scanner
	       END;
      Kreuz, HochKomma  :
	       BEGIN Find_Art_Wert( Art, Wert, RDummy, Stri);
		     CASE Art OF
		       Char_TP :BEGIN Push_Integer(Lo(Wert));
				      ErgebTyp := CharTypB
				END;
		       String_Tp: BEGIN ErgebTyp := StringTypB;
					Push_String(Stri)
				  END
		     END;
		     Scanner;
	       END;
	 Not_T: BEGIN Scanner;
		      Faktor(S, ErgebTyp, BooleanTypB, Tiefe);
		      Typen_Gleich(ErgebTyp, BooleanTypB);
		      Codiere_Trap(R_LongNot)
		END;
	 ELSE Fehler('Faktor erwartet')
       END; { CASE }
 END;  { Faktor }

      VAR Ergebrechts : T_TypBaum;
	  LastToken   : T_Token;
      BEGIN (* Term *)
	 IF InputRec.C_Ok THEN Faktor(S, ErgebTyp, SollTyp, Tiefe);
	 WHILE (Scan.Token IN [Mal, Div_T, Durch, Mod_T, And_T]) AND InputRec.C_Ok
	    DO BEGIN LastToken := Scan.Token;
		     IF lastToken <> And_T THEN Mathematisch(ErgebTyp);
		     Scanner;
		     Faktor(S, Ergebrechts, SollTyp, Tiefe);
		     Typen_Gleich(ErgebTyp, ErgebRechts);
		     IF is_Integer(ErgebTyp)
			THEN CASE LastToken OF
			       Mal  : Codiere_Trap(R_IntMult);
			       Div_T: Codiere_Trap(R_IntDiv);
			       Mod_T: Codiere_Trap(R_IntMod);
			       ELSE   Fehler('Operation nicht erlaubt ')
			      END
			ELSE IF ErgebTyp = RealTypB
				THEN CASE LastToken OF
				       Mal  : Codiere_Trap(R_FloatMult);
				       Durch: Codiere_Trap(R_FloatDiv);
				       ELSE   Fehler('Operation nicht erlaubt')
				      END
				ELSE IF (ErgebTyp = BooleanTypB) AND (LastToken = And_T)
					THEN  Codiere_Trap(R_LongAnd)
			ELSE IF (ErgebTyp^.Art = Set_TP) AND (LastToken = Mal)
				THEN Codiere_Trap(R_SetMal)
				ELSE Fehler('Operation fr diesen Typ verboten');
	       END;
      END;   { Term }

   VAR Ergebrechts  : T_TypBaum;
       lastToken    : T_Token;
       MustBe_Mathe,
       istMinus     : Boolean;
   BEGIN { Einfacher_Ausdruck }
     IF (Scan.Token = Plus) OR (Scan.Token = Minus)
	THEN BEGIN istMinus := Scan.Token = Minus;
		   Scanner;
		   Mustbe_Mathe := true;
	     END
	ELSE BEGIN  MustBe_Mathe := false; istMinus := false
	     END;
     Term(S, ErgebTyp, SollTyp, Tiefe);
     IF istMinus
	THEN IF is_Integer(ErgebTyp)
		THEN Neg_IntStack
		ELSE IF ErgebTyp = RealTypB
			THEN Codiere_Trap(R_NegReal)
			ELSE Fehler(' - nicht erlaubt ');
     IF MustBe_Mathe THEN Mathematisch(Ergebtyp);
     IF (ErgebTyp=CharTypB) AND (Scan.Token=Plus) {neu 1.21 }
        THEN BEGIN ChartoStringTop;
                   ErgebTyp := StringTypB
             END;
     WHILE (Scan.Token IN [Plus, Minus, OR_T]) AND InputRec.C_Ok DO
	BEGIN LastToken := Scan.Token;
	      Scanner;
	      Term(S, Ergebrechts, SollTyp, Tiefe);
              IF (Ergebrechts=CharTypB) AND (LastToken=Plus) {neu 1.21 }
                 THEN BEGIN ChartoStringTop;
                            Ergebrechts := StringTypB
                      END;
              Typen_Gleich(ErgebTyp, Ergebrechts);
	      IF is_Integer(ErgebTyp)
		 THEN CASE LastToken OF
			Plus  : Addiere_IntStack;
			Minus : Subtrahiere_IntStack;
			ELSE   Fehler('Operation nicht erlaubt ')
                       END
                 ELSE IF ErgebTyp = RealTypB
                         THEN CASE LastToken OF
                                Plus : Codiere_Trap(R_FloatAdd);
                                Minus: Codiere_Trap(R_FloatSub);
                                ELSE   Fehler('Operation nicht erlaubt')
			       END
                         ELSE IF (ErgebTyp = BooleanTypB) AND (LastToken = OR_T)
                                 THEN  Codiere_Trap(R_LongOr)
                 ELSE IF ErgebTyp^.Art = Set_Tp
                         THEN CASE LastToken OF
                                Plus : Codiere_Trap(R_SetPlus);
                                Minus: Codiere_Trap(R_SetMinus);
                                ELSE   Fehler('Operation nicht erlaubt')
                               END
                 ELSE IF (ErgebTyp = StringTypB) AND (LastToken = Plus)    { neu 1.21 }
                         THEN Codiere_Trap(R_StrConcat)
                         ELSE Fehler('Operation fr diesen Typ verboten');
        END
   END;

VAR Ergebrechts   : T_TypBaum;
    OldToken      : T_Token;
BEGIN { Ausdruck }
   Einfacher_Ausdruck(S, ErgebTyp, SollTyp, Tiefe);
   IF (Scan.Token IN [Kleiner .. In_T]) AND inputRec.C_Ok
      THEN BEGIN
             OldToken := Scan.Token;
             Scanner;
             IF InputRec.C_Ok THEN Einfacher_Ausdruck(S, Ergebrechts,ErgebTyp, Tiefe);
             CASE ErgebRechts^.Art  OF
               Set_Tp : BEGIN IF OldToken = In_T
                                 THEN Typen_Gleich(ErgebTyp, Ergebrechts^.element)
                                 ELSE Typen_Gleich(ErgebTyp, Ergebrechts);
                              CodiereCMPSet(OldToken)
                        END;
	       Real_Tp: BEGIN CodiereCMPReal(OldToken);
                              Typen_Gleich(ErgebTyp, Ergebrechts)
                        END;
               String_Tp : BEGIN CodiereCMPString(OldToken);
                                 Typen_Gleich(ErgebTyp, Ergebrechts)
                           END;
               Integer_Tp, LongInt_Tp, Register_Tp, ShortInt_Tp, Char_Tp,
               Pointer_Tp : BEGIN CodiereCMPInteger(OldToken);
                                  Typen_Gleich(ErgebTyp, Ergebrechts)
                            END;
               ELSE         BEGIN CodiereCMPviel(OldToken, ErgebTyp^.laenge);
                                  Typen_Gleich(ErgebTyp, Ergebrechts)
                            END
             END;
             CodiereWord($0029);   { MOVT R0 }
             CodiereWord(Push_R0);
             ErgebTyp := BooleanTypB
          END;
END;

PROCEDURE Bedingung_P(    S     : T_BezStack;
                      Tiefe  : Word);
{ nach der Bedingung ist das T-Flag true(1) / false(0) }
VAR ErgebTyp : T_TypBaum;
BEGIN
  IF InputRec.C_Ok THEN Ausdruck(S, ErgebTyp, BooleanTypB, Tiefe);
  IF ErgebTyp <> BooleanTypB
     THEN Fehler(' Boolean-Typ erwartet');
  CodiereWord(Pull_R0);
  CodiereWord($8801);    { CMP/EQ #1,R0 }
END;

PROCEDURE StartZuweisung_P(    S     : T_BezStack;
                           Var Ergeb : T_TypBaum;
                           VAR BezP  : T_BezStack;
                           Tiefe  : Word);
VAR Nr       : LongInt;
    RegVar   : Boolean;
BEGIN
  Test_If(Scan.Token, Bezeichner_T,'Bezeichner');
  IF Finde_Bezeichner(S, Scan.Wort, BezP, Nr)
     THEN BEGIN
             abzaehl_Typ(BezP^.VTypZ);
             RegVar := (BezP^.VTypZ^.Laenge = 0);
             IF not RegVar THEN Push_VarAdr(BezP^.ProcNr, Tiefe, BezP^.Offset)
          END
     ELSE Fehler('Bezeichner unbekannt');
  Scanner;
  Test_If(Scan.Token, Zuweisung, ':=');
  Scanner;
  IF InputRec.C_Ok THEN Ausdruck(S, Ergeb, BezP^.VTypZ, Tiefe);
  IF RegVar AND InputRec.C_Ok
            THEN BEGIN CodiereWord(Pull_R1);
                       CodiereWord($6013+$100*BezP^.Offset)
                 END;
  IF InputRec.C_Ok THEN Typen_Gleich(BezP^.VTypZ, Ergeb);
  IF not InputRec.C_Ok OR BezP^.Var_Param
     THEN Fehler('nur lokale Variablen erwuenscht!')
     ELSE IF not RegVar
             THEN Pull_Variable(BezP^.VTypZ^.Laenge, false, false);
  IF InputRec.C_Ok THEN Ergeb := BezP^.VTypZ;        (* ist Zwangslaeufig *)
END;


PROCEDURE Formal_Parameter(VAR S       : T_BezStack;
                               Pr_Kopf : T_BezStack;
                           VAR Sp      : LongInt;
                           Tiefe  : Word);
VAR aktTyp         : T_TypBaum;
    erster, Varp   : Boolean;
    first, Hilf    : T_BezStack;
    VarOffset, Vnr, VPlatz : LongInt;
BEGIN
  Test_If(Scan.Token, RKauf, ' ( ');
  Scanner; Sp := 0;
  REPEAT
    aktTyp := nil;
    IF Scan.Token = Var_T
       THEN BEGIN Varp := True; Scanner END
       ELSE Varp := false;
    First := S; VNr := 0;
    REPEAT
         Test_If(Scan.Token, Bezeichner_T, 'Var-Bezeichner');
         Doppel_Test(S, Scan.Wort, Pr_Kopf);
         Insert_UserTyp(S, Scan.Wort,aktTyp, Var_Bez, Varp);  (* echter Typ spter *)
         inc(VNr);
         Scanner;
         IF Scan.Token = Komma THEN Scanner
    UNTIL (Scan.Token = Doppelpunkt) OR not InputRec.C_Ok;
    Scanner;
    Test_If(Scan.Token, Bezeichner_T, 'Typ-Bezeichner');
    IF InputRec.C_Ok AND not Finde_Typ(S, Scan.Wort, aktTyp)
       THEN Fehler('Typ unbekannt')
       ELSE BEGIN
              IF aktTyp = RegisterTypB THEN Fehler('Register nicht erlaubt ');
              Hilf := S;
              IF VarP THEN VPlatz := 4
                      ELSE VPlatz := aktTyp^.Laenge;
              machLangWort(VPlatz);
              inc(Sp, VNr * VPlatz);
              IF VarP
                 THEN VarOffset := Sp
                 ELSE CASE aktTyp^.Laenge OF
                         1 : VarOffset := Sp-3;
                         2 : VarOffset := Sp-2;
                         ELSE VarOffset := Sp
                      END;
              WHILE InputRec.C_Ok AND (Hilf <> first)  DO
                 BEGIN Hilf^.VTypZ     := aktTyp;  (* zunchst nur Typ eintragen *)
                       Hilf^.ProcNr    := Pr_Kopf^.PrNr;
                       Hilf^.TypDirekt := false;
                       Hilf^.Offset    := -VarOffset;
                       Dec(VarOffset, VPlatz);
                       Hilf := Hilf^.next
                 END;
              Scanner;
               IF Scan.Token = Semikolon
                 THEN Scanner
                 ELSE Test_If(Scan.Token, RKzu, ')');
           END
  UNTIL (Scan.Token = RKzu) OR not InputRec.C_Ok;
  Scanner;
END;



PROCEDURE Aktuelle_Parameter(    S      : T_BezStack;
                                 ProcBP : T_BezStack;
                                 Tiefe  : Word);

   PROCEDURE Vergleiche_Parameter(   S      : T_BezStack;
                                     Hilf,
                                     ProcBP : T_BezStack;
                                     mKomma : Boolean;
                                     Tiefe  : Word);
  VAR Help : T_BezStack;
      Ergebnistyp : T_TypBaum;
      nr          : LongInt;
      Offset      : LongInt;
  BEGIN
    IF InputRec.C_Ok AND (Hilf <> ProcBP) THEN
       BEGIN
           Vergleiche_parameter(S, Hilf^.next, ProcBP, True, Tiefe);
              Scanner;
              IF Hilf^.Var_Param
                 THEN BEGIN IF Finde_Bezeichner(S, Scan.Wort, Help, Nr)
                               THEN BEGIN
                                      IF Help^.Var_Param
                                         THEN Push_RefVarAdr(Help^.ProcNr, Tiefe, Help^.Offset)
                                         ELSE Push_VarAdr(Help^.ProcNr, Tiefe, Help^.Offset);
                                      Scanner;
                                      Var_Verfolgung(Help^.VTypZ, S, ErgebnisTyp, Tiefe);
                                    END
                               ELSE Fehler('Bezeichner unbekannt');
                      END
                 ELSE IF InputRec.C_Ok
                         THEN Ausdruck(S, ErgebnisTyp,hilf^.VTypZ, Tiefe);
	      IF mKomma THEN Test_If(Scan.Token, Komma, ',');
              IF InputRec.C_Ok
                THEN IF not Hilf^.Var_Param
                        THEN IF TypCharString(Hilf^.VTypZ, ErgebnisTyp)
                                THEN (* ok *)
                                ELSE Typen_Gleich(Hilf^.VTypZ, ErgebnisTyp)
                        ELSE Var_Typen_Gleich(Hilf^.VTypZ, ErgebnisTyp);
            END
   END;

BEGIN
  Scanner;
  Test_If(Scan.Token, RKauf, ' ( ');
  Vergleiche_Parameter(S, ProcBP^.PParam, ProcBP, false, Tiefe);
  Test_If(Scan.Token, RKzu,')');
  Scanner
END;


PROCEDURE Pointer_Test(    S      : T_BezStack;
                           ProcBP : T_BezStack;
                           Tiefe  : Word);
VAR Help : T_BezStack;
    Nr   : LongInt;
    ErgebnisTyp : T_TypBaum;
BEGIN
  Scanner;
  Test_If(Scan.Token, RKauf, ' ( ');
  Scanner;
    IF InputRec.C_Ok AND Finde_Bezeichner(S, Scan.Wort, Help, Nr)
     THEN BEGIN
	    IF Help^.Var_Param
               THEN Push_RefVarAdr(Help^.ProcNr, Tiefe, Help^.Offset)
               ELSE Push_VarAdr(Help^.ProcNr, Tiefe, Help^.Offset);
            Scanner;
            Var_Verfolgung(Help^.VTypZ, S, ErgebnisTyp, Tiefe);
            IF ErgebnisTyp^.Art <> Pointer_Tp
               THEN Fehler('Pointer-Typ erwartet');
            IF (ProcBP^.Name = 'NEW') OR (ProcBP^.Name = 'DISPOSE')
               THEN Push_Integer(ErgebnisTyp^.Bezug^.Laenge)
          END
     ELSE Fehler('Bezeichner unbekannt');
  Test_If(Scan.Token, RKzu,')');
  Scanner
END;

PROCEDURE Anweisungsfolge_P(    S     : T_BezStack;
                            VAR GLStack   : T_GLStack;
                            Tiefe  : Word);

  PROCEDURE Anweisung_P(    S     : T_BezStack;
                        VAR GLStack   : T_GLStack;
                            Tiefe  : Word);

    PROCEDURE Whileanweisung_P(    S     : T_BezStack;
                            VAR GLStack   : T_GLStack;
                            Tiefe  : Word);
    VAR WhileStart : LongInt;
        NachWhile  : T_BralInfo;
    BEGIN
      WhileStart := Code.Pc;
      Scanner;
      Bedingung_P(S, Tiefe);
      MachPClang;
      CodiereWord($8906);    { BT + 6 }
      Codiere_Bral(NachWhile);
      Test_if(Scan.Token,Do_T,'DO');
      Scanner;
      IF InputRec.C_Ok THEN Anweisung_P(S, GLStack, Tiefe);
      Codiere_Braback(WhileStart);
      Ersetze_Bral(NachWhile)
    END;

    PROCEDURE Foranweisung_P(    S       : T_BezStack;
			     VAR GLStack : T_GLStack;
                                 Tiefe   : Word);
    VAR VarTyp, Ergebnis   : T_TypBaum;
	BezP     : T_BezStack;
	ForStart : LongInt;
	NachFor  : T_BralInfo;
	Up       : Boolean;
    BEGIN
      Scanner;
      StartZuweisung_P(S, VarTyp, BezP, Tiefe);
      IF Scan.Token = To_T
	 THEN BEGIN Up := True; Scanner END
	 ELSE IF Scan.Token = Downto_T
		 THEN BEGIN Scanner; Up := false END
		 ELSE Fehler('TO/DOWNTO erwartet');
      IF InputRec.C_Ok THEN Ausdruck (S, Ergebnis, nil, Tiefe);
      IF InputRec.C_Ok THEN Typen_Gleich(VarTyp, Ergebnis);
      Test_if(Scan.Token, Do_T, 'DO');
      Scanner;
      IF InputRec.C_OK THEN Load_Var(BezP^.ProcNr,Tiefe, BezP^.Offset, VarTyp^.Laenge);
      ForStart  := Code.Pc;
      CodiereWord($61F2);         { MOV.L @R15,R1 }
      IF UP
         THEN CodiereWord($3103)  { CMP/GE R0,R1 }
         ELSE CodiereWord($3013); { CMP/GE R1,R0 }
      machPClang;
      CodiereWord($8906);   { BT + 6 }
      Codiere_Bral(NachFor);
      IF InputRec.C_OK THEN Anweisung_P(S, GLStack, Tiefe);
      IF InputRec.C_OK
         THEN IF VarTyp^.Laenge = 0
                 THEN IF Up
                         THEN CodiereWord($7001+$100*BezP^.Offset) { ADD #1,Roffset }
                         ELSE CodiereWord($70FF+$100*BezP^.Offset) { ADD #-1,Roffset }
                 ELSE BEGIN
                         Load_Var(BezP^.ProcNr, Tiefe, BezP^.Offset, VarTyp^.Laenge);
                         IF Up THEN CodiereWord($7001)   { ADD #1,R0 }
                               ELSE CodiereWord($70FF);  { Add #-1,R0 }
                         CASE VarTyp^.Laenge OF
                              1 : CodiereWord($2100);    { MOV.B R0,@R1 }
                              2 : CodiereWord($2101);    { MOV.W R0,@R1 }
                              4 : CodiereWord($2102);    { MOV.L R0,@R1 }
                         END
                       END;
      Codiere_Braback(ForStart);
      Ersetze_Bral(NachFor);
      CodiereWord(Pull_R0)  ;
    END;

    PROCEDURE Repeatanweisung_P(    S     : T_BezStack;
                                VAR GLStack   : T_GLStack;
                                    Tiefe  : Word);
    VAR RepeatStart : LongInt;
    BEGIN
      RepeatStart := Code.PC;
      Scanner;
      REPEAT
         IF InputRec.C_Ok THEN Anweisung_P(S, GLStack, Tiefe);
         IF (Scan.Token = Semikolon)
            THEN Scanner
            ELSE IF Scan.Token IN [Punkt .. Label_T, End_T]
                    THEN Fehler('UNTIL erwartet')
      UNTIL (Scan.Token = Until_T) OR not InputRec.C_Ok;
      Scanner;
      IF InputRec.C_Ok THEN Bedingung_P(S, Tiefe);
      machPClang;
      IF  RepeatStart - Code.PC -4 >= -4090
         THEN CodiereWord($8901)  { BT + 1 }
         ELSE CodiereWord($8906); { BT + 6 }
      Codiere_Braback(RepeatStart)
    END;

    PROCEDURE Ifanweisung_P(    S     : T_BezStack;
                            VAR GLStack   : T_GLStack;
                            Tiefe  : Word);
    VAR ZuElse, ZumEnde : T_BralInfo;
    BEGIN
      Scanner;
      Bedingung_P(S, Tiefe);
      MachPClang;
      CodiereWord($8906);    { BT +6 }
      Codiere_Bral(ZuElse);
      Test_if(Scan.Token, Then_T, 'THEN');
      Scanner;
      IF InputRec.C_Ok THEN Anweisung_P(S, GLStack, Tiefe);
      IF (Scan.Token = Else_T) AND InputRec.C_Ok
         THEN BEGIN Codiere_Bral(ZumEnde);
                    Ersetze_Bral(ZuElse);
                    Scanner;
                    Anweisung_P(S, GLStack, Tiefe);
                    Ersetze_Bral(ZumEnde)
              END
         ELSE Ersetze_Bral(ZuElse)
    END;

    PROCEDURE Gotoanweisung_P(    S     : T_BezStack;
                            VAR GLStack   : T_GLStack;
                            Tiefe  : Word);
    VAR aktGo : T_Element;
    BEGIN
       Scanner;
       Test_If(Scan.Token, Zahl_T,'Label-Zahl');
       aktgo.Zahl := Scan.Zahl;
       Codiere_Bral(AktGo.BInfo);
       Push(GLStack.G, aktGo);
       Scanner
    END;

    PROCEDURE Caseanweisung_P(    S       : T_BezStack;
		     	      VAR GLStack : T_GLStack;
                                  Tiefe   : Word);

    PROCEDURE eine_Konst(LinksTyp  : T_TypBaum;
			     Jmp       : LongInt);
    VAR Wert    : LongInt;
        Bereich : Boolean;
    BEGIN
	 Find_Def_Konst(LinksTyp, Wert);
	 Scanner;
         IF Scan.Token = Zweipunkte
            THEN BEGIN
                   Bereich := true;
                   LastOpcode_leer;
                   KS_CodiereS_long(Wert,1);
                   CodiereWord($3013); { CMP/GE R1,R0 }
                   CodiereWord($8B02); { BF +2 }
                   Scanner;
                   Find_Def_Konst( LinksTyp, Wert);
                   LastOpcode_leer;
                   KS_CodiereS_long(Wert,1);
                   CodiereWord($3103); { CMP/GE R0,R1 }
                   Scanner;
                 END
            ELSE BEGIN
                   Bereich := false;
                   IF Scan.Token = Komma
	              THEN BEGIN Scanner;
		                 eine_Konst( LinksTyp, Jmp + 4)
		           END;
                   Lastopcode_Leer;
                   KS_CodiereS_long(Wert,1);
                   CodiereWord($3010);      { CMP/EQ R1,R0 }
                 END;
         IF Bereich
            THEN CodiereWord($8900+Jmp-1)      { BT +Jmp-1 }
            ELSE BEGIN
                   CodiereWord($8900+Jmp);   { BT +Jmp }
                   CodiereNOP; { damit Gruppe 4 Worte lang ist }
                 END;
	 IF Jmp >= 128 THEN Fehler('zu viele CASE-Konstanten')
    END;

    VAR Help : T_BezStack;
	LinksTyp  : T_TypBaum;
	NaechsteAnweisung : T_BralInfo;
	aktGo     : T_Element;
	JmpStack  : T_Stack;
	EinByte   : Boolean;
    BEGIN
      Ersetze_KS_Daten(Mit_Branch);      { damit er nicht dazwischenfunkt ! }
      aktGo.Zahl := 0; Create_ST(JmpStack);
      Scanner;
      Ausdruck (S, LinksTyp, nil, Tiefe);
      IF LinksTyp^.Laenge > 4 THEN Fehler('skalarer Typ erwartet');
      CodiereWord(Pull_R0);
      Test_if(Scan.Token,Of_T,'OF');
      Scanner;
      REPEAT
         machPClang;
	 eine_Konst( LinksTyp, 6);
         Codiere_Bral(NaechsteAnweisung);
	 Test_IF (Scan.Token, Doppelpunkt, ':');
	 Scanner;
         Ersetze_KS_Daten(Mit_Branch);      { damit er nicht dazwischenfunkt ! }
	 IF InputRec.C_Ok THEN Anweisung_P(S, GLStack, Tiefe);
	 Codiere_Bral(aktGo.BInfo);
	 Push(JmpStack, aktGo);
	 Ersetze_Bral(NaechsteAnweisung);
	 IF Scan.Token = Semikolon THEN Scanner
      UNTIL (Scan.Token = End_T) OR (Scan.Token = ELse_T) OR not InputRec.C_Ok;
      IF Scan.Token = Else_T
	 THEN BEGIN Scanner;
	       Anweisung_P(S, GlStack, Tiefe);
	       IF Scan.Token = Semikolon THEN Scanner;
	       Test_If(Scan.Token, End_T,'END');
	      END;
      Setze_idJmp(JmpStack);
      Scanner
    END;

    PROCEDURE Exit_Prozedur(VAR S     : T_BezStack;
                            Tiefe  : Word);
    VAR Help : T_BezStack;
	Nr   : LongInt;
    BEGIN
      Scanner;
      Test_IF(Scan.Token, RKauf, '(');
      Scanner;
      Test_IF(Scan.Token, Bezeichner_T, 'Procedure/Function Bezeichner');
      IF Finde_Bezeichner(S, Scan.Wort, Help, Nr) AND
	 ( (Help^.Bez = Proc_Bez) OR (Help^.Bez = Func_Bez) )
	 THEN BEGIN IF (Help^.Bez = Proc_Bez) AND
		       (Help^.PrNr <> Sys_Proc) AND
		       (Help^.PTyp = Normal_Proc)
		       THEN Codiere_Exit(Help^.PrNr, Tiefe)
		    ELSE IF (Help^.Bez = Func_Bez) AND
			    (Help^.FuNr <> Sys_Proc) AND InputRec.C_Ok
                            THEN Codiere_Exit(Help^.FuNr, Tiefe)
                            ELSE Fehler('bei dieser Prozedur nicht erlaubt')
              END
         ELSE Fehler('Function/Procedure unbekannt');
      Scanner;
      Test_IF(Scan.Token, RKzu, ')');
      Scanner
    END;


    PROCEDURE Inc_Dec_Prozedur(VAR S     : T_BezStack;
                                   Tiefe  : Word;
                                   istInc :Boolean);
    VAR Help : T_BezStack;
	Nr   : LongInt;
    BEGIN
      Scanner;
      Test_IF(Scan.Token, RKauf, '(');
      Scanner;
      Test_IF(Scan.Token, Bezeichner_T, 'Variablen Bezeichner');
      IF Finde_Bezeichner(S, Scan.Wort, Help, Nr) AND
	  (Help^.Bez = Var_Bez)
	 THEN BEGIN
                IF (Help^.VTypZ^.Laenge <= 4) AND (Help^.ProcNr = Tiefe)
		   THEN BEGIN
                           Scanner;
                           Test_IF(Scan.Token, Komma, ',');
                           Scanner;
                           IF Scan.Token = Zahl_T
                              THEN IF IstInc
                                      THEN IF Scan.Zahl < 128
                                              THEN Codiere_Inc(Help^.Offset, Help^.VTypZ^.Laenge, Scan.Zahl)
                                              ELSE Fehler('inc-Konstante > 127')
                                      ELSE IF Scan.Zahl <= 128
                                              THEN Codiere_Inc(Help^.Offset, Help^.VTypZ^.Laenge, -Scan.Zahl)
                                              ELSE Fehler('dec-Konstante < -128')
                              ELSE Fehler(' Konstante erwartet')
                        END
                    ELSE Fehler('INC nicht erlaubt')
              END
         ELSE Fehler('Variable unbekannt');
      Scanner;
      Test_IF(Scan.Token, RKzu,')');
      Scanner;
    END;

    PROCEDURE Prozeduraufruf_P(VAR S,
                                   BezP  : T_BezStack;
                                   Tiefe  : Word);
    BEGIN
      IF BezP^.Name = 'EXIT'
         THEN Exit_Prozedur(S, Tiefe)
         ELSE IF (BezP^.Name = 'INC') OR (BezP^.Name='DEC')
                 THEN Inc_DEC_Prozedur(S,Tiefe, BezP^.Name = 'INC')
         ELSE IF BezP^.PTyp = Normal_Proc
                 THEN
                   BEGIN
                     IF (BezP^.Name = 'NEW')  OR
                        (BezP^.Name = 'DISPOSE')
                        THEN Pointer_Test(S, BezP, Tiefe)
                        ELSE BEGIN
                               IF BezP^.PrNr <> Sys_Proc
                                  THEN BEGIN
                                         Push_VarRegister(BezP^.PRegVars);
                                         CodiereWord(Push_VR);
                                         CodiereWord(Push_PR);
                                       END;
                              IF BezP^.PParam <> BezP
                                THEN Aktuelle_Parameter(S, BezP, Tiefe)
                                ELSE Scanner;
                             END;
                        LastOpcode_leer;
                        IF BezP^.PrNr = Sys_Proc
                           THEN Codiere_Trap(T_Trap(BezP^.PAddr))
                           ELSE Codiere_JSR(BezP^.Paddr, Tiefe, BezP^.PRegVars)
                    END
                 ELSE IF BezP^.PTyp = Irpt_Proc
                         THEN BEGIN CodiereWord(Push_VR);
                                    CodiereWord(Push_PR);
                                    Codiere_JSR(BezP^.Paddr, Tiefe,4);
                                    Scanner
			      END
                         ELSE IF BezP^.PTyp = Par_Proc
                                 THEN InitTask_P(S, BezP, Tiefe)
                                 ELSE Fehler('Prozedur darf nicht aufgerufen werden');
   END;


    PROCEDURE Zuweisung_P(    S     : T_BezStack;
                          VAR BezP  : T_BezStack;
                              Tiefe  : Word);
    VAR linksTyp, ErgebnisTyp : T_TypBaum;
        FunktionsVar          : Boolean;
    BEGIN
      Scanner;
      Funktionsvar := false;
      IF (BezP^.VTypZ^.Laenge > 4) OR
         (Scan.Token <> Zuweisung ) OR
         (BezP^.Procnr <> Tiefe) OR
          BezP^.Var_Param
         THEN BEGIN
                IF BezP^.Bez = Var_Bez
                   THEN BEGIN IF BezP^.Var_Param
                                 THEN Push_RefVarAdr(BezP^.ProcNr, Tiefe, BezP^.Offset)
                                 ELSE Push_VarAdr(BezP^.ProcNr, Tiefe, BezP^.Offset);
		              Var_Verfolgung(BezP^.VTypZ, S, LinksTyp, Tiefe)
                        END
                   ELSE IF BezP^.Bez = Func_Bez
                           THEN BEGIN Push_VarAdr(BezP^.FuNr, Tiefe, 8+4*(BezP^.FRegVars - 4)); { neu }
                                      Var_Verfolgung(BezP^.FTypZ, S, LinksTyp, Tiefe);
                                      Funktionsvar := true
                                END
                           ELSE Fehler ('Typ hier nicht erlaubt ');
                Test_If(Scan.Token, Zuweisung, ':=');
                Scanner;
                IF InputRec.C_Ok
                   THEN BEGIN Ausdruck(S, ErgebnisTyp,LinksTyp, Tiefe);
                             IF TypCharString(LinksTyp, Ergebnistyp)
                                THEN (* alles ok *)
                                ELSE Typen_Gleich(LinksTyp, Ergebnistyp);
                             Pull_Variable(LinksTyp^.Laenge, LinksTyp = StringTypB, FunktionsVar);
                        END
              END
         ELSE BEGIN
                Test_If(Scan.Token, Zuweisung, ':=');
                Scanner;
                IF InputRec.C_Ok THEN Ausdruck(S, ErgebnisTyp,BezP^.VTypZ, Tiefe);
                IF inputrec.C_ok THEN Typen_Gleich(BezP^.VTypZ, Ergebnistyp);
                Store_Variable(BezP^.Offset, BezP^.VTypZ^.Laenge)
              END
   END;



  PROCEDURE Assembler_P(VAR S       : T_BezStack;
                            Tiefe  : Word);

     FUNCTION Finde_akt_ProcTyp(S: T_BezStack; VAR Nr: Word):T_ProcTyp;
     BEGIN
       WHILE (S <> nil) AND (S^.Bez <> Proc_Bez) AND (S^.Bez <> Func_Bez) DO S := S^.next;
       IF S = nil
          THEN { Fehler, darf nicht passieren }
          ELSE IF S^.Bez = Proc_Bez
                  THEN BEGIN Finde_akt_ProcTyp := S^.PTyp;
                             Nr := S^.PrNr
                       END
                  ELSE BEGIN Finde_akt_ProcTyp := Func_Proc;
                             Nr := S^.FuNr
                       END
     END;

PROCEDURE Erzeuge_VarInfo(S: T_BezStack; VAR B : T_Baum);
VAR lokale_ProcNr : Word;
    ProcTyp : T_ProcTyp;
BEGIN
   B := nil;
   ProcTyp := Finde_akt_Proctyp(S, lokale_ProcNr);
   WHILE S <> nil DO
      BEGIN
        IF Length(S^.Name) <= 9
           THEN IF (S^.Bez = Var_Bez)
                   THEN IF (S^.ProcNr = Lokale_ProcNr) OR (S^.ProcNr=0)
		           THEN Labelrein(B, S^.Name,L_Ident_BS, S^.Offset)
                           ELSE
                   ELSE IF (S^.Bez = Func_bez) AND
                           (S^.FuNr = Lokale_ProcNr)
		           THEN Labelrein(B, S^.Name, L_Ident_BS, S^.FVarSpace)
		           ELSE IF (S^.Bez = Const_Bez)
                                   THEN Labelrein(B, S^.Name, L_Ident_BS, S^.Wert);

        S := S^.next
     END
END;


 VAR Baum : T_Baum;
    Ende,list: Boolean;
    Varzeiger: LongInt;
    Insertheap: T_Insertheap;
    AssBezBaum: T_AssBezBaum;
  BEGIN
    Erzeuge_VarInfo(S, Baum );
    CodiereWord($E080);              { MOV #$80,R0 }
    CodiereWord($6002+$100*ExtReg);  { MOV.L @R0,ext_Reg }
    LastOpcode_leer;
    WHILE InputRec.z = ' ' DO Lies;
    IF InputRec.z = #13
       THEN BEGIN Lies;
		  Ende:=False; List:=False;
                  Insertheap:=NIL; Varzeiger:= 0;
		  asmSH7000(Pascalass,Ende,List,Baum,AssBezBaum, Insertheap,
                          VarZeiger);
		  IF InputRec.C_ok
		     THEN  Insertersetzen_Dispose(Baum,Insertheap,InputRec.Meldung[5],InputRec.C_Ok);
	    END
       ELSE Fehler('neue Zeile erwartet');
    Scan.Token := Semikolon; InputRec.Z := ' ';
  END;


  VAR BezP   : T_BezStack;
      Nr : LongInt;
  BEGIN   (* Anweisung *)
    Test_KS_Voll;
    IF InputRec.C_Ok THEN CASE Scan.Token OF
      While_T      : Whileanweisung_P(S, GLStack, Tiefe);
      For_T        : Foranweisung_P(S, GLStack, Tiefe);
      Repeat_T     : Repeatanweisung_P(S,GLStack, Tiefe);
      If_T         : Ifanweisung_P(S,GLStack, Tiefe);
      Goto_T       : Gotoanweisung_P(S, GLStack, Tiefe);
      Case_T       : Caseanweisung_P(S,GLStack, Tiefe);
      Assembler_T  : Assembler_P(S,Tiefe);
      Bezeichner_T : IF Finde_Bezeichner(S, Scan.Wort, BezP, Nr)
                        THEN IF BezP^.Bez = Proc_Bez
                              THEN Prozeduraufruf_P(S, BezP, Tiefe)
                              ELSE Zuweisung_P(S, BezP, Tiefe)
                        ELSE Fehler('Bezeichner unbekannt');
      Begin_T      : Anweisungsfolge_P(S, GLStack, Tiefe);
      Zahl_T       : BEGIN Define_Label(GLStack.L);
                           Anweisung_P(S, GLStack, Tiefe)
		     END;
      TrOn_T       : BEGIN CodiereWord($0001); Scanner END;
      TrOff_T      : BEGIN CodiereWord($0011); Scanner END;
      Then_T, To_T, Downto_T, Do_T, Real_T, Else_T
                   : Fehler('Anweisung erwartet');
      ELSE           (* leere Anweisung *)
    END;
  END;

BEGIN (* Anweisungsfolge_P *)
  Scanner;
  REPEAT
    Anweisung_P(S, GLStack, Tiefe);
    IF Scan.Token = Semikolon
       THEN Scanner
       ELSE IF Scan.Token <> End_T
               THEN Fehler('END erwartet')
  UNTIL (Scan.Token = End_T) OR not InputRec.C_Ok ;
  Scanner
END;

PROCEDURE Block_P(VAR S,
                      Kopf    : T_BezStack;
                      Tiefe   : Word);

  PROCEDURE Funktion_P(VAR S,
                           BlKopf : T_BezStack;
                           Tiefe  : Word);
  VAR F, LokBez  : T_BezStack;
      VarLaenge : LongInt;
      Ist_Forward, altFWD : Boolean;
      Adr        : T_AdrInfo;
      BraInfo    : T_BralInfo;
  BEGIN
     Scanner; Ist_Forward := false;
     Test_if(Scan.Token, Bezeichner_T, 'Bezeichner');
     IF In_ForwardListe(FWL, Scan.Wort, F)
        THEN ist_Forward := true
        ELSE Doppel_Test(S, Scan.Wort, BlKopf);
     Insert_UserTyp(S, Scan.Wort, nil, Func_Bez,false);
     IF ist_Forward
        THEN S^.FuNr := F^.FuNr
        ELSE S^.FuNr := Tiefe;
     S^.FParSpace := 0; S^.FRegVars := 4;
     S^.FAddr     := Code.PC;
     LokBez := S;
     Scanner;
     IF (Scan.Token <> Doppelpunkt) AND InputRec.C_Ok
        THEN Formal_Parameter(LokBez, LokBez, Lokbez^.FParSpace, Tiefe);
     S^.FVarSpace := S^.FParSpace;
     S^.FParam    := LokBez;
     S^.TypDirekt := True;
     IF Ist_Forward THEN Vergleiche_Param(S^.FParam, S, F^.FParam, F);
     Test_if(Scan.Token, Doppelpunkt, ':');
     Scanner;
     Test_If(Scan.Token, Bezeichner_T, 'Typ-Bezeichner');
     IF InputRec.C_Ok AND not Finde_Typ(S, Scan.Wort, S^.FTypZ)
        THEN Fehler('Typ-Bezeichner unbekannt');
     Scanner;
     IF ist_Forward THEN
       IF S^.FTypZ <> F^.FTypZ THEN Fehler('Funktions-Typ nicht identisch');
     Test_if(Scan.Token,Semikolon,';');
     Scanner;
     IF InputRec.C_Ok
        THEN IF Scan.Token = Forward_T
          THEN BEGIN
                  S^.FFWDekl := true;
                  Codiere_Bral(BraInfo);
                  Insert_ForwardListe(FWL,S^.Name, S, BraInfo);
                  Scanner;
                  Test_if(Scan.Token, Semikolon,';');
                  Scanner
               END
          ELSE BEGIN
                  IF Ist_Forward  { alter FW-Aufruf }
                    THEN Del_aus_ForwardListe(FWL, S^.Name);
                  S^.FFWDekl := false;
                  machLangWort(S^.FVarSpace);  { ??? }
                  Block_P(LokBez, S, Tiefe);
                  Test_if(Scan.Token,Semikolon,';');
                  Codiere_RTS;
                  Ersetze_KS_Daten(Ohne_Branch);
                  Scanner
               END
  END;

  PROCEDURE Interrupt_Prozedur_P(VAR S, BlKopf : T_BezStack;
                                     Tiefe  : Word);

      PROCEDURE StoreIrqReg;
      VAR i: Word;
      BEGIN
        CodiereWord($4F02); (* sts.l mach,@-R15 *)
        CodiereWord($4F12); (* sts.l macl,@-R15 *)
        CodiereWord($4F22); (* sts.l pr,@-R15 *)
        FOR i:=0 TO 14 DO Codiereword($2F06+$10*i); (* mov.l ri,@-R15 *)
      END;

      PROCEDURE RestoreIrqReg;
      VAR i: Word;
      BEGIN
        FOR i:=14 DOWNTO 0 DO Codiereword($60F6+$100*i); (* mov.l @r15+, ri *)
        Codiereword($4F26); (* lds.l @R15+,pr *)
        Codiereword($4F16); (* lds.l @R15+,macl *)
        Codiereword($4F06); (* lds.l @R15+,mach *)
      END;

  VAR LokBez  : T_BezStack;
      Ir_Nr   : Integer;
  BEGIN
     Scanner;
     Test_if(Scan.Token,Procedure_T,'PROCEDURE');
     Scanner;
     Test_if(Scan.Token,Bezeichner_T,'Bezeichner');
     IF InputRec.C_Ok THEN Doppel_Test(S, Scan.Wort, BlKopf);
     Insert_UserTyp(S, Scan.Wort, nil, Proc_Bez, true);
     S^.PrNr      := Tiefe;
     S^.PVarSpace := 0;    S^.PParSpace := 0; S^.PRegVars := 4;
     S^.PAddr     := Code.PC;
     S^.TypDirekt := True;
     S^.PTyp      := Irpt_Proc;
     S^.PFWDekl   := false;
     LokBez := S;
     S^.PParam := S;           (* keine Parameter erlaubt *)
     Scanner;
     IF Scan.Token = RKauf
        THEN Fehler('keine Parameter bei Interrupt-Prozeduren');
     Test_IF (Scan.Token, Zahl_T, 'Zahl erwartet');
     Ir_Nr := Scan.Zahl;
     Scanner;    (* ; *)
     Scanner;    (* vorscannen *)
     IF (Ir_Nr < 0) OR (Ir_Nr > $BF)  {???}
        THEN Fehler (' Interrupt nicht im Bereich');
     CodiereWord($E000 + Ir_Nr);          { MOV #IrNr,R0 }
     CodiereWord($CB40);                  { OR #$40,R0 }
     CodiereWord($4008);                  { SHLL2 R0 }
     CodiereWord($0122);                  { STC  VBR,R1 }
     CodiereWord($310C);                  { ADD  R0,R1 }
     LastOpcode_leer;
     KS_CodiereS_long(S^.PAddr + 16, 0);  { MOV.L PAddr,R0 }
     CodiereWord($000B);                  { RTS }
     CodiereWord($2102);                  { MOV.L R0,@R1 }
    { Test_IF(Scan.Token, Begin_T, 'BEGIN');  }
     StoreIRQReg;
     IF InputRec.C_Ok THEN
            Block_P(LokBez, S, Tiefe);
     Test_if(Scan.Token,Semikolon,';');
     RestoreIRQReg;
     CodiereWord($002B);                  { RTE }
     CodiereNOP;
     Ersetze_KS_Daten(Ohne_Branch);
     Scanner
  END;


  PROCEDURE Parallel_Prozedur_P(VAR S,
                                    BlKopf : T_BezStack;
                                    Tiefe  : Word);
  VAR LokBez  : T_BezStack;
  BEGIN
     Scanner;
     Test_if(Scan.Token, Bezeichner_T, 'Bezeichner');
     Doppel_Test(S, Scan.Wort, BlKopf);
     IF InputRec.C_Ok THEN Insert_UserTyp(S, Scan.Wort, nil, Proc_Bez, false);
     S^.PrNr      := Tiefe;
     S^.PVarSpace := 0;   S^.PParSpace := 0; S^.PRegVars := 4;
     S^.PAddr     := Code.PC;
     S^.PTyp      := Par_Proc;
     S^.TypDirekt := true;
     S^.PFWDekl   := false;
     LokBez := S;
     S^.PParam := S;           (* keine Parameter erlaubt *)
     Scanner;
     IF Scan.Token <> Semikolon
        THEN Fehler('keine Parameter bei Parallel-Prozeduren');
     Scanner;
     IF InputRec.C_Ok THEN Block_P(LokBez, S, Tiefe);
     Test_if(Scan.Token,Semikolon,';');
     Codiere_Trap(R_TermTask);
     Ersetze_KS_Daten(Ohne_Branch);
     Scanner
  END;

  PROCEDURE Prozedur_P(VAR S,
                           BlKopf : T_BezStack;
                           Tiefe  : Word);
  VAR F, LokBez       : T_BezStack;
      VarLaenge       : LongInt;
      ist_Forward     : Boolean;
      Bral_Info       : T_BralInfo;
  BEGIN
     LastOpcode_leer;
     Scanner; ist_Forward := false;
     Test_if(Scan.Token, Bezeichner_T, 'Bezeichner');
     IF In_ForwardListe(FWL, Scan.Wort, F)
        THEN ist_Forward := true
	ELSE Doppel_Test(S, Scan.Wort, BlKopf);
     Insert_UserTyp(S, Scan.Wort, nil, Proc_Bez, false);
     IF ist_Forward
        THEN S^.PrNr := F^.PrNr
        ELSE S^.PrNr := Tiefe;
     S^.PParSpace := 0; S^.PRegVars := 4;
     S^.PAddr     := Code.PC;
     S^.TypDirekt := True;
     S^.PTyp      := normal_Proc;
     LokBez := S;
     Scanner;
     IF Scan.Token <> Semikolon
        THEN Formal_Parameter(LokBez, LokBez, LokBez^.PParSpace, Tiefe);
     S^.PVarSpace := S^.PParSpace;
     Test_if(Scan.Token, Semikolon, ';');
     S^.PParam := LokBez;
     IF ist_Forward THEN Vergleiche_Param(S^.PParam, S, F^.PParam, F);
     Scanner;
     IF InputRec.C_Ok
        THEN IF Scan.Token = Forward_T
                THEN BEGIN
                       S^.PFWDekl := true;
                       Codiere_Bral( BraL_Info);
                       Insert_ForwardListe(FWL,S^.Name, S, Bral_Info);
                       Scanner;
                       Test_if(Scan.Token, Semikolon,';');
                       Scanner
                     END
                ELSE BEGIN
                       IF ist_Forward   {altFWD}
                         THEN Del_aus_ForwardListe(FWL, S^.Name);
                       S^.PFWDekl := false;
                       Block_P(LokBez, S, Tiefe);
                       Test_if(Scan.Token,Semikolon,';');
                       Codiere_RTS;
                       Ersetze_KS_Daten(Ohne_Branch);
                       Scanner
                     END
  END;

  PROCEDURE Deklaration_P(VAR S,
                              Kopf    : T_BezStack;
                          VAR no_Jump : Boolean;
                          VAR BlockStart: T_BralInfo;
			  VAR GLStack : T_GLStack;
                              Tiefe   : Word);
  BEGIN
    IF (Scan.Token IN [Procedure_T .. Function_T]) AND InputRec.C_Ok
       THEN BEGIN
              IF no_Jump
                 THEN BEGIN
                        no_Jump := False;
                        Codiere_Bral(BlockStart);
                      END
            END;
    IF InputRec.C_Ok THEN CASE Scan.Token OF
      Function_T   : Funktion_P(S, Kopf, Tiefe+1);
      Procedure_T  : Prozedur_P(S, Kopf, Tiefe+1);
      Task_T       : Parallel_Prozedur_P(S, Kopf, Tiefe+1);
      Interrupt_T  : Interrupt_Prozedur_P(S, Kopf, Tiefe+1);
      Const_T      : Konstanten_dekl_P(S, Kopf);
      Type_T       : Typ_dekl_P(S, Kopf);
      Var_T        : Var_dekl_P(S, Kopf);
      Label_T      : Label_dekl_P( GLStack.L);
      ELSE           Test_if(Scan.Token, Begin_T, 'BEGIN')
    END
  END;

VAR No_Jump    : Boolean;
    BlockStart : T_BralInfo;
    GLStack    : T_GLStack;
BEGIN (* Block_P *)
  No_Jump := True;
  Create_St(GLStack.G); Create_St(GLStack.L);
  IF Kopf^.PTyp <> Irpt_Proc
     THEN BEGIN
           WHILE (Scan.Token <> Begin_T) AND InputRec.C_Ok DO
                Deklaration_P(S, Kopf, No_Jump, BlockStart, GLStack, Tiefe);
           IF no_Jump THEN {nix } ELSE ersetze_Bral(BlockStart);
           Put_lokVarAdr(Kopf^.PrNr, Kopf^.PParSpace);
          END
     ELSE IF Scan.Token = Var_T
             THEN BEGIN
                    Var_Dekl_P(S,Kopf);  { erlaubt ab 1.11.97 }
                    LastOpcode_Leer;
                    CodiereCodeWord($60F3+$100*VarReg);    { MOV R15,VarReg (lokaler Datenzeiger) }
                  END;
  machLangWort(Kopf^.PVarSpace);
  GetVarSpace(Kopf^.PVarSpace - Kopf^.PParSpace); { lokale Variablen }
  IF InputRec.C_Ok THEN Anweisungsfolge_P(S,GLStack, Tiefe);
  FreeVarSpace(Kopf^.PVarSpace);
  Trage_label_ein(GLStack.L, GLStack.G);
  IF InputRec.C_OK THEN Dispose_all_User(S, Kopf^.PParam)
END;

PROCEDURE Programm_P(VAR S     : T_BezStack);
VAR HeapAdr: T_AdrInfo;
    lokBez : T_BezStack;
    StartPC : LongInt;
BEGIN
   Scanner;
   Test_if(Scan.Token,Bezeichner_T,'Bezeichner');
   IF InputRec.C_Ok THEN Insert_Usertyp(S, Scan.Wort, nil, Proc_Bez, false);
   Scanner;
   Test_if(Scan.Token, Semikolon, ';');
   Scanner;
   IF Scan.Token = Zahl_T                { andere Startadresse }
     THEN BEGIN Code.PC := Scan.Zahl;
                Code.Startadresse := Scan.Zahl;
                SysInfo.CodeStart := Scan.Zahl;
                Scanner;
                Test_if(Scan.Token, Semikolon, ';');
                Scanner
          END;
   S^.PrNr      := 0;      { 0. Prozedur = HP }
   S^.PVarSpace := 0;   S^.PParSpace := 0; S^.PRegVars := 4;
   S^.PAddr     := Code.PC;
   S^.TypDirekt := true;
   S^.PParam    := S;       (* keine Parameter frs Hauptprogramm *)
   S^.PTyp      := Main_Proc;   (* wg. Varspace und Aufruf *)
   LokBez := S;
   KS_CodiereS_Long(FreeZeiger,1);   { MOV #FreePtr,R1 }
   CodiereCodeWord($C32B);              { .moval Freespace,R0 }
   LiesAdresse(HeapAdr);
   StartPC := Code.PC;
   CodiereLong(0);
   CodiereCodeWord($0222);              { STC   VBR,R2 }
   CodiereCodeWord($E318);              { MOV   #$18,R3}
   CodiereCodeWord($4318);              { SHLL8 R3 }
   CodiereCodeWord($323C);              { ADD   R3,R2 }
   CodiereCodeWord($3026);              { CMP/HI R2,R0 }
   CodiereCodeWord($8900);              { BT +0 }
   CodiereCodeWord($6023);              { MOV   R2, R0 }
   CodiereCodeWord($2102);              { MOV.L R0,@R1 }
   CodiereCodeWord($E100);              { MOV   #0,R1 }
   CodiereCodeWord($2012);              { MOV.L R1,@R0 }
   KS_CodiereS_Long(LastTask,0);
   KS_CodiereS_Long(maxTask,1);
   CodiereCodeWord($2010);              { MOV.B R1,@R0 }
   CodiereCodeWord($7F80);              { ADD   #-128,R15  }
   { CodiereCodeWord($60F3+$100*ExtReg);   MOV   R15,ExtReg  Fehler Uebergabe}
     IF InputRec.C_Ok THEN Block_P(LokBez ,S, 0);
   Test_if(Scan.Token,Punkt,'.');
   LastOpcode_leer;
   CodiereCodeWord($C300);              { TRAPA #0 }
   Ersetze_Ks_Daten(Ohne_Branch);
   machPClang;
   Ersetzelong(Code.PC-StartPC-4, HeapAdr)
END;

VAR UserBez : T_BezStack;
BEGIN
   UserBez := nil;
   Create_StdBez(StdBez);
   Create_StdTyp(UserBez);
   Create_StdProzeduren(UserBez);
   FWL := nil;
   OpenInput(WorkFile.TName,'PASCAL');
   IF Ioresult = 0
      THEN BEGIN
             CCreate(SysInfo.CodeStart);
             Lies;
             Scanner;
             Test_if(Scan.Token, Program_T, 'PROGRAM');
             IF InputRec.C_Ok THEN Programm_P(UserBez);
             IF FWL <> nil THEN Fehler('Forward-Prozedur fehlt');
             IF InputRec.C_Ok THEN
                BEGIN
                   CloseInput;
		   CClose;
                   Speichern(WorkFile);
                   Str(Code.BlockNr*(MaxB+1)+Code.Position,InputRec.Meldung[2]);
                   InputRec.Meldung[2] := InputRec.Meldung[2]+' Bytes Code erzeugt';
                   InputRec.Meldung[5] := '0 Fehler   Codedatei erzeugt';
                   InputRec.OkMeldung:=Workfile.CName+' '+InputRec.Meldung[2];
                END
                  ELSE BEGIN WorkFile.TFehler := InputRec.Last.ZNr;
                           CloseInput
                     END;
             IF InputRec.Include AND not InputRec.C_Ok THEN close(InputRec.Incl)
           END
      ELSE Fehler(' Textdatei nicht gefunden');
    Dispose_StdBez(StdBez);
    Dispose_all_User(UserBez, nil);
END;

END.
