(* 1.5.91: endlich als aufrufbare Unit hergestellt *)
(* 8.10.95 HJ: Problem Codeunit: BRA spaeter als erstes Wort klappt nicht *)
(* 4. 3.96: Variable PC entfernt, wird ber Code.PC abgearbeitet *)
(* 13.3.96: HJ: .Bral und .Bsrl eingefhrt *)

UNIT  ASS7000;

INTERFACE

USES Luchstyp,BasmScan;

PROCEDURE Assemble;

PROCEDURE AsmSH7000(Assaufruf: T_Assaufruf;
		  VAR Ende,List: Boolean;
                  VAR Baum: T_Baum;
                  VAR AssBezBaum: T_AssBezBaum;
                  VAR Insertheap: T_Insertheap;
                  VAR VarZeiger: LongInt);

IMPLEMENTATION
{$IFDEF Delphi }
USES  Codesave, CommWin;
{$ELSE }
USES  CodeSave, CommDOS;
{$ENDIF }

TYPE  T_ChrSet = Set OF Char;
      T_LastMN =(Op_Delbra,Op_ZielR0,Op_LDC,OP_Normal);

VAR   Listfile: Text;

PROCEDURE Erzeuge(VAR AssBezBaum: T_AssBezBaum; Assaufruf: T_Assaufruf);
BEGIN
  AssBezBaum:=NIL;
  AssBezRein(AssBezBaum,'MOV'   ,6,0,0,3,T_ADD);
  AssBezRein(AssBezBaum,'RTS'   ,0,0,0,$B,T_RTS);
  AssBezRein(AssBezBaum,'MOV.B' ,0,0,0,0,T_MOV);
  AssBezRein(AssBezBaum,'MOV.W' ,0,0,0,1,T_MOV);
  AssBezRein(AssBezBaum,'MOV.L' ,0,0,0,2,T_MOV);
  AssBezRein(AssBezBaum,'JMP'    ,4,0,2,$B,T_JMP);
  AssBezRein(AssBezBaum,'JSR'    ,4,0,0,$B,T_JMP);
  AssBezRein(AssBezBaum,'BT'     ,8,9,0,0,T_BT);
  AssBezRein(AssBezBaum,'BF'     ,8,$B,0,0,T_BT);
  AssBezRein(AssBezBaum,'MOVA'   ,$C,7,0,0,T_MOVA);
  AssBezRein(AssBezBaum,'BRA'    ,$A,0,0,0,T_BRA);
  AssBezRein(AssBezBaum,'BSR'    ,$B,0,0,0,T_Bsr);
  AssBezRein(AssBezBaum,'CLRT'  ,0,0,0,8,T_NOP);
  AssBezRein(AssBezBaum,'SETT'  ,0,0,1,8,T_NOP);
  AssBezRein(AssBezBaum,'CLRMAC',0,0,2,8,T_NOP);
  AssBezRein(AssBezBaum,'NOP'   ,0,0,0,9,T_NOP);
  AssBezRein(AssBezBaum,'DIV0U' ,0,0,1,9,T_NOP);
  AssBezRein(AssBezBaum,'SLEEP' ,0,0,1,$B,T_NOP);
  AssBezRein(AssBezBaum,'RTE'   ,0,0,2,$B,T_RTS);
  AssBezRein(AssBezBaum,'MOVT'  ,0,0,2,9,T_SHLL);
  AssBezRein(AssBezBaum,'SHAL'  ,4,0,2,0,T_SHLL);
  AssBezRein(AssBezBaum,'SHLL'  ,4,0,0,0,T_SHLL);
  AssBezRein(AssBezBaum,'SHAR'  ,4,0,2,1,T_SHLL);
  AssBezRein(AssBezBaum,'SHLL2' ,4,0,0,8,T_SHLL);
  AssBezRein(AssBezBaum,'SHLL8' ,4,0,1,8,T_SHLL);
  AssBezRein(AssBezBaum,'SHLL16' ,4,0,2,8,T_SHLL);
  AssBezRein(AssBezBaum,'SHLR'   ,4,0,0,1,T_SHLL);
  AssBezRein(AssBezBaum,'SHLR2'  ,4,0,0,9,T_SHLL);
  AssBezRein(AssBezBaum,'SHLR8'  ,4,0,1,9,T_SHLL);
  AssBezRein(AssBezBaum,'SHLR16' ,4,0,2,9,T_SHLL);
  AssBezRein(AssBezBaum,'ROTL'   ,4,0,0,4,T_SHLL);
  AssBezRein(AssBezBaum,'ROTR'   ,4,0,0,5,T_SHLL);
  AssBezRein(AssBezBaum,'ROTCL'  ,4,0,2,4,T_SHLL);
  AssBezRein(AssBezBaum,'ROTCR'  ,4,0,2,5,T_SHLL);
  AssBezRein(AssBezBaum,'CMP/PL' ,4,0,1,5,T_SHLL);
  AssBezRein(AssBezBaum,'CMP/PZ' ,4,0,1,1,T_SHLL);
  AssBezRein(AssBezBaum,'ADDC'   ,3,0,0,$E,T_ADDC);
  AssBezRein(AssBezBaum,'ADDV'   ,3,0,0,$F,T_ADDC);
  AssBezRein(AssBezBaum,'CMP/GE' ,3,0,0,3,T_ADDC);
  AssBezRein(AssBezBaum,'CMP/GT' ,3,0,0,7,T_ADDC);
  AssBezRein(AssBezBaum,'EXTS.B' ,6,0,0,$E,T_ADDC);
  AssBezRein(AssBezBaum,'EXTS.W' ,6,0,0,$F,T_ADDC);
  AssBezRein(AssBezBaum,'EXTU.B' ,6,0,0,$C,T_ADDC);
  AssBezRein(AssBezBaum,'EXTU.W' ,6,0,0,$D,T_ADDC);
  AssBezRein(AssBezBaum,'CMP/HI' ,3,0,0,6,T_ADDC);
  AssBezRein(AssBezBaum,'CMP/HS' ,3,0,0,2,T_ADDC);
  AssBezRein(AssBezBaum,'CMP/STR',2,0,0,$C,T_ADDC);
  AssBezRein(AssBezBaum,'DIV0S'  ,2,0,0,7,T_ADDC);
  AssBezRein(AssBezBaum,'DIV1'   ,3,0,0,4,T_ADDC);
  AssBezRein(AssBezBaum,'MULS.W' ,2,0,0,$F,T_ADDC);
  AssBezRein(AssBezBaum,'MULS'   ,2,0,0,$F,T_ADDC);
  AssBezRein(AssBezBaum,'MULU.W' ,2,0,0,$E,T_ADDC);
  AssBezRein(AssBezBaum,'MULU'   ,2,0,0,$E,T_ADDC);
  AssBezRein(AssBezBaum,'NEG'    ,6,0,0,$B,T_ADDC);
  AssBezRein(AssBezBaum,'NEGC'   ,6,0,0,$A,T_ADDC);
  AssBezRein(AssBezBaum,'NOT'    ,6,0,0,7,T_ADDC);
  AssBezRein(AssBezBaum,'SUB'    ,3,0,0,8,T_ADDC);
  AssBezRein(AssBezBaum,'SUBC'   ,3,0,0,$A,T_ADDC);
  AssBezRein(AssBezBaum,'SUBV'   ,3,0,0,$B,T_ADDC);
  AssBezRein(AssBezBaum,'SWAP.B' ,6,0,0,8,T_ADDC);
  AssBezRein(AssBezBaum,'SWAP.W' ,6,0,0,9,T_ADDC);
  AssBezRein(AssBezBaum,'XTRCT'  ,2,0,0,$D,T_ADDC);
  AssBezRein(AssBezBaum,'TAS.B'  ,4,0,1,$B,T_JMP);
  AssBezRein(AssBezBaum,'TRAPA'  ,$C,3,0,0,T_TRAPA);
  AssBezRein(AssBezBaum,'XOR'    ,2,0,0,$A,T_OR);
  AssBezRein(AssBezBaum,'OR'     ,2,0,0,$B,T_OR);
  AssBezRein(AssBezBaum,'CMP/EQ' ,3,0,0,0,T_CMPEQ);
  AssBezRein(AssBezBaum,'AND'    ,2,0,0,9,T_AND);
  AssBezRein(AssBezBaum,'ADD'    ,3,0,0,$C,T_ADD);
  AssBezRein(AssBezBaum,'AND.B'  ,$C,$D,0,0,T_ANDB);
  AssBezRein(AssBezBaum,'OR.B'   ,$C,$F,0,0,T_ANDB);
  AssBezRein(AssBezBaum,'TST.B'  ,$C,$C,0,0,T_ANDB);
  AssBezRein(AssBezBaum,'TST'    ,$2,0,0,8,T_OR);
  AssBezRein(AssBezBaum,'XOR.B'  ,$C,$E,0,0,T_ANDB);
  AssBezRein(AssBezBaum,'MAC.L'  ,0,0,0,$F,T_MAC);
  AssBezRein(AssBezBaum,'LDS'    ,4,0,0,$A,T_LDS);
  AssBezRein(AssBezBaum,'LDS.L'  ,4,0,0,6,T_LDSL);
  AssBezRein(AssBezBaum,'LDC'    ,4,0,0,$E,T_LDC);
  AssBezRein(AssBezBaum,'LDC.L'  ,4,0,0,$7,T_LDCL);
  AssBezRein(AssBezBaum,'STS'    ,0,0,0,$A,T_STS);
  AssBezRein(AssBezBaum,'STS.L'  ,4,0,0,2,T_STSL);
  AssBezRein(AssBezBaum,'STC'    ,0,0,0,2,T_STC);
  AssBezRein(AssBezBaum,'STC.L'  ,4,0,0,3,T_STCL);
  AssBezRein(AssBezBaum,'MAC'    ,4,0,0,$F,T_MAC);
  AssBezRein(AssBezBaum,'MAC.W'  ,4,0,0,$F,T_MAC);
  (*------- es folgen Pseudo-Opcodes ----------*)
  AssBezRein(AssBezBaum,'.EQU'   ,0,0,0,0,T_EQU);
  AssBezRein(AssBezBaum,'.END'    ,0,0,0,0,T_END);
  AssBezRein(AssBezBaum,'.ORG'    ,0,0,0,0,T_Org);
  AssBezRein(AssBezBaum,'.LIST'   ,0,0,0,0,T_List);
  AssBezRein(AssBezBaum,'.LISTF'  ,0,0,0,0,T_ListF);
  AssBezRein(AssBezBaum,'.NOLIST' ,0,0,0,0,T_NoList);
  AssBezRein(AssBezBaum,'.ASC'    ,0,0,0,0,T_Asc);
  AssBezRein(AssBezBaum,'.ASCZ'   ,0,0,0,0,T_AscZ);
  AssBezRein(AssBezBaum,'.BYTE'   ,0,0,0,0,T_DB);
  AssBezRein(AssBezBaum,'.WORD'   ,0,0,0,0,T_DW);
  AssBezRein(AssBezBaum,'.LONG'   ,0,0,0,0,T_DL);
  AssBezRein(AssBezBaum,'.DIST'   ,0,0,0,0,T_Distance);
  AssBezRein(AssBezBaum,'.REAL'   ,0,0,0,0,T_DR);
  AssBezRein(AssBezBaum,'.TRON'   ,0,0,0,1,T_NOP);
  AssBezRein(AssBezBaum,'.TROFF'  ,0,0,1,1,T_NOP);
  AssBezRein(AssBezBaum,'.STR'    ,0,0,0,0,T_Str);
  AssBezRein(AssBezBaum,'.ALIGN'  ,0,0,0,0,T_Align);
  AssBezRein(AssBezBaum,'.DS'     ,0,0,0,0,T_DS);
  AssBezRein(AssBezBaum,'.PAGE'   ,0,0,0,0,T_Page);
  AssBezRein(AssBezBaum,'.IF'     ,0,0,0,0,T_If);
  AssBezRein(AssBezBaum,'.ELSE'   ,0,0,0,0,T_Else);
  AssBezRein(AssBezBaum,'.ENDIF'  ,0,0,0,0,T_Endif);
  AssBezRein(AssBezBaum,'.VS'     ,0,0,0,0,T_VS);
  AssBezRein(AssBezBaum,'.VARD'   ,0,0,0,0,T_Vard);
  AssBezRein(AssBezBaum,'.INCL'   ,0,0,0,0,T_Incl);
  AssBezRein(AssBezBaum,'.BKPT'   ,0,0,0,0,T_bkpt);

  (* Long-Branch-Befehle als Pseudo-Befehle *)

  AssBezRein(AssBezBaum,'.BRAL'   ,$C,$3,$2,$9,T_BRAL);
  AssBezRein(AssBezBaum,'.BSRL'   ,$C,$3,$2,$A,T_BSRL);
  AssBezRein(AssBezBaum,'.MOVAL'  ,$C,$3,$2,$B,T_MOVAL);
  IF Assaufruf IN [BASICASS,PascalAss]
     THEN AssBezRein(AssBezBaum,'ENDASS' ,0,0,0,0,T_Endass);

  (*$IFDEF CPU7600 *) (* ------ Spezialbefehle ------ *)
  AssBezRein(AssBezBaum,'BT/S'   ,8,$D,0,0,T_BT);
  AssBezRein(AssBezBaum,'BF/S'   ,8,$F,0,0,T_BT);
  AssBezRein(AssBezBaum,'DT'     ,4,0,2,4,T_SHLL);
  AssBezRein(AssBezBaum,'BSRF'   ,0,0,0,3,T_SHLL);
  AssBezRein(AssBezBaum,'DMULU.L',3,0,0,5,T_ADDC);
  AssBezRein(AssBezBaum,'MUL.L'  ,0,0,0,7,T_ADDC);
  AssBezRein(AssBezBaum,'DMULS.L',3,0,0,$D,T_ADDC);
  AssBezRein(AssBezBaum,'BRAF'   ,0,0,2,3,T_SHLL);
  (*$ENDIF *)
END;

PROCEDURE vernichte(VAR AssBezBaum: T_AssBezBaum);
BEGIN
  IF AssBezBaum <> NIL
     THEN BEGIN vernichte(AssBezBaum^.links);
                vernichte(AssBezBaum^.rechts);
                Dispose(AssBezBaum)
          END;
END;

PROCEDURE AsmSH7000(Assaufruf: T_Assaufruf;
		  VAR Ende,List: Boolean;
                  VAR Baum: T_Baum;
                  VAR AssBezBaum: T_AssBezBaum;
                  VAR Insertheap: T_Insertheap;
                  VAR VarZeiger: LongInt);

CONST S_Imm=False; D_Imm=True;

VAR Rechenzeichen,Insertfehler:Boolean;
    EndAss,Ist_Befehl,LabelNotFound,IfSperre,IfAktiv: Boolean;
    Lablwert,Wert,ZeilenPC,Zeiger:Longint;
    Zeilenlaenge: Word;
    HexString,Zeile: Str131;
    Symbol: T_BasicSymbol;
    Insertlabel,Labl,Befehl:T_Ident;
    IncFName,Op1,Op2,Kommentar: Str80;
    Zeichen: Char;
    Typ: OP_Typ;
    Prebyte: Byte;
    Opcode: T_Opcode;
    MnTyp : T_Mn;
    Nibbles: T_Nibbles;
    Act_MN,Last_MN: T_LastMN;


PROCEDURE help(b:Byte);
BEGIN
  write(ord(zeichen),'Help ',b);readln;write('weiter gehts..');
END;

procedure shownibbles;
begin
   writeln(nibbles.n1:3,nibbles.n2:3,nibbles.n3:3,nibbles.n4:3);readln;
end;

PROCEDURE DeleteLabel(VAR BAum: T_Baum);
BEGIN
  IF Baum <> nil
     THEN BEGIN
            IF Baum^.links <> nil THEN DeleteLabel(Baum^.links);
            IF Baum^.rechts <> nil THEN DeleteLabel(Baum^.rechts);
            Dispose(Baum); Baum := nil
          END
END;


FUNCTION L_vorhanden(Baum: T_Baum; L_Name: T_Ident;
                     VAR L_Symbol: T_BasicSymbol; VAR L_Wert: LongInt): Boolean;
var aktiv: boolean;
BEGIN
  aktiv:=True;
  while aktiv do
    begin if baum=nil
             then begin aktiv:=False; l_vorhanden:=false end
             else if baum^.b_name=L_Name
                     THEN BEGIN L_Wert:=Baum^.B_Wert; L_Symbol:=Baum^.B_Symbol;
                                L_vorhanden:=True; aktiv:=False
                          END
                     ELSE IF Baum^.B_Name > L_Name
                             THEN Baum:=Baum^.links
                             ELSE Baum:=Baum^.rechts
    end
END;

PROCEDURE Ausgabe(s: Str131);
BEGIN
  IF List THEN writeln(listfile,s);
END;

PROCEDURE Zeigezeile;
VAR Zeile:Str131;
BEGIN
  Zeile:=HexString+'                        '; Zeile[0]:=#27;
  Zeile:=Zeile+Labl+'           ';          Zeile[0]:=#38;
  Zeile:=Zeile+Befehl+'       ';            Zeile[0]:=#45;
  IF Op1 <> '' THEN Zeile:=Zeile+OP1;
  IF Op2 <> '' THEN Zeile:=Zeile+','+OP2;
  WHILE Length(Zeile)<56 DO Zeile:=Zeile+' ';
  Zeile:=Zeile+Kommentar;
  Ausgabe(Zeile)
END;

PROCEDURE Fehlerausgabe(f: Str80);
BEGIN Fehler('Assembler-Fehler: '+f);
END;

PROCEDURE Insertrein(VAR Insertheap:T_Insertheap;
                     Name: T_Ident; PC: LongInt; Typ: Op_Typ);
BEGIN
  IF Rechenzeichen
     THEN Fehlerausgabe('Rechenausdruck mit unbekanntem Label '+Name)
     ELSE Insertheaprein(Insertheap,Name,PC,Typ)
END;

FUNCTION Basic_Or_Pascal: Boolean;
VAR BoP: Boolean;
BEGIN BoP:=AssAufruf <> Ass;
      IF BoP THEN Fehlerausgabe('Pseudo-Opcode '+Befehl+' innerhalb Basic nicht erlaubt');
      Basic_Or_Pascal := BoP;
END;

FUNCTION Pascalaufruf: Boolean;
VAR BoP: Boolean;
BEGIN BoP:=AssAufruf = Pascalass;
      IF BoP THEN Fehlerausgabe('Pseudo-Opcode '+Befehl+' innerhalb Pascal nicht erlaubt');
      Pascalaufruf := BoP;
END;

 PROCEDURE Lieszeichen;

  PROCEDURE liesZ;
  BEGIN
    Lies;
    Zeichen:=InputRec.z;
    IF Zeichen=#0 THEN BEGIN Ende:=True; zeichen:=#13 END;
  END;

 BEGIN
   LiesZ; IF Zeichen=#10 THEN LiesZ
 END;

PROCEDURE LiesUpcaseZeichen;
BEGIN
  LiesZeichen; Zeichen:=Upcase(Zeichen)
END;

PROCEDURE LiesNoSpace;
BEGIN WHILE Zeichen=' ' DO LiesZeichen END;

PROCEDURE LiesUpcaseNoSpace;
BEGIN
   WHILE (NOT Ende) AND (Zeichen <= ' ')  DO
    begin LiesZeichen;
{
          if not InputRec.C_ok then write(Ord(Zeichen):4);
}
    end;
   Zeichen:=Upcase(Zeichen)
END;

PROCEDURE Lies_Kommentar;
BEGIN
  WHILE Zeichen <> #13 DO
    BEGIN Kommentar:=Kommentar+Zeichen; Lieszeichen END;
END;

PROCEDURE Lies_Uppercase(VAR S: Str80; ChrSet: T_ChrSet);
BEGIN
  S:=Upcase(Zeichen);
  Lieszeichen;
  WHILE NOT (Zeichen IN ChrSet) DO
    BEGIN S:=S + Upcase(Zeichen); Lieszeichen END
END;

PROCEDURE Lies_Uppercase_Kl(VAR S: Str80;ChrSet: T_ChrSet);
BEGIN
  S:=Upcase(Zeichen);
  Lieszeichen;
  WHILE NOT (Zeichen IN ChrSet) DO
    BEGIN IF Zeichen='(' THEN ChrSet:=ChrSet-[','];
          IF Zeichen=')' THEN ChrSet:=ChrSet+[','];
          S:=S + Upcase(Zeichen); Lieszeichen
    END
END;

PROCEDURE Lies_Operand(VAR Op: Str80; ScanOp: Str80; VAR Wert: LongInt);
VAR lbl: T_Ident;
VAR Scanptr,MaxScanptr: Byte;
    Scanaktiv: Boolean;

 PROCEDURE LiesOpZ;
 BEGIN
  IF Scanaktiv
     THEN BEGIN Zeichen:=ScanOp[Scanptr]; Inc(Scanptr) END
     ELSE Lieszeichen
 END;

 PROCEDURE LiesUpcaseZ;
 BEGIN LiesOpZ; Zeichen:=Upcase(Zeichen) END;

 PROCEDURE LiesNoSp;
 BEGIN WHILE Zeichen=' ' DO LiesOpZ END;

 PROCEDURE TestLabelNotFound(L: T_Ident);
 BEGIN
  IF LabelNotFound THEN Fehlerausgabe('unbekanntes Label '+L+' im Rechenausdruck');
 END;

   PROCEDURE Rechenausdruck(VAR Op: Str80; VAR Wert: LongInt);
   VAR Altzeichen: Char;
       Altwert: LongInt;

     PROCEDURE Produkt(VAR Op: Str80; VAR Wert: LongInt);
     VAR Altzeichen: Char;
         Altwert: LongInt;

         PROCEDURE Faktor(VAR Op: Str80; VAR Wert: LongInt);

            PROCEDURE Lies_Hex(VAR Op:Str80; VAR Wert: LongInt);
            BEGIN
              Wert:=0;
              Op:=Op+Upcase(Zeichen);
              LiesUpcaseZ;
              WHILE    ((Zeichen>='0') AND (Zeichen<='9'))
                    OR ((Zeichen>='A') AND (Zeichen<='F'))
                DO BEGIN Op:=Op+Zeichen; Wert:=Wert*16;
                         IF (Zeichen >= '0') AND (Zeichen<='9')
                            THEN Wert:=Wert + Ord(Zeichen) - 48
                            ELSE Wert:=Wert + Ord(Zeichen) - 55;
                         LiesUpcaseZ
                   END
            END;

            PROCEDURE Lies_Bin(VAR Op:Str80; VAR Wert: LongInt);
            BEGIN
              Wert:=0;
              Op:=Op+'%';
              LiesOpz;
              WHILE (Zeichen='0') OR (Zeichen='1')
                DO BEGIN Op:=Op+Zeichen; Wert:=Wert shl 1;
                         IF Zeichen = '1' THEN Inc(Wert);
                         LiesOpZ
                   END
            END;

            PROCEDURE Lies_Dez(VAR Op:Str80; VAR Wert: LongInt);
            BEGIN
              Wert:=0;
              WHILE    ((Zeichen>='0') AND (Zeichen<='9'))
                DO BEGIN Op:=Op+Zeichen;
                         Wert:=Wert * 10 + Ord(Zeichen) - 48;
                         LiesOpZ
                   END
            END;

            PROCEDURE Lies_Char(VAR Op:Str80; VAR Wert: LongInt);
            BEGIN
              LiesOpZ; Op:=Op + #39 + Zeichen;
              Wert:=Ord(Zeichen);
              LiesOpZ;
              IF Zeichen = #39 THEN BEGIN Op:=Op+#39; LiesOpZ END
            END;

            PROCEDURE Lies_Label(VAR Op:Str80; LbL:T_Ident; VAR Wert: LongInt);
            VAR d_Symbol: T_BasicSymbol;
            BEGIN
              Zeichen:=UpCase(Zeichen);
              (*
              IF Zeichen='<' THEN BEGIN Op:=Op+'<'; Liesupcasez END;
              *)
              IF (Zeichen>='@') AND (Zeichen<='Z')
              THEN BEGIN
                      WHILE    ((Zeichen>='0') AND (Zeichen<='9'))
                            OR ((Zeichen>='@') AND (Zeichen <= 'Z'))
                            OR (Zeichen='_')
                         DO BEGIN
                               Lbl:=Lbl+Zeichen; Op:=Op+Zeichen;
                               LiesUpcasez
                            END;
                      IF (Assaufruf=Basicass) AND (Zeichen IN ['%','$',':'])
                         THEN BEGIN
                               IF Length(lbl) < 9 THEN Lbl:=Lbl+Zeichen
                                                  ELSE Lbl[9]:=Zeichen;
                               Op:=Op+Zeichen;
                               LiesUpcasez
                              END;
                      LabelNotFound:=NOT L_vorhanden(Baum,Lbl,d_Symbol,Wert)
                   END
              ELSE Fehlerausgabe('Operand <'+op+'> nicht erlaubt');
              Insertlabel:=Lbl
            END;

         BEGIN
           LiesNoSp;
           lbl:='';
           IF Ende
              THEN Fehlerausgabe('Rechenausdruck oder Operand fehlerhaft')
              ELSE BEGIN IF      Zeichen = '$' THEN Lies_Hex(Op,Wert)
                         ELSE IF Zeichen = '%' THEN Lies_Bin(Op,Wert)
                         ELSE IF Zeichen = #39 THEN Lies_Char(Op,Wert)
                         ELSE IF (Zeichen>='0')  AND (Zeichen <= '9')
                                               THEN Lies_Dez(Op,Wert)
                         ELSE IF (Upcase(Zeichen)='H') THEN
                                 BEGIN Op:=Op+'H'; LiesOpZ;
                                       IF Zeichen =chr($27) (* Hochkomma *)
                                          THEN Lies_Hex(Op,Wert)
                                          ELSE Lies_Label(Op,'H',Wert)
                                 END
                         ELSE IF (Upcase(Zeichen)='B') THEN
                                 BEGIN Op:=Op+'B'; LiesOpZ;
                                       IF Zeichen =chr($27) (* Hochkomma *)
                                          THEN Lies_Bin(Op,Wert)
                                          ELSE Lies_Label(Op,'B',Wert)
                                 END
                         ELSE Lies_Label(Op,'',Wert)
                   END
         END;

     BEGIN
       Faktor(Op,Wert);
       WHILE (Zeichen = '*') OR (Zeichen = '/')
         DO BEGIN TestLabelNotFound(OP);
                  Rechenzeichen:=True;
                  Op:=Op+Zeichen; Altzeichen:=Zeichen; Altwert:=Wert;
                  LiesOpZ;
                  Faktor(Op,Wert);
                  IF Altzeichen='/'
                     THEN IF Wert=0
                             THEN Fehlerausgabe('Division durch 0 verboten')
                             ELSE Wert:=Altwert DIV Wert
                     ELSE Wert:=Altwert*Wert
            END
     END;

   BEGIN (* Rechenausdruck *)
     IF Zeichen='-' THEN Wert:=0 ELSE Produkt(Op,Wert);
     WHILE (Zeichen = '+') OR (Zeichen = '-')
       DO BEGIN TestLabelNotFound(OP);
                Rechenzeichen:=True;
                Op:=Op+Zeichen; Altzeichen:=Zeichen; Altwert:=Wert;
                LiesOpZ;
                Produkt(Op,Wert);
                IF Altzeichen = '-' THEN Wert:=-Wert;
                Wert:=Altwert+Wert;
          END
   END;


BEGIN    (* Liesoperand *)
  Scanaktiv:=(ScanOp[0]>#0);
  IF Scanaktiv THEN
     BEGIN ScanPtr:=2; Zeichen:=ScanOp[1]; ScanOp:=ScanOp+#13 END;
  Rechenzeichen:=False;
  LiesNoSp;
  IF Zeichen=','
     THEN Wert:=0
     ELSE IF Zeichen='*'
             THEN BEGIN Op:=Op+'*'; Wert:=ZeilenPC; Lieszeichen END
             ELSE IF (Zeichen = #13) OR Ende
                     THEN Fehlerausgabe('Operand fehlt')
                     ELSE BEGIN Rechenausdruck(Op,Wert);
                                If Labelnotfound OR (Wert shr 8 <> 0)
                                   THEN Typ:=ext ELSE Typ:=Dir
                          END
END;

PROCEDURE Codierebyte(B: Word);
BEGIN
 IF NOT IfSperre
    THEN BEGIN IF List
                  THEN IF LabelNotFound
                          THEN Hexstring:=Hexstring+'xx'
                          ELSE HexString:=HexString+Hexbyte(Lo(b));
               CodiereCodeByte(Lo(b));
         END
END;


PROCEDURE CodiereWord(W: word);
BEGIN
(*
  writeln('PC=',HexLong(Code.PC),' Bef=',befehl,' ',Op1,',',Op2,
           ' Blocknr=',code.blocknr,' Pos=',code.Position,
           ' Code=',Hexword(w));
*)
  Codierebyte(hi(W));
  Codierebyte(lo(W))
END;

PROCEDURE CodiereLong(W:Longint);
BEGIN CodiereWord(Wert SHR 16); CodiereWord(Wert AND $FFFF); END;

PROCEDURE Zwischenausgabe;
BEGIN
  IF List THEN IF Length(Hexstring) >= 26
                  THEN BEGIN Ausgabe(Hexstring);
                             HexString:=HexLong(Code.PC)+': '
                       END
END;

PROCEDURE AssDB;
BEGIN
  Lies_Operand(Op1,'',Wert);
  IF LabelNotFound THEN Insertrein(Insertheap,Insertlabel,Code.PC,Byte_t);
  Codierebyte(Wert);
  WHILE Zeichen=',' DO
        BEGIN Op1:=Op1+Zeichen;
              Zwischenausgabe;
              Lieszeichen;
              LabelNotFound:=False;
              Lies_Operand(Op1,'',Wert);
              IF LabelNotFound
                 THEN Insertrein(Insertheap,Insertlabel,Code.PC,Byte_t);
              CodiereByte(Wert);
        END
END;

PROCEDURE AssDW;
BEGIN
   Lies_Operand(Op1,'',Wert);
   IF LabelNotFound
      THEN Insertrein(Insertheap,Insertlabel,Code.PC,Word_t);
   CodiereWord(Wert);
   WHILE Zeichen=',' DO
     BEGIN Op1:=Op1+zeichen;
           Zwischenausgabe;
           Lieszeichen;
           LabelNotFound:=False;
           Lies_Operand(Op1,'',Wert);
           IF LabelNotFound
              THEN Insertrein(Insertheap,Insertlabel,Code.PC,Word_t);
           CodiereWord(Wert);
     END
END;

PROCEDURE AssDL;
BEGIN
  IF (Code.PC AND 3) <> 0
     THEN Fehlerausgabe('Adresslage falsch. ALIGN 4 benutzen')
     ELSE BEGIN
            Lies_Operand(Op1,'',Wert);
            IF LabelNotFound
               THEN Insertrein(Insertheap,Insertlabel,Code.PC,Long_t);
            CodiereLong(Wert);
            WHILE Zeichen=',' DO
             BEGIN Op1:=Op1+zeichen;
                   Zwischenausgabe;
                   Lieszeichen;
                   LabelNotFound:=False;
                   Lies_Operand(Op1,'',Wert);
                   IF LabelNotFound
                      THEN Insertrein(Insertheap,Insertlabel,Code.PC,Long_t);
                   CodiereLong(Wert);
             END
           END
END;

PROCEDURE AssDistance;
BEGIN
  IF (Code.PC AND 3) <> 0
     THEN Fehlerausgabe('Adresslage falsch. <.ALIGN4> benutzen')
     ELSE BEGIN
            Lies_Operand(Op1,'',Wert);
            IF LabelNotFound
               THEN Insertrein(Insertheap,Insertlabel,Code.PC,Distance_t);
            CodiereLong(Wert-Code.PC);
            WHILE Zeichen=',' DO
             BEGIN Op1:=Op1+zeichen;
                   Zwischenausgabe;
                   Lieszeichen;
                   LabelNotFound:=False;
                   Lies_Operand(Op1,'',Wert);
                   IF LabelNotFound
                      THEN Insertrein(Insertheap,Insertlabel,Code.PC,Distance_t);
                   CodiereLong(Wert-Code.PC);
             END
           END
END;


PROCEDURE AssDR;
TYPE T_CockReal=ARRAY[0..7] OF Byte;
     T_reell=RECORD
             CASE Boolean OF
               true: (intel_R: Double);
               false:(Cock_R : T_Cockreal);
             END;
VAR Reell: T_Reell;
    Reellstring: Str80;
    Reellwert: Double;
    i: Integer;
BEGIN
  Reellstring:='';
  IF (Code.PC AND 3) <> 0
     THEN Fehlerausgabe('Adresslage falsch. ALIGN 4 benutzen')
     ELSE BEGIN
            LiesNospace;
            WHILE Zeichen IN ['0'..'9','E','e','.','+','-'] DO
              BEGIN Reellstring:=Reellstring+Zeichen;
                    Op1:=Op1+Zeichen; Lieszeichen
              END;
            VAL(Reellstring,Reell.Intel_R,i);
            IF i <> 0 THEN Fehlerausgabe('Realzahl <'+Reellstring+'> falsch');
            FOR i:=7 DOWNTO 0 DO CodiereByte(Reell.Cock_R[i]);
          END
END;

PROCEDURE AssASC;
BEGIN
  LiesNoSpace;
  IF Zeichen <> #39
     THEN Fehlerausgabe('Hochkomma erwartet')
     ELSE BEGIN Op1:=#39;
                Lieszeichen;
                WHILE (Zeichen <> #39) AND (Zeichen <> #13) DO
                      BEGIN Zwischenausgabe;
                            Codierebyte(Ord(Zeichen));
                            Op1:=Op1+Zeichen;
                            Lieszeichen;
                      END;
                IF Zeichen =#13 THEN Fehlerausgabe('Hochkomma fehlt')
                                ELSE BEGIN Lieszeichen; Op1:=Op1+#39 END
          END
END;

PROCEDURE AssStr;
VAR Feld: ARRAY[0..79] OF Byte;
    Laenge,i: Integer;
BEGIN
  LiesNoSpace;
  IF Zeichen <> #39
     THEN Fehlerausgabe('Hochkomma erwartet')
     ELSE BEGIN Op1:=#39; Lieszeichen; Laenge:=0;
                WHILE (Zeichen <> #39) AND (Zeichen <> #13) DO
                      BEGIN Inc(Laenge);
                            Feld[Laenge]:=ord(Zeichen);
                            Op1:=Op1+Zeichen;
                            Lieszeichen;
                      END;
                IF Zeichen =#13
                   THEN Fehlerausgabe('Hochkomma fehlt')
                   ELSE BEGIN Lieszeichen; Op1:=Op1+#39;
                              Feld[0]:=Laenge;
                              i:=0;
                              WHILE i<=Laenge DO
                                    BEGIN Zwischenausgabe;
                                          Codierebyte(Feld[i]); Inc(i)
                                    END
                        END
          END
END;

PROCEDURE AssVarD;
BEGIN
 IF NOT Pascalaufruf
    THEN BEGIN
          Labelnotfound:=False;
          Lies_Operand(Op1,'',VarZeiger);
          IF LabelNotFound THEN Fehlerausgabe('unbekanntes Label <'+Op1+'>');
          Lablwert:=Varzeiger;
          Hexstring:=HexString+'         '+HexLong(Varzeiger)
         END
END;

PROCEDURE AssVS;
BEGIN
 IF NOT Pascalaufruf
  THEN IF Labl=''
          THEN Fehlerausgabe('Label erwartet')
          ELSE BEGIN
                LablWert:=Varzeiger;
                Lies_operand(Op1,'',Wert);
                IF LabelNotFound THEN Fehlerausgabe('unbekanntes Label <'+Op1+'>');
                Hexstring:=HexString+'         '+HexLong(Varzeiger);
                Varzeiger:=Varzeiger+Wert;
              END
END;

PROCEDURE AssDS;
BEGIN
  Lies_Operand(Op1,'',Wert);
  IF LabelNotFound THEN Fehlerausgabe('unbekanntes Label <'+Op1+'>');
  WHILE Wert <> 0 DO BEGIN codierebyte($FF); dec(wert) END
END;

PROCEDURE Asspage;
BEGIN
  IF List THEN write(listfile,#12)
END;

PROCEDURE AssAlign;
BEGIN
  IF Odd(Code.Pc) THEN Codierebyte($FF);
  LiesUpCaseNoSpace; Op1:=Zeichen;
  IF (Zeichen='4') AND (Code.PC AND 2 = 2) THEN CodiereWord($0009);  (* NOP *)
  IF Zeichen IN ['2','4']
     THEN Lieszeichen
     ELSE Fehlerausgabe ('ALIGN 2 oder ALIGN 4 erwartet');
END;

PROCEDURE AssEqu;
BEGIN
  IF Labl=''
   THEN Fehlerausgabe('Labelname fehlt')
   ELSE BEGIN
          LabelNotFound:=False;
          Lies_Operand(Op1,'',LablWert);
          IF LabelNotFound
            THEN Fehlerausgabe('unbekanntes Label <'+Op1+'>');
          Hexstring:=HexString+HexLong(LablWert)
        END
END;

PROCEDURE AssIf;
BEGIN
  IF NOT Basic_Or_Pascal
     THEN BEGIN
           Lies_Operand(Op1,'',Wert);
           IF Typ IN [dir,ext]
              THEN If Ifaktiv THEN Fehlerausgabe('keine IF-Schachtelung erlaubt')
              ELSE BEGIN IfAktiv:=True; IfSperre:=Wert=0 END
              ELSE Fehlerausgabe('unbrauchbarer Operand <'+Op1+'>')
          END
END;

PROCEDURE AssELSE;
BEGIN
  IF NOT Basic_Or_Pascal
     THEN If Ifaktiv THEN IfSperre:=NOT Ifsperre
                     ELSE Fehlerausgabe('<.ELSE> ohne <.IF>');
END;

PROCEDURE AssENDIF;
BEGIN
  IF NOT Basic_Or_Pascal
     THEN If Ifaktiv THEN BEGIN IfSperre:=False; IfAktiv:=False END
                     ELSE Fehlerausgabe('<.ENDIF> ohne <.IF>')
END;

PROCEDURE AssOrg;
VAR orgPC: LongInt;
BEGIN
  IF NOT Basic_Or_Pascal
     THEN BEGIN Lies_Operand(Op1,'',orgPC); Code.PC:=orgpc;
                Code.Startadresse := orgPC;
          END
END;

PROCEDURE AssInclude;
BEGIN
  IF NOT Basic_Or_Pascal
     THEN IF InputRec.Include
             THEN Fehlerausgabe('geschachteltes INCL verboten')
             ELSE BEGIN
                    LiesNoSpace;
                    IF Zeichen =#13
                       THEN Fehlerausgabe ('INCL-Name fehlt')
                       ELSE BEGIN Lies_Uppercase(Op1,[#0..' ',';',',']);
                                  IncFName:=Op1;
                                  Assign(InputRec.Incl,IncFName);
                                  Reset(InputRec.Incl);
                                  InputRec.Include:=Ioresult=0;
                                  IF NOT InputRec.Include
                                    THEN Fehlerausgabe('Includefile '+IncFName+' nicht gefunden')
                                    ELSE BEGIN InputRec.Include:=True;
                                               InputRec.Last.INr:=1
                                         END
                            END
                  END
END;


(*
PROCEDURE TypBkpt;
BEGIN
  LiesNoSpace;
  IF Zeichen='#'
     THEN TypImm($4B,S_Imm)
     ELSE Fehlerausgabe('# erwartet')
END;
*)

PROCEDURE CodiereNibbles;
VAR w:Word;
BEGIN
  w:=Nibbles.N1 shl 12 + (Nibbles.N2 and $F) shl 8
               + (Nibbles.N3 AND $F) shl 4 + (Nibbles.N4 and $F);
  CodiereWord(w);
END;

PROCEDURE AssImm;
VAR Opok: Boolean;
BEGIN
   Lieszeichen;
   Lies_Operand(Op1,'',Wert);
   IF Labelnotfound
      THEN Insertrein(Insertheap,Insertlabel,Code.PC+1,imm_t);
   Nibbles.N3:=(Wert AND $00F0) shr 4;
   Nibbles.N4:=Wert AND $000F;
   (*
   IF (Pos('OR',Befehl) > 0) OR (Pos('AND',Befehl) > 0)
      THEN Opok:=(Wert>=0) AND (Wert<=255)
      ELSE Opok:=(Wert>=-128) AND (Wert<=127);
   IF NOT Opok THEN Fehlerausgabe('Konstante '+Op1+' verboten')
   *)
END;

PROCEDURE Test_Zugriff_auf_R0(Register: Byte);
VAR ok: Boolean;
BEGIN
  IF Last_MN = OP_ZielR0
     THEN IF Register=0
             THEN Fehlerausgabe('Zugriff auf R0 hier verboten')
END;

FUNCTION OpIstRn(Op: Str80; VAR Rn: Byte):Boolean;
VAR ok: Boolean;
BEGIN
 CASE OP[0] OF
   #2: BEGIN ok:=((Op[1]='R') AND (Op[2] IN ['0'..'9']));
             Rn:=Ord(Op[2])-$30;
             Test_Zugriff_auf_R0(Rn)
       END;
   #3: BEGIN ok:=((Op[1]='R') AND (Op[2]='1') AND (Op[3] IN ['0'..'5']));
             Rn:=Ord(Op[3])-$30+10
       END;
   ELSE ok:=False
 END;
 OpIstRn:=ok;
END;

FUNCTION OpIstRnPlus(Op: Str80; VAR Rn: Byte):Boolean;
BEGIN
 OpIstRnplus:=(Op[1]='@') AND (Op[Length(Op)]='+')
                          AND OpIstRn(Copy(Op,2,Length(op)-2),Rn)
END;

FUNCTION OpIstIndRn(Op: Str80; VAR Rn: Byte):Boolean;
BEGIN
 OpIstIndRn:=(Op[1]='@') AND OpIstRn(Copy(Op,2,Length(op)-1),Rn)
END;

FUNCTION OpIstMinusRn(Op: Str80; VAR Rn: Byte):Boolean;
BEGIN
 OpIstMinusRn:=(Op[1]='@') AND (Op[2]='-')
                          AND OpIstRn(Copy(Op,3,Length(op)-2),Rn)
END;

FUNCTION OpIstR0Rn(Op: Str80; VAR Rn: Byte):Boolean;
BEGIN
 OpIstR0Rn:=(Copy(Op,1,5)='@(R0,')
            AND (Op[Length(Op)]=')')
            AND OpIstRn(Copy(Op,6,Length(op)-6),Rn)
END;

FUNCTION OpIstDisGBR(Op: Str80):Boolean;
VAR ok: Boolean;
    Displ,Dummy: Str80;
    Typ: Op_Typ;
    Wert: LongInt;
    LastZ: Char;
BEGIN
 Dummy:='';
 IF Befehl[5]='B' THEN Typ:=Dis8_t
                  ELSE IF Befehl[5]='W' THEN Typ:=Dis9_T ELSE Typ:=Dis10_T;
 ok:=(OP[1]='@') AND (Op[2]='(') AND (Copy(Op,Length(op)-4,5)=',GBR)');
 IF ok THEN BEGIN Displ:=Copy(Op,3,Length(op)-7);
                  LastZ:=Zeichen; Lies_Operand(Dummy,Displ,Wert); Zeichen:=LastZ;
                  IF Labelnotfound
                     THEN Insertrein(Insertheap,Insertlabel,System.memavail,Typ);
                  IF Typ=Dis9_T THEN Wert:=Wert shr 1;
                  IF Typ=Dis10_T THEN Wert:=Wert shr 2;
                  Nibbles.N2:=Nibbles.N4;
                  Nibbles.N3:=(Wert AND $00F0) shr 4;
                  Nibbles.N4:=Wert AND $000F;
            END;
 OpIstDisGBR:=ok
END;

FUNCTION OpIstDisRn(Op: Str80):Boolean;
VAR Offsetok,ok: Boolean;
    KommaPos: Byte;
    Displ,Dummy,RnStr: Str80;
    Typ: Op_Typ;
    Wert: LongInt;
    LastZ: Char;
BEGIN
 dummy:='';
 IF Befehl[5]='B'
    THEN Typ:=Dis4_t ELSE IF Befehl[5]='W' THEN Typ:=Dis5_T ELSE Typ:=Dis6_T;
 KommaPos:=Pos(',',Op);
 ok:=(OP[1]='@') AND (Op[2]='(')
                 AND (Op[Length(op)]=')')
                 AND (Kommapos>0)
                 AND (Op[Length(op)-1]<>'C');  (* Ausschlu von PC *)
 IF ok THEN BEGIN Displ:=Copy(Op,3,KommaPos-3);
                  LastZ:=Zeichen;
                  Lies_Operand(Dummy,Displ,Wert);
                  Zeichen:=LastZ;
                  IF Typ=Dis4_T THEN Offsetok:=(Wert=(Wert AND $F));
                  IF Typ=Dis5_T THEN BEGIN Offsetok:=(Wert=(Wert AND $1E));
                                           Wert:=Wert shr 1;
                                     END;
                  IF Typ=Dis6_T THEN BEGIN Offsetok:=(Wert=(Wert AND $3C));
                                           Wert:=Wert shr 2;
                                     END;
                  Nibbles.N2:=Nibbles.N4; Nibbles.N4:=Wert AND $000F;
                  RnStr:=Copy(Op,KommaPos+1,Length(Op)-KommaPos-1);
                  ok:=ok AND (OpIstRn(RnStr,Nibbles.N3));
                  IF Labelnotfound AND ok
                     THEN Fehlerausgabe('unbekanntes Label <'+Displ+'> im Registeroffset');
                  IF NOT Offsetok THEN Fehlerausgabe('Offset-Wert <'+Displ+'> zu gross');

            END;
 OpIstDisRn:=ok
END;

FUNCTION OpIstDisPC(Op: Str80; Typ:Op_Typ):Boolean;
VAR Dummy: Str80;
    Ziel,Distanz: LongInt;
    LastZ: Char;
BEGIN
 dummy:='';
 LastZ:=Zeichen;
 IF (OP[1]='@') AND (Op[2]='(') AND (Copy(Op,Length(op)-3,4)=',PC)')
    THEN Lies_Operand(Dummy,Copy(Op,3,Length(Op)-6),Ziel)
    ELSE Lies_Operand(Dummy,Op,Ziel);
 Zeichen:=LastZ;
 Distanz:=(Ziel-(Code.PC+4));
 IF Labelnotfound
    THEN Insertrein(Insertheap,Insertlabel,Code.PC,Typ)
    ELSE BEGIN IF Distanz<0 THEN Fehlerausgabe('Rueckwaertiger Zugriff auf <'+Insertlabel+'>');
               IF Typ=DisPcW_T THEN Distanz:=Distanz shr 1;
               IF Typ=DisPcL_T THEN Distanz:=Distanz shr 2;
               IF Distanz>=$100 THEN Fehlerausgabe('Entfernung zu <'+Op+'> zu gross');
               Nibbles.N3:=(Distanz shr 4) AND $0F;
               Nibbles.N4:=Distanz AND $000F;
         END;
 IF InputRec.C_Ok
    THEN IF Last_MN=Op_Delbra
            THEN Fehlerausgabe('Konstantenzugriff im Delayslot verboten');
 OpIstDisPC:=InputRec.C_ok
END;

PROCEDURE LiesRn(VAR Op: Str80; VAR Rn: Byte);
BEGIN
 Lies_Uppercase(Op,[#0..' ',',',';',')']);
 IF NOT OpIstRn(Op,Rn) THEN Fehlerausgabe('Registerbezeichnung erwartet');
END;

PROCEDURE LiesR0;
BEGIN
 LiesZeichen; Lies_Uppercase(Op2,[#0..' ',';']);
 IF Op2<>'R0' THEN Fehlerausgabe('Register R0 erwartet')
              ELSE Test_Zugriff_auf_R0(0);
END;

PROCEDURE LiesKommaR0;
BEGIN
 IF Zeichen=',' THEN LiesR0
                ELSE Fehlerausgabe('Komma erwartet');
END;

PROCEDURE LiesKomma;
BEGIN
  IF Zeichen=',' THEN LiesUpcaseZeichen ELSE Fehlerausgabe('Komma erwartet')
END;

PROCEDURE AssRts;
BEGIN
  CodiereNibbles;
  IF Last_MN = Op_Delbra
     THEN Fehlerausgabe('RTS/RTE im Delayslot verboten');
  Act_MN:=Op_Delbra
END;

PROCEDURE AssNop;
BEGIN
  CodiereNibbles;
END;

PROCEDURE AssSHLL;
BEGIN
  LiesUpcaseNospace;
  LiesRn(Op1,Nibbles.N2);
  CodiereNibbles
END;

PROCEDURE AssRn2;
BEGIN
  IF (Zeichen=',') AND InputRec.C_ok
     THEN BEGIN LiesUpcaseZeichen;
                LiesUpCaseNoSpace;
                LiesRn(Op2,Nibbles.N2);
          END
     ELSE Fehlerausgabe('Komma erwartet')
END;

PROCEDURE AssADDC;
BEGIN
  LiesUpcaseNospace;
  LiesRn(Op1,Nibbles.N3);
  AssRn2;
  CodiereNibbles;
END;

PROCEDURE AssTrapa;
BEGIN
  LiesUpcaseNoSpace;
  IF Zeichen ='#'
     THEN BEGIN AssImm; Op1:='#'+Op1;
                CodiereNibbles;
          END
     ELSE Fehlerausgabe('# erwartet')
END;

PROCEDURE AssBkpt;
BEGIN
  LiesUpcaseNoSpace;
  IF Zeichen ='#'
     THEN BEGIN AssImm; Op1:='#'+Op1;
                Nibbles.N2:=Nibbles.N3;
                Nibbles.N3:=Nibbles.N4; Nibbles.N4:=0;
                CodiereNibbles;
          END
     ELSE Fehlerausgabe('# erwartet')
END;

PROCEDURE AssOr;
BEGIN
  LiesUpcaseNoSpace;
  IF Zeichen ='#'
     THEN BEGIN Nibbles.N1:=$C;
                Nibbles.N2:=Nibbles.N4;
                AssImm; Op1:='#'+Op1;
                LiesKommaR0;
                CodiereNibbles
          END
     ELSE AssADDC;
END;

PROCEDURE AssAnd;
BEGIN
  LiesUpcaseNoSpace;
  IF Zeichen ='#'
     THEN BEGIN
                Nibbles.N1:=$C;
                Nibbles.N2:=Nibbles.N4;
                AssImm; Op1:='#'+Op1;
                LiesKommaR0;
                CodiereNibbles
          END
     ELSE AssADDC;
END;

PROCEDURE AssCmpEq;
BEGIN
  LiesUpcaseNoSpace;
  IF Zeichen ='#'
     THEN BEGIN Nibbles.N1:=8;
                Nibbles.N2:=8;
                AssImm; Op1:='#'+Op1;
                LiesKommaR0;
                CodiereNibbles
          END
     ELSE AssADDC
END;

PROCEDURE AssAdd;
BEGIN
  LiesUpcaseNoSpace;
  IF Zeichen ='#'
     THEN BEGIN IF Befehl='ADD' THEN Nibbles.N1:=7 ELSE Nibbles.N1:=$E;
                AssImm; Op1:='#'+Op1;
                AssRn2;
                CodiereNibbles;
          END
     ELSE AssADDC;
END;

PROCEDURE AssAndb;
BEGIN
  LiesUpcaseNoSpace;
  IF Zeichen ='#'
     THEN BEGIN AssImm; Op1:='#'+Op1;
                IF Zeichen = ','
                   THEN BEGIN LiesZeichen; Lies_UpperCase(Op2,[#0..' ',';']);
                              IF Op2<>'@(R0,GBR)' THEN Fehlerausgabe('@(R0,GBR) erwartet');
                              CodiereNibbles;
                        END
                   ELSE Fehlerausgabe('Komma erwartet')
          END
     ELSE Fehlerausgabe('# erwartet');
END;

PROCEDURE AssJmp;
BEGIN
  LiesUpcaseNoSpace;
  IF Zeichen ='@'
     THEN BEGIN LiesUpcaseZeichen; AssSHLL; Op1:='@'+Op1 END
     ELSE Fehlerausgabe('@ erwartet');
  IF Last_MN = Op_Delbra
     THEN Fehlerausgabe('JMP/JSR im Delayslot verboten');
  Act_MN:=Op_Delbra
END;

PROCEDURE AssBt;
VAR Ziel,Distanz: Longint;
BEGIN
   LiesUpcaseNoSpace;
   Lies_Operand(Op1,'',Ziel);
   IF Labelnotfound
      THEN Insertrein(Insertheap,Insertlabel,Code.PC,Bra8_t)
      ELSE BEGIN Distanz:=(Ziel-(Code.PC+4));
                 IF ((Distanz >= -256) AND (Distanz <= 254))
                    THEN BEGIN Nibbles.N3:=(Distanz shr 5) AND $F;
                               Nibbles.N4:=(Distanz shr 1) AND $F
                         END
                    ELSE Fehlerausgabe('Branch auf <'+Op1+'> zu lang')
          END;
   CodiereNibbles;
END;

PROCEDURE AssBra(Typ:Op_Typ);
VAR Ziel,Distanz: LongInt;
BEGIN
   LiesUpcaseNoSpace;
   Lies_Operand(Op1,'',Ziel);
   IF Labelnotfound
      THEN Insertrein(Insertheap,Insertlabel,Code.PC,Typ)
      ELSE BEGIN Distanz:=(Ziel-(Code.PC+4));
                 IF ((Distanz >= -4096) AND (Distanz <= 4094))
                    THEN BEGIN Nibbles.N2:=(Distanz shr 9) AND $F;
                               Nibbles.N3:=(Distanz shr 5) AND $F;
                               Nibbles.N4:=(Distanz shr 1) AND $F
                         END
                    ELSE Fehlerausgabe('Branch auf <'+Op1+'> zu lang')
          END;
   CodiereNibbles;
   IF Last_MN = Op_Delbra
      THEN Fehlerausgabe('BRA/BSR im Delayslot verboten');
   Act_MN:=Op_Delbra
END;

(* Pseudo-Befehl .BRAL durch TRAPA #$29 bzw .BSRL durch TRAPA #$30
   mit nachgestelltem Longoffset *)

PROCEDURE AssBraL(Typ:Op_Typ);
VAR Ziel,Distanz: LongInt;
BEGIN
   IF Code.PC AND 2 = 0 THEN CodiereWord($0009); (* NOP evtl. vorab *)
   CodiereNibbles;                               (* Trapa-Befehl    *)
   LiesUpcaseNoSpace;
   Lies_Operand(Op1,'',Ziel);
   IF Labelnotfound
      THEN Insertrein(Insertheap,Insertlabel,Code.PC,Typ)
      ELSE Distanz:=(Ziel-(Code.PC)-4);
   CodiereWord((Distanz shr 8 ) shr 8); Codiereword(Distanz AND $FFFF);
END;

PROCEDURE AssMovaL;
BEGIN
  AssBraL(Moval_t);LiesKommaR0
END;

PROCEDURE AssMac;
VAR ok: Boolean;
BEGIN
  LiesUpcaseNoSpace;
  Lies_Uppercase(Op1,[#0..' ',',',';']);
  ok:=OpIstRnPlus(Op1,Nibbles.N2);
  IF ok THEN BEGIN LiesKomma;
                   Lies_Uppercase(Op2,[#0..' ',',',';']);
                   ok:=OpIstRnPlus(Op2,Nibbles.N3)
             END;
  IF ok THEN CodiereNibbles
        ELSE Fehlerausgabe('@Rn+,@Rm+ erwartet')
END;

PROCEDURE AssLDC(Reg1,Reg2,Reg3: Str4; Typ: Byte);
VAR ok: Boolean;
BEGIN
  LiesUpcaseNoSpace;
  Lies_Uppercase(Op1,[#0..' ',',',';']);
  IF Typ=0 THEN ok:=OpIstRn(Op1,Nibbles.N2)
           ELSE ok:=OpIstRnPlus(Op1,Nibbles.N2);
  IF ok
     THEN BEGIN LiesKomma;
                Lies_Uppercase(Op2,[#0..' ',';']);
                IF Op2=Reg1 THEN Nibbles.N3:=0
                ELSE IF Op2=Reg2 THEN Nibbles.N3:=1
                ELSE IF Op2=Reg3 THEN Nibbles.N3:=2
                ELSE Fehlerausgabe(Reg1+', '+Reg2+' oder '+Reg3+' als Zielregister erwartet')
          END
     ELSE If Typ=0 THEN Fehlerausgabe('Rn als Quellregister erwartet')
                   ELSE Fehlerausgabe('@Rm+ als Quellregister erwartet');
  CodiereNibbles;
  IF Last_MN=Op_DelBra THEN Fehlerausgabe('LDC/LDS im Delay Branch Slot verboten');
  Act_MN:=Op_LDC;
END;

PROCEDURE AssSTC(Reg1,Reg2,Reg3: Str4;Typ:Byte);
BEGIN
  LiesUpcaseNoSpace;
  Lies_Uppercase(Op1,[#0..' ',',',';']);
  IF Op1=Reg1 THEN Nibbles.N3:=0
  ELSE IF Op1=Reg2 THEN Nibbles.N3:=1
  ELSE IF Op1=Reg3 THEN Nibbles.N3:=2
  ELSE Fehlerausgabe(Reg1+', '+Reg2+' oder '+Reg3+' erwartet');
  LiesKomma;
  Lies_Uppercase(Op2,[#0..' ',',',';']);
  IF Typ=0 THEN BEGIN IF NOT OpIstRn(Op2,Nibbles.N2)
                      THEN Fehlerausgabe('Rn als Zielregister erwartet')
                END
           ELSE IF NOT OpIstMinusRn(Op2,Nibbles.N2)
                THEN Fehlerausgabe('@Rn+ als Zielregister erwartet');
  CodiereNibbles;
  IF Last_MN=Op_DelBra THEN Fehlerausgabe('STS/STC im Delay Branch Slot verboten');
  Act_MN:=Op_LDC;
END;

PROCEDURE AsszuDisGBR;
BEGIN
  IF Op1='R0'
     THEN BEGIN Nibbles.N1:=$C;
                Test_Zugriff_auf_R0(0)
          END
     ELSE Fehlerausgabe('R0 als Ziel erwartet')
END;

PROCEDURE AssMovRnZuX;
VAR QuellRm,QuellGr: Byte;
BEGIN
  QuellRm:=Nibbles.N3; QuellGr:=Nibbles.N4;
  LiesKomma;
  Lies_Uppercase_Kl(Op2,[#0..' ',';']);
  IF OpIstIndRn(Op2,Nibbles.N2) THEN Nibbles.N1:=2
  ELSE IF OpIstMinusRn(Op2,Nibbles.N2)
       THEN BEGIN Nibbles.N1:=2; Nibbles.N4:=Nibbles.N4 OR 4 END
  ELSE IF OpIstR0Rn(Op2,Nibbles.N2) THEN Nibbles.N4:=Nibbles.N4 OR 4
  ELSE IF OpIstDisGbr(Op2) THEN AsszuDisGbr
  ELSE IF OpIstDisRn(Op2)
       THEN IF Befehl[5]='L'
               THEN BEGIN Nibbles.N1:=1; Nibbles.N2:=Nibbles.N3;
                          Nibbles.N3:=QuellRm;Test_Zugriff_auf_R0(0)
                    END
               ELSE IF Op1='R0'
                       THEN BEGIN Nibbles.N1:=8;Nibbles.N2:=QuellGr;
                                  Test_Zugriff_auf_R0(0)
                            END
                       ELSE Fehlerausgabe('R0 als Quelle erwartet')
  ELSE Fehlerausgabe('Zieloperand <'+Op2+'> fehlerhaft');
END;

PROCEDURE AssMov;
VAR Typ: OP_Typ;
BEGIN
  LiesUpcaseNoSpace;
  IF Befehl[5]='W' THEN Typ:=DisPCW_T ELSE Typ:=DisPCL_T; (* fuer PC *)
  Lies_Uppercase_Kl(Op1,[#0..' ',',',';']);
  IF OpIstRn(Op1,Nibbles.N3) THEN AssMovRnZuX
  ELSE IF OpIstIndRn(Op1,Nibbles.N3)
          THEN BEGIN Nibbles.N1:=6; AssRn2 END
  ELSE IF OpIstRnplus(Op1,Nibbles.N3)
          THEN BEGIN Nibbles.N1:=6; Nibbles.N4:=Nibbles.N4 or 4;
                     AssRn2 END
  ELSE IF OpIstR0Rn(Op1,Nibbles.N3)
          THEN BEGIN Nibbles.N4:=Nibbles.N4 OR $C; AssRn2 END
  ELSE IF OpIstDisGBR(Op1)
          THEN BEGIN Nibbles.N1:=$C; Nibbles.N2:=Nibbles.N2 OR 4;
                     LiesR0; Act_MN:=OP_ZielR0
               END
  ELSE IF OpIstDisRn(Op1)
          THEN IF Befehl[5]='L'
                  THEN BEGIN Nibbles.N1:=5; AssRn2 END
                  ELSE BEGIN Nibbles.N1:=8; Nibbles.N2:=Nibbles.N2 OR 4;
                             LiesR0; Act_MN:=OP_ZielR0
                       END
  ELSE IF OpIstDisPC(Op1,Typ)
          THEN BEGIN IF Befehl[5]='B' THEN Fehlerausgabe('verbotene Groesse .B');
                     IF Befehl[5]='W' THEN Nibbles.N1:=9 ELSE Nibbles.N1:=$D;
                     AssRn2
               END
  ELSE Fehlerausgabe('Quelloperand <'+Op1+'> fehlerhaft');
  CodiereNibbles
END;

PROCEDURE AssListF;
VAR Filename: T_Filename;
BEGIN
  LiesUpcaseNoSpace;
  Lies_UpperCase(Filename,[#0..#13,' ']);
  assign(Listfile,FileName); rewrite(listfile);
  IF Ioresult <> 0
     THEN BEGIN Fehlerausgabe('Fehler beim Oeffnen der Datei '+Filename);
                InputRec.C_Ok:=False;
          END
     ELSE BEGIN Op1:=Filename; List:=True END;
END;

PROCEDURE AssMOVA;
BEGIN
  LiesUpcaseNoSpace;
  Lies_Uppercase_Kl(Op1,[#0..' ',',',';']);
  IF OpIstDisPC(Op1,DisPCL_T)
     THEN LiesKommaR0
     ELSE Fehlerausgabe('Quelloperand <'+Op1+'> fehlerhaft');
  CodiereNibbles
END;


PROCEDURE Ass_Befehl;
BEGIN
 Ist_Befehl:=AssBezDa(AssBezBaum,Befehl,Nibbles,MnTyp);
 IF Ist_Befehl THEN
  BEGIN
        IF MnTyp=T_If    THEN AssIf
   ELSE IF MnTyp=T_Else  THEN AssElse
   ELSE IF MnTyp=T_Endif THEN AssEndif
   ELSE IF NOT IfSperre THEN
     BEGIN
      IF (MnTyp IN [T_RTS..T_DL]) AND Odd(Code.PC)
           THEN Fehlerausgabe('ungerade Adresse verboten, .ALIGN 2 verwenden')
           ELSE
            BEGIN
             CASE MnTyp OF
               T_Mov   : AssMov;
               T_RTS   : AssRts;
               T_Nop   : AssNop;
               T_SHLL  : AssSHLL;
               T_ADDC  : AssADDC;
               T_Jmp   : AssJmp;
               T_Trapa : AssTrapa;
               T_Bkpt  : AssBkpt;
               T_ListF : AssListF;
               T_List  : List:=True;
               T_NoList: List:=False;
               T_Endass: Endass:=True;
               T_Or    : AssOr;
               T_And   : AssAnd;
               T_Add   : AssAdd;
               T_CmpEq : AssCmpEq;
               T_AndB  : AssAndB;
               T_LDC   : AssLDC('SR','GBR','VBR',0);
               T_LDS   : AssLDC('MACH','MACL','PR',0);
               T_LDCL  : AssLDC('SR','GBR','VBR',1);
               T_LDSL  : AssLDC('MACH','MACL','PR',1);
               T_STC   : AssSTC('SR','GBR','VBR',0);
               T_STS   : AssSTC('MACH','MACL','PR',0);
               T_STCL  : AssSTC('SR','GBR','VBR',1);
               T_STSL  : AssSTC('MACH','MACL','PR',1);
               T_MAC   : AssMac;
               T_MOVA  : AssMOVA;
               T_Bra   : AssBra(Bra12_t);
               T_BSR   : AssBra(Bsr12_t);
               T_Bral  : AssBral(Bral_t);
               T_BSRl  : AssBral(Bsrl_t);
               T_Moval : AssMoval;
               T_BT    : AssBt;
               T_End   : Ende:=NOT BASIC_OR_PASCAL;
               T_Align : AssAlign;
               T_Equ   : AssEqu;
               T_DW    : AssDW;
               T_DB    : AssDB;
               T_DL    : AssDL;
               T_Distance: AssDistance;
               T_DR    : AssDR;
               T_Asc   : AssAsc;
               T_AscZ  : BEGIN AssAsc; CodiereByte(0) END;
               T_Str   : AssStr;
               T_Org   : AssOrg;
               T_VS    : AssVS;
               T_VARD  : AssVARD;
               T_DS    : AssDS;
               T_Page  : AssPage;
               T_Incl  : AssInclude;
              END;
             IF InputRec.C_ok AND (Zeichen <> #13)
                THEN BEGIN LiesUpcaseNoSpace;
                           Lies_Kommentar;
                     END
           END
         END
  END
END;

PROCEDURE Labelundbefehl;
BEGIN
  Labl:=Befehl; Befehl:='         ';
  LiesNoSpace;
  IF (Zeichen=';') OR (Zeichen='*')
     THEN Lies_Kommentar
     ELSE IF Zeichen <> #13
             THEN BEGIN Lies_Uppercase(Befehl,[#0..' ',';']);
                        Ass_Befehl;
                        IF NOT Ist_Befehl
                           THEN Fehlerausgabe('unbekannte Anweisung '+Befehl)
                  END
END;

PROCEDURE Asslabelrein;
VAR LWert:LongInt;
BEGIN
  IF (NOT IfSperre) AND (Length(Labl)>0)
     THEN IF L_vorhanden(Baum,Labl,Symbol,Lwert)
             THEN Fehlerausgabe('Label '+Labl+' bereits deklariert')
             ELSE Labelrein(Baum,Labl,L_Ident_BS,Lablwert);
END;

PROCEDURE Ass_Zeile;
BEGIN
  Act_MN:=Op_Normal;
  Lablwert:=Code.PC; ZeilenPC:=Code.PC;
  HexString:=''; Befehl:=''; Labl:=''; Op1:=''; Op2:='';Kommentar:='';
  LabelNotFound:=False;
  IF List THEN HexString:=HexLong(Code.PC)+': ';
  LiesUpcaseNoSpace; IF Zeichen=#10 THEN LiesUpcaseNoSpace;
  IF Zeichen <> #13
     THEN IF (Zeichen=';') OR (Zeichen='*')
             THEN Lies_Kommentar
             ELSE BEGIN Lies_Uppercase(Befehl,[#0..' ',';']);
                        Ass_Befehl;
                        IF NOT Ist_Befehl THEN Labelundbefehl
                  END;
  AssLabelrein;
  Last_MN:=Act_MN;
  {
  IF list
    THEN BEGIN Zeigezeile;
               IF Keypressed THEN InputRec.C_ok:=(Readkey=#27) OR InputRec.C_ok
         END
  }
END;

BEGIN (* Ass7032 *)
   IF Assaufruf IN [Basicass,Pascalass] THEN Zeichen:=#13;
   snd(200);
   Erzeuge(AssBezBaum,Assaufruf);
   snd(400);
   IFSperre:=False; IFAktiv:=False; Endass:=False;
   Last_MN:=Op_Normal;
   WHILE InputRec.C_ok AND NOT (Ende OR EndAss) DO Ass_Zeile;
   snd(800);
   vernichte(AssBezBaum);
   snd(1200);
END;

PROCEDURE Assemble;

CONST D_Imm=True; S_Imm=False;

VAR  PC,VarZeiger: LongInt;
     Baum: T_Baum;
     Insertheap: T_Insertheap;
     AssBezBaum: T_AssBezBaum;
     Ende,List:Boolean;
     i: Integer;
     ListFilename: T_Filename;

BEGIN       (* von Assembler *)
  snd(100);
  Ccreate(Sysinfo.Codestart); baum:=NIL; Insertheap:=NIL;
  Listfilename:=''; List:=False; Ende:=False;
  VarZeiger:=0;
  OpenInput(WorkFile.TName,'ASSEMBLER');
  IF ioresult = 0
   THEN BEGIN AsmSH7000(Ass,Ende,List,Baum,
                      AssBezBaum,Insertheap,VarZeiger);
              CloseInput;
              Insertersetzen_Dispose(Baum,Insertheap,InputRec.Meldung[5],InputRec.C_Ok);
              snd(1600);
              IF InputRec.C_Ok THEN {Str(Code.BlockNr*(MaxB+1)+Code.Position,Meldung[5]);}
              CClose;
        END
   ELSE BEGIN InputRec.C_ok := false;
             { Meldung[5] :='Datei '+ Work.TName + ' existiert nicht' }
        END;
  IF InputRec.C_ok
     THEN BEGIN IF list THEN Labelausgabe(Baum,listfile);
                speichern(WorkFile);
                Str(Code.BlockNr*(MaxB+1)+Code.Position,InputRec.Meldung[2]);
                InputRec.Meldung[2] := InputRec.Meldung[2]+' Bytes Code erzeugt';
                InputRec.Meldung[5] := '0 Fehler   Codedatei erzeugt';
                InputRec.OkMeldung:=Workfile.CName+' '+InputRec.Meldung[2];
          END
     ELSE BEGIN WorkFile.TFehler:=InputRec.Last.ZNr;
                WorkFile.WCode := false;
        END;
  Dispose_Baum(Baum);
  IF Listfilename <> '' THEN Close(Listfile);
END;

BEGIN END.
