UNIT BAsmScan;
{ Scannt fuer Assembler und Basic }
{ 10.02.96 Alf aus der alten Scanunit abgeleitet }

INTERFACE
USES Luchstyp;

TYPE
  T_BasicSymbol = (ListP_BS,               (* 1. Anweisung *)
                  Doppelpunkt_BS, End_BS,Let_BS,Def_BS,Label_BS, Return_BS,
                  Interrupt_BS,ReturnI_BS,Print_BS,Gotoxy_BS,
                  Poke_BS, WPoke_BS,LPoke_BS,Call_BS,
                  Goto_BS,Gosub_BS, REM_BS, Input_BS, Get_BS,
                  Read_BS, Data_BS, Inc_BS, Dec_BS,Register_BS,
                  Restore_BS,For_BS,Repeat_BS,If_BS,Ifl_BS,While_BS,
                  On_BS, Stop_BS,Include_BS,Dim_BS,Assembler_BS,
                  Tron_BS, Troff_BS,
                  Delay_BS,SetClock_BS, ReadClock_BS, LCDInit_BS, CopReset_BS,
                  L_Ident_BS, I_Ident_BS, I_Reg_BS,
                  R_Ident_BS, S_Ident_BS, F_Ident_BS,
                  StrLength_BS,
                  I2CInit_BS,I2CStart_BS,I2CRestart_BS,
                  I2CSend_BS,I2CStop_BS,
                  EEProgByte_BS,EEProgWord_BS,EEProgLong_BS,EEProgReal_BS,
                  EEProgStr_BS,
                  TastInit_BS,
                  TaskStop_BS,Sleep_BS,Wait_BS,Send_BS,TaskStart_BS,InitTask_BS,
                  ExitTask_BS,
                  SCI1Init_BS,DAOut_BS,
                  RSInit_BS,RSStat_BS,RSSend_BS,SetIrqMask_BS,
                  GoHost_BS,
                  Nolist_BS,Zeilenende_BS,        (* 2 letzte Anweisungen *)

                  Sin_BS,Cos_BS,Tan_BS,Asn_BS,Acs_BS,Atn_BS,  (* nur Realfunktionen *)
                  Exp_BS,Ln_BS,Sqrt_BS,Frac_BS,Trunc_BS,Sgn_BS,
                  Fakultaet_BS,EEReadReal_BS,Val_BS,

                  Abs_BS,Sqr_BS,                     (* beides *)

                  Peek_BS,LPeek_BS,Len_BS,Asc_BS,Pos_BS,Addr_BS,Keypress_BS,
                  ReadTimer_BS,RSReady_BS,RSRead_BS,GetIrqMask_BS,
                  EEReadByte_BS,EEReadWord_BS,EEReadLong_BS,
                  awaited_BS, ADIn_BS, ADIn16_BS,
                  I2CReadA_BS,I2CReadNA_BS,I2CAck_BS,
                  VBR_BS,
                  BitAnd_BS,BitOr_BS,BitEor_BS,BitNot_BS,WPeek_BS,
                                                   (* nur Intfunktionen *)

                  ChrD_BS,EEReadStr_BS,StrD_BS,LeftD_BS,RightD_BS,MidD_BS, (* Stringfunktionen *)

                  Spc_BS,

                  To_BS, Step_BS, Next_BS,Wend_BS,Until_BS,Then_BS,Else_BS,Endif_BS,
                  Not_BS, And_BS, Or_BS, Eor_BS, Plus_BS, Minus_BS, Mal_BS, Durch_BS,
                  Mod_BS, Div_BS,
                  Gleich_BS,Ungleich_BS,Kleiner_BS,KleinerGleich_BS,
                  Groesser_BS,Groessergleich_BS,
                  Semikolon_BS, Komma_BS,Klammerauf_BS, Klammerzu_BS,
                  Str_BS,Back_BS,
                  I_Zahl_BS,R_Zahl_BS,ZNR_Ident_BS,
                  VAR_BS,Org_BS,Word_BS,Byte_BS,
                  EndOfText_BS,unbekannt_BS);

     T_Opcode    = (Other,PushInt,PushReal,PushPR);
     Op_Typ      = (imm_t,Dis4_t,Dis5_t,Dis6_t,Dis8_t,Dis9_t,Dis10_t,
                    DisPCW_T,DisPCL_T,Byte_t,word_t,long_t,Distance_t,
                    bra8_t,bra12_t,bsr12_t,BasBraL_T,BasBsrL_T,
                    bral_t,bsrl_t,Moval_T,OnGoto_T,
                    dir,ext,bra,indxy,noOp);   (* <- nicht mehr noetig *)


     T_DimHeap=^DimH;
     DimH=RECORD
           DimName  : T_Ident;
           DimL     : Word;
           Dimens,Dim1,Dim2,Dim3: Word;
           next     : T_Dimheap
          END;
     T_Baum=^Baumlabel;
     Baumlabel=RECORD
                 links,rechts: T_Baum;
                 B_Name: T_Ident;
                 B_Wert: LongInt;
                 B_Symbol : T_BasicSymbol;
               END;

     T_Insertheap=^T_Insert;
     T_Insert=RECORD
                Name:    T_Ident;
                PC:      LongInt;
                AdrInfo: T_AdrInfo;
                Typ:     Op_Typ;
                next:    T_Insertheap
              END;

     T_Mn=(T_RTS,T_Nop,T_SHLL,T_Or,T_And,T_Add,T_CmpEq,T_ADDC,T_Jmp,T_TRAPA,
           T_ANDB,T_LDC,T_LDCL,T_LDSL,T_LDS,T_MAC,T_STC,T_STCL,T_STS,T_STSL,
           T_BT,T_BRA,T_Bsr,T_MOVA,T_MOV,
           T_BRAL,T_BSRL,T_MOVAL,
           T_DR,T_Distance,T_DW,T_DL,
           (* T_RTS muss erster Typ sein, T_DL letzter *)
           (* ab hier keine Wortgrenze fuer PC noetig: *)
           T_Nolist,T_List,T_ListF,T_DB,T_asc,T_AscZ,T_Str,T_Equ,T_Org,T_End,
           T_DS,T_Page,T_if,T_else,T_endif,T_Vard,T_VS,T_Incl,
           T_Bkpt,T_Align,T_Endass);

     T_Nibbles=Record N1,N2,N3,N4: Byte END;
     T_AssBezBaum=^T_AssBezB;
     T_AssBezB =RECORD
                  links,rechts: T_AssBezBaum;
                  MnName      : T_Ident;
                  Nibbles     : T_Nibbles;
                  MnTyp       : T_Mn;
                END;

     T_ScanResult      = RECORD
                          z           : Char;
                          Meldung     : T_Meldung;
                          C_Ok        : Boolean;
                          Basicsymbol : T_Basicsymbol;
                          Wert        : Double;
                          Name        : T_Bezeichner;
                          Zahl        : LongInt;
                          RZahl       : T_LuchsReal
                       END;

     T_DataFeld    = ARRAY [0..511] OF Byte;
     T_DataZeiger  = ^T_DataBlock;
     T_DataSchlange= RECORD
                      Kopf, Schwanz : T_DataZeiger;
                      Position      : Word;
                      Laenge        : LongInt;
                     END;
     T_DataBlock   = RECORD
                      DataFeld: T_DataFeld;
                      next:  T_DataZeiger
                     END;


PROCEDURE Create_Dataschlange(VAR DataSchlange:T_DataSchlange);
PROCEDURE DataSpeichern(DataSchlange: T_DataSchlange;
                        VAR Baum: T_Baum);
PROCEDURE CodiereDatabyte(b: Byte; VAR DataSchlange:T_DataSchlange);
PROCEDURE CodiereDataReal(r: Double; VAR DataSchlange:T_DataSchlange);
PROCEDURE CodiereDataString(s: String; VAR DataSchlange:T_DataSchlange);
PROCEDURE Dispose_DataSchlange(CS: T_DataSchlange);

PROCEDURE AssBezrein(VAR Baum: T_AssBezBaum;  AssBez: T_Ident;
                     MSB,Rn,Fx,LSB: Byte; MN: T_Mn);
FUNCTION  AssBezda(Baum: T_AssBezBaum;     AssBez: T_Ident;
                  VAR Opcd: T_Nibbles;     VAR MN    : T_Mn   ): Boolean;
PROCEDURE DimHeapRein(VAR Dimheap: T_Dimheap; Name:T_Ident;
                          DimLaenge,Dimension,DimAnz1,DimAnz2,DimAnz3: Word);
FUNCTION  DimHeapVorhanden(Dimheap:T_Dimheap; Name: T_Ident;
                VAR Dimension,DimLaenge,Dimanz1,Dimanz2,Dimanz3: LongInt): Boolean;

PROCEDURE Labelrein(VAR Baum: T_Baum; L_Name: T_Ident;
                        Symbol: T_BasicSymbol; L_Wert:LongInt);

PROCEDURE Labelausgabe(Baum: T_Baum; VAR Listfile: Text);

FUNCTION  L_vorhanden(Baum: T_Baum; L_Name: T_Ident;
                     VAR L_Symbol: T_BasicSymbol; VAR L_Wert: LongInt): Boolean;

PROCEDURE Erzeuge(VAR b: T_Baum);

PROCEDURE Insertheaprein(VAR Insertheap: T_Insertheap;
                         L_Name: T_Ident;
                         L_PC: LongInt;
                         L_Typ: Op_Typ);

PROCEDURE Insertersetzen_Dispose(Baum: T_Baum;
                         VAR Insertheap: T_Insertheap;
                         VAR Fehlerstring: String;
                         VAR C_Ok: Boolean);


PROCEDURE Dispose_Baum(VAR Baum: T_Baum);

PROCEDURE Dispose_DimHeap(VAR Dimheap: T_Dimheap);

PROCEDURE Basic_Scanner(VAR ScanResult: T_ScanResult; StdBezBaum: T_Baum);

IMPLEMENTATION
{$IFDEF Delphi }
USES Codesave, CommWin;
{$ELSE }
USES CodeSave, CommDOS;
{$ENDIF }

PROCEDURE Create_Dataschlange(VAR DataSchlange:T_DataSchlange);
BEGIN
  DataSchlange.Kopf:=NIL; DataSchlange.Schwanz:=NIL;
  DataSchlange.Position:=512; DataSchlange.Laenge:=0;
END;

PROCEDURE NewBlock(VAR DataSchlange: T_DataSchlange);
VAR NewZeiger: T_DataZeiger;
BEGIN
  new(NewZeiger);
  newZeiger^.next := nil;
  IF DataSchlange.Kopf=NIL
     THEN DataSchlange.Kopf:=NewZeiger
     ELSE DataSchlange.Schwanz^.next:=NewZeiger;
  DataSchlange.Schwanz:=NewZeiger;
  DataSchlange.Position:=0  ;
END;

PROCEDURE KorrigiereDataLabel(VAR baum:T_Baum; Datastart: Longint);
BEGIN
 IF baum <> NIL
    THEN BEGIN IF Baum^.B_Symbol=Data_BS
                  THEN Baum^.B_Wert:=Baum^.B_Wert+Datastart;
               KorrigiereDatalabel(Baum^.links,Datastart);
               KorrigiereDatalabel(Baum^.rechts,Datastart)
         END
END;

PROCEDURE DataSpeichern(DataSchlange: T_DataSchlange;
                        VAR Baum: T_Baum);
VAR i: Word;
BEGIN
  KorrigiereDataLabel(Baum,Code.PC);
  WHILE Dataschlange.Kopf <> Dataschlange.Schwanz DO
    BEGIN FOR i:=0 TO 511 DO CodiereCodeByte(Dataschlange.Kopf^.Datafeld[i]);
          Dataschlange.Kopf:=Dataschlange.Kopf^.next
    END;
  IF Dataschlange.Schwanz <> NIL
     THEN FOR i:=0 TO Dataschlange.Position-1 DO
           CodiereCodeByte(Dataschlange.Schwanz^.Datafeld[i]);
END;

PROCEDURE Dispose_DataSchlange(CS: T_DataSchlange);
VAR hilfV, Hilfn: T_DataZeiger;
BEGIN
  Hilfv := CS.Kopf;
  WHILE Hilfv <> nil DO
      BEGIN
         Hilfn := Hilfv;
         HilfV := Hilfv^.next;
         Dispose(Hilfn)
      END
END;

PROCEDURE CodiereDatabyte(b: Byte; VAR DataSchlange:T_DataSchlange);
VAR i: Integer;
BEGIN
  IF DataSchlange.Position=512 THEN NewBlock(DataSchlange);
  DataSchlange.Schwanz^.DataFeld[DataSchlange.Position]:=b;
  Inc(DataSchlange.Position); Inc(DataSchlange.Laenge);
END;

PROCEDURE CodiereDataString(s: String; VAR DataSchlange:T_DataSchlange);
VAR i,l: Integer;
BEGIN
  l:=ord(s[0]);
  CodiereDataByte(l,Dataschlange);
  FOR i:=1 TO l DO CodiereDataByte(ord(s[i]),Dataschlange);
  WHILE Dataschlange.Position AND 3 <> 0 DO CodiereDatabyte(0,Dataschlange);
END;

PROCEDURE CodiereDataReal(r: Double; VAR DataSchlange:T_DataSchlange);
TYPE T_reell=Record case boolean of
               true: (x: Double);
               false:(b: ARRAY[0..7] of Byte);
             end;
VAR reell: T_reell;
    i    : Word;
BEGIN
  reell.x:=r;
  FOR i:=7 downto 0 do CodiereDataByte(reell.b[i],Dataschlange);
END;


(*----- Prozeduren fuer Assembler-Bezeichner ------------*)

PROCEDURE AssBezrein(VAR Baum: T_AssBezBaum;  AssBez: T_Ident;
                     MSB,Rn,Fx,LSB: Byte; MN: T_Mn);

  PROCEDURE Ass_Rein(VAR Baum: T_AssBezBaum);
  BEGIN
    IF Baum=NIL
       THEN BEGIN new(Baum); Baum^.links:=NIL; Baum^.rechts:=NIL;
                  Baum^.MnName:=AssBez;
                  Baum^.Nibbles.N1:=MSB; Baum^.Nibbles.N2:=Rn;
                  Baum^.Nibbles.N3:=Fx;  Baum^.Nibbles.N4:=LSB;
                  Baum^.MnTyp:=Mn
            END
       ELSE
            IF Baum^.MnName = AssBez
               THEN
               ELSE IF Baum^.MnName > AssBez
                       THEN Ass_rein(Baum^.links)
                       ELSE Ass_rein(Baum^.rechts)
  END;

BEGIN Ass_Rein(Baum) END;

FUNCTION AssBezda(Baum: T_AssBezBaum;     AssBez: T_Ident;
                  VAR Opcd: T_Nibbles;     VAR MN    : T_Mn   ): Boolean;
var aktiv: boolean;
BEGIN
  aktiv:=True;
  while aktiv do
    begin
          if baum=nil
             then begin aktiv:=False; AssBezDa:=false end
             else if baum^.MnName=AssBez
                     THEN BEGIN Mn:=Baum^.MnTyp; Opcd:=Baum^.Nibbles;
                                AssBezDa:=True; aktiv:=False
                          END
                     ELSE IF Baum^.MnName > AssBez
                             THEN Baum:=Baum^.links
                             ELSE Baum:=Baum^.rechts
    end
END;

PROCEDURE DimHeapRein(VAR Dimheap: T_Dimheap; Name:T_Ident;
                          DimLaenge,Dimension,DimAnz1,DimAnz2,DimAnz3: Word);
VAR Newheap: T_DimHeap;
BEGIN
  new(Newheap);
  Newheap^.next:=Dimheap;
  newheap^.DimName:=Name; newheap^.Diml:=Dimlaenge; newheap^.Dimens:=Dimension;
  Newheap^.Dim1:=Dimanz1; Newheap^.Dim2:=Dimanz2; Newheap^.Dim3:=Dimanz3;
  Dimheap:=Newheap
END;

FUNCTION DimHeapVorhanden(Dimheap:T_Dimheap; Name: T_Ident;
                VAR Dimension,DimLaenge,Dimanz1,Dimanz2,Dimanz3: LongInt): Boolean;
BEGIN
  IF Dimheap=NIL
     THEN Dimheapvorhanden:=False
     ELSE IF Name=Dimheap^.Dimname
             THEN BEGIN Dimlaenge:=Dimheap^.Diml; Dimanz1:=Dimheap^.Dim1;
                        Dimanz2:=Dimheap^.Dim2; Dimanz3:=Dimheap^.Dim3;
                        Dimension:=Dimheap^.Dimens;
                        DimHeapVorhanden:=True
                  END
             ELSE Dimheapvorhanden:=Dimheapvorhanden(Dimheap^.next,Name,
                                  Dimension,Dimlaenge,Dimanz1,Dimanz2,Dimanz3)
END;

PROCEDURE Labelrein(VAR Baum: T_Baum; L_Name: T_Ident;
                    Symbol: T_BasicSymbol; L_Wert:LongInt);

  PROCEDURE L_Rein(VAR Baum: T_Baum);
  BEGIN
    IF Baum=NIL
       THEN BEGIN new(Baum); Baum^.links:=NIL; Baum^.rechts:=NIL;
                  Baum^.B_Name:=L_Name; Baum^.B_Wert:=L_Wert;
                  Baum^.B_Symbol:=Symbol
            END
       ELSE
            IF Baum^.B_Name = L_Name
               THEN
               ELSE IF Baum^.B_Name > L_Name
                       THEN L_rein(Baum^.links)
                       ELSE L_rein(Baum^.rechts)
  END;

BEGIN
  L_Rein(Baum)
END;

FUNCTION L_vorhanden(Baum: T_Baum; L_Name: T_Ident;
                     VAR L_Symbol: T_BasicSymbol; VAR L_Wert: LongInt): Boolean;
var aktiv: boolean;
BEGIN
  aktiv:=True;
  while aktiv do
    begin if baum=nil
             then begin aktiv:=False; l_vorhanden:=false end
             else if baum^.b_name=L_Name
                     THEN BEGIN L_Wert:=Baum^.B_Wert; L_Symbol:=Baum^.B_Symbol;
                                L_vorhanden:=True; aktiv:=False
                          END
                     ELSE IF Baum^.B_Name > L_Name
                             THEN Baum:=Baum^.links
                             ELSE Baum:=Baum^.rechts
    end
END;

PROCEDURE Labelausgabe(Baum: T_Baum; VAR Listfile: Text);
TYPE T_Symbolset = Set OF T_BasicSymbol;
     Str80=String[80];
VAR i,Zaehler: Integer;
    Labelstring: Str80;

   PROCEDURE ZeigeBaum(Baum: T_Baum; Symbole: T_Symbolset);
   VAR lbl,L_Wert:  Str80;
   BEGIN
     IF Baum <> NIL
        THEN BEGIN
               Zeigebaum(Baum^.links,Symbole);
               IF Baum^.B_Symbol IN Symbole
                  THEN BEGIN
                          lbl:=Baum^.B_Name;
                          WHILE Length(Lbl) <11 DO lbl:=lbl + ' ';
                          labelstring:=labelstring+lbl+'$'+
                                       HexLong(Baum^.B_Wert)+'   ';
                          Zaehler:=Zaehler+1;
                          IF Zaehler=3
                             THEN BEGIN writeln(Listfile,labelstring);
                                        Zaehler:=0; Labelstring:=''
                                  END
                       END;
               Zeigebaum(Baum^.rechts,Symbole)
             END
   END;

BEGIN
   writeln(listfile); writeln(listfile);
   writeln(listfile,'Sprunglabel:');
   Zaehler:=0; Labelstring:='';
   Zeigebaum(Baum,[L_Ident_BS]);
   writeln(listfile,Labelstring);
   writeln(listfile); writeln(listfile,'Variable:');
   Zaehler:=0; Labelstring:='';
   Zeigebaum(Baum,[I_Ident_BS,R_Ident_BS,S_Ident_BS]);
   writeln(listfile,Labelstring);
   writeln(Listfile,'#################################');
END;

PROCEDURE Dispose_DimHeap(VAR Dimheap: T_Dimheap);
BEGIN
  IF Dimheap <> NIL THEN
    BEGIN Dispose_Dimheap(Dimheap^.next); Dispose(Dimheap); END
END;

PROCEDURE Dispose_Baum(VAR Baum: T_Baum);
BEGIN
 IF Baum <> NIL
    THEN BEGIN Dispose_Baum(Baum^.rechts);
               Dispose_Baum(Baum^.links);
               Dispose(Baum)
         END;
END;


PROCEDURE Insertheaprein(VAR Insertheap: T_Insertheap;
                         L_Name: T_Ident;
                         L_PC: LongInt;
                         L_Typ: Op_Typ);
VAR hilf: T_Insertheap;
BEGIN
  hilf:=Insertheap; New(Insertheap);
  Insertheap^.Name:=L_Name;
  Insertheap^.PC:=L_PC;
  LiesAdresse(Insertheap^.AdrInfo);
  (*
  writeln(insertheap^.adrinfo.position);readln;
  *)
  Insertheap^.Typ:=L_Typ;
  Insertheap^.next:=hilf;
END;

PROCEDURE Insertersetzen_Dispose(Baum: T_Baum;
                         VAR Insertheap: T_Insertheap;
                         VAR FehlerString: String;
                         VAR C_Ok: Boolean);
VAR Distanz,Wert: LongInt;
    Dummysymbol: T_BasicSymbol;
    Wort: Word;
    altH  : T_InsertHeap;

  PROCEDURE IncAdrInf(VAR AdrInfo:T_AdrInfo; Offset: Word);
  BEGIN
    Inc(AdrInfo.Position,Offset);
    IF AdrInfo.Position>=256
       THEN BEGIN AdrInfo.Position:=AdrInfo.Position-256;
                  Inc(AdrInfo.Blocknr)
            END
{
    IF AdrInfo.Position <> 256
       THEN Inc(AdrInfo.Position)
       ELSE BEGIN AdrInfo.Position:=1; Inc(AdrInfo.BlockNr) END
}
  END;

  PROCEDURE ersetze;
  BEGIN
     IF L_vorhanden(Baum, Insertheap^.Name,Dummysymbol,Wert)
        THEN BEGIN
                   case Insertheap^.Typ of
                     imm_t:  begin incAdrInf(Insertheap^.adrinfo,1);
                                   ersetzebyte(Wert,Insertheap^.AdrInfo);
                             end;
                     Byte_t: ersetzebyte(Wert,Insertheap^.AdrInfo);
                     Word_t: ersetzeWord(Wert,Insertheap^.AdrInfo);
                     Long_t: ersetzelong(Wert,Insertheap^.Adrinfo);
                     Distance_t: ersetzelong(Wert-Insertheap^.PC,
                                             Insertheap^.Adrinfo);
                    {
                     Dis4_t: begin inc(Insertheap^.adrinfo.Position);
                                   ersetzeNibble(Wert,Insertheap^.AdrInfo, Code);
                             end;
                     Dis5_t: begin inc(Insertheap^.adrinfo.Position);
                                   ersetzeNibble(Wert shr 1,Insertheap^.AdrInfo);
                             end;
                     Dis6_t: begin inc(Insertheap^.adrinfo.Position);
                                   ersetzeNibble(Wert shr 2,Insertheap^.AdrInfo);
                             end;
                   }
                     Dis8_t: begin incAdrInf(Insertheap^.adrinfo,1);
                                   ersetzebyte(Wert,Insertheap^.AdrInfo);
                             end;
                     Dis9_t: begin incAdrInf(Insertheap^.adrinfo,1);
                                   ersetzebyte(Wert shr 1,Insertheap^.AdrInfo);
                             end;
                     Dis10_t:begin incAdrInf(Insertheap^.adrinfo,1);
                                   ersetzebyte(Wert shr 2,Insertheap^.AdrInfo);
                             end;
                     Bra8_T:BEGIN Distanz:=Wert-Insertheap^.PC-4;
                                  IF ((Distanz >= -256) AND (Distanz <= 254))
                                   THEN BEGIN incAdrInf(Insertheap^.adrinfo,1);
                                              ersetzebyte(Distanz shr 1,Insertheap^.AdrInfo)
                                        END
                                   ELSE BEGIN FehlerString:='Branch auf '
                                                           +Insertheap^.Name
                                                           +' zu lang';
                                              C_Ok:=False
                                        END;
                          END;
                     DisPCW_T:
                          BEGIN
                           IF Wert AND 1 <> 0
                            THEN Fehlerstring:='Verbotener Wordzugriff auf '
                                        +Insertheap^.Name
                            ELSE BEGIN
                                  Distanz:=Wert-Insertheap^.PC-4;
                                  IF Distanz <0
                                   THEN BEGIN FehlerString:=' Zugriff auf '+
                                                     Insertheap^.Name+' zu nah oder rueckwaerts';
                                              C_Ok:=False
                                        END
                                   ELSE BEGIN
                                          Distanz:=Distanz shr 1;
                                          IF Distanz < $100
                                             THEN BEGIN incAdrInf(Insertheap^.adrinfo,1);
                                                        ersetzebyte(Distanz,Insertheap^.AdrInfo);
                                                  END
                                             ELSE BEGIN FehlerString:='Word Zugriff auf '
                                                           +Insertheap^.Name
                                                           +' zu weit';
                                                        C_Ok:=False
                                                  END;
                                        END
                                  END
                          END;
                     DisPCL_T:
                          BEGIN
                           IF Wert AND 3 <> 0
                            THEN BEGIN Fehlerstring:='Verbotener Longzugriff auf '
                                        +Insertheap^.Name;
                                       C_Ok:=False
                                 END
                            ELSE BEGIN
                                  Distanz:=Wert-((Insertheap^.PC+4) AND $FFFFFFFC);
                                  IF Distanz <0
                                   THEN BEGIN FehlerString:='Rueckwaertiger Zugriff auf '+
                                                     Insertheap^.Name+'=$'+Hexlong(wert)+' verboten';
                                              C_Ok:=False
                                        END
                                   ELSE BEGIN
                                          Distanz:=Distanz shr 2;
                                          IF Distanz < $100
                                             THEN BEGIN incAdrInf(Insertheap^.adrinfo,1);
                                                        ersetzebyte(Distanz,Insertheap^.AdrInfo);
                                                  END
                                             ELSE BEGIN FehlerString:='Longword Zugriff auf '
                                                           +Insertheap^.Name
                                                           +' zu weit';
                                                        C_Ok:=False
                                                  END;
                                        END
                                  END
                          END;
                     BSR12_T,Bra12_T:
                          BEGIN Distanz:=Wert-Insertheap^.PC-4;
                                IF ((Distanz >= -4096) AND (Distanz <= 4094))
                                   THEN BEGIN
                                          IF Insertheap^.Typ=Bra12_T
                                             THEN Wort:=$A000
                                             ELSE Wort:=$B000;
                                          Wort:=Wort OR ((Distanz shr 1) AND $00000FFF);
                                          ersetzeword(Wort,Insertheap^.adrinfo);
                                        END
                                   ELSE BEGIN FehlerString:='Branch auf '
                                                           +Insertheap^.Name
                                                           +' zu lang';
                                              C_Ok:=False
                                        END;
                          END;
                     BSRL_T,BRAL_T,Moval_T:
                          BEGIN Distanz:=Wert-Insertheap^.PC-4;
                                ErsetzeLong(Distanz,Insertheap^.Adrinfo);
                          END;
                     BasBraL_T:
                          BEGIN Distanz:=Wert-Insertheap^.PC-4;
                                IF Distanz <= 4080             (* hier nur pos. moeglich *)
                                   THEN BEGIN Dec(Insertheap^.Adrinfo.Position,10);
                                              IF Insertheap^.Adrinfo.Position>256 (* keine neg. Werte *)
                                                 THEN BEGIN Dec(Insertheap^.Adrinfo.BlockNr,1);
                                                            Inc(Insertheap^.Adrinfo.Position,256)
                                                      END;
                                              Ersetzelong(($A000+(Distanz+10)shr 1)shl 16 +9,Insertheap^.Adrinfo);
                                              IncAdrInf(Insertheap^.Adrinfo,4);
                                              Ersetzelong($00090009,Insertheap^.AdrInfo); (* bra xx Pull_PR *)
                                        END
                                   ELSE ErsetzeLong(Distanz+4,Insertheap^.Adrinfo);
                          END;
                     BasBsrL_T:
                          BEGIN Distanz:=Wert-Insertheap^.PC-4;
                                IF Distanz <= 4070             (* hier nur pos. moeglich *)
                                   THEN BEGIN Dec(Insertheap^.Adrinfo.Position,16);
                                              IF Insertheap^.Adrinfo.Position>256 (* keine neg. Werte *)
                                                 THEN BEGIN Dec(Insertheap^.Adrinfo.BlockNr,1);
                                                            Inc(Insertheap^.Adrinfo.Position,256)
                                                      END;
                                              Ersetzelong((($B000+(Distanz+16)shr 1)shl 8) shl 8 +9,Insertheap^.Adrinfo);
                                              IncAdrInf(Insertheap^.Adrinfo,4);
                                              Ersetzelong($4F26A005,Insertheap^.AdrInfo); (* Pull_PR bra xx *)
                                              IncAdrInf(Insertheap^.Adrinfo,4);
                                              Ersetzelong($00090009,Insertheap^.AdrInfo); (* 2 NOP *)

                                        END
                                   ELSE ErsetzeLong(Distanz+4,Insertheap^.Adrinfo);
                          END;
                     OnGoto_T:
                          BEGIN Distanz:=Wert-Insertheap^.PC;
                                ErsetzeLong(Distanz,Insertheap^.Adrinfo);
                          END;
                   END;
             END
        ELSE BEGIN FehlerString:=Insertheap^.Name+' nicht deklariert'; C_Ok:=False END
  END;

BEGIN
  WHILE (Insertheap <> NIL)
     DO BEGIN altH := InsertHeap;
              ersetze;
              Insertheap:=Insertheap^.next;
              Dispose(AltH)
        END
END;




{
PROCEDURE Codieredatabytes(VAR Dataschlange,CSchlange: T_Cschlange;
                           VAR Baum: T_Baum;
                           Dataadrinfo: T_AdrInfo;
                           VAR PC: LongInt);

VAR CZeiger:T_CZeiger;
    I: Integer;

    PROCEDURE KorrigiereDataLabel(VAR baum:T_Baum; PC: Word);
    BEGIN
      IF baum <> NIL
         THEN BEGIN IF Baum^.B_Symbol=Data_BS
                       THEN Baum^.B_Wert:=Baum^.B_Wert+PC;
                    KorrigiereDatalabel(Baum^.links,PC);
                    KorrigiereDatalabel(Baum^.rechts,PC)
              END
    END;
BEGIN
  Ersetzeword(PC,DataAdrinfo);
  KorrigiereDataLabel(baum,PC);
  CZeiger:=DataSchlange.Kopf;
  WHILE CZeiger <> DataSchlange.Schwanz DO
    BEGIN FOR i:=0 TO 511 DO CodiereCodeByte(CZeiger^.CFeld[i],CSchlange,PC);
          CZeiger:=CZeiger^.Next;
    END;
  IF Dataschlange.Schwanz<>NIL
    THEN FOR i:=0 TO Dataschlange.Position DO
           CodiereCodeByte(DataSchlange.Schwanz^.CFeld[i],CSchlange,PC);

BEGIN END;
}

PROCEDURE Erzeuge(VAR b: T_Baum);
BEGIN
  b:=NIL;
  Labelrein(b,'END'   ,END_BS   ,0);
  Labelrein(b,'NOLIST',NoList_BS,0);
  Labelrein(b,'LISTP' ,ListP_BS ,0);
  Labelrein(b,'PRINT' ,Print_BS ,0);
  Labelrein(b,'GOTOXY',Gotoxy_BS,0);
  Labelrein(b,'STOP'  ,Stop_BS  ,0);
  Labelrein(b,'DELAY' ,Delay_BS ,0);
  Labelrein(b,'RETURN',Return_BS,0);
  Labelrein(b,'RETURNI',ReturnI_BS,0);
  Labelrein(b,'INTERRUPT',Interrupt_BS,0);
  Labelrein(b,'POKE'  ,Poke_BS  ,0);
  Labelrein(b,'LPOKE' ,LPoke_BS ,0);
  Labelrein(b,'WPOKE' ,WPoke_BS ,0);
  Labelrein(b,'CALL'  ,Call_BS  ,0);
  Labelrein(b,'GOTO'  ,Goto_BS  ,0);
  Labelrein(b,'GOSUB' ,Gosub_BS ,0);
  Labelrein(b,'ON'    ,On_BS    ,0);
  Labelrein(b,'REM'   ,Rem_BS   ,0);
  Labelrein(b,'LET'   ,Let_BS   ,0);
  Labelrein(b,'COPRESET',CopReset_BS,0);
  Labelrein(b,'GET'   ,Get_BS   ,0);
  Labelrein(b,'INPUT' ,Input_BS ,0);
  Labelrein(b,'IF'    ,If_BS    ,0);
  Labelrein(b,'IFL'   ,Ifl_BS   ,0);
  Labelrein(b,'THEN'  ,Then_BS  ,0);
  Labelrein(b,'ELSE'  ,Else_BS  ,0);
  Labelrein(b,'ENDIF' ,Endif_BS ,0);
  Labelrein(b,'WHILE' ,While_BS ,0);
  Labelrein(b,'WEND'  ,Wend_BS  ,0);
  Labelrein(b,'REPEAT',Repeat_BS,0);
  Labelrein(b,'UNTIL' ,Until_BS ,0);
  Labelrein(b,'AND'   ,And_BS   ,0);
  Labelrein(b,'OR'    ,Or_BS    ,0);
  Labelrein(b,'NOT'   ,Not_BS   ,0);
  Labelrein(b,'MOD'   ,Mod_BS   ,0);
  Labelrein(b,'DIV'   ,Div_BS   ,0);
  Labelrein(b,'READ'  ,Read_BS  ,0);
  Labelrein(b,'DATA'  ,Data_BS  ,0);
  Labelrein(b,'RESTORE', Restore_BS, 0);
  Labelrein(b,'ORG'   ,Org_BS   ,0);
  Labelrein(b,'VAR'   ,Var_BS   ,0);
  Labelrein(b,'WORD'  ,Word_BS  ,0);
  Labelrein(b,'BYTE'  ,Byte_BS  ,0);
  Labelrein(b,'REGISTER',Register_BS,0);
  Labelrein(b,'DIM'   ,Dim_BS   ,0);
  Labelrein(b,'FOR'   ,For_BS   ,0);
  Labelrein(b,'TO'    ,To_BS    ,0);
  Labelrein(b,'STEP'  ,Step_BS  ,0);
  Labelrein(b,'NEXT'  ,Next_BS  ,0);
  Labelrein(b,'DEF'   ,Def_BS   ,0);
  Labelrein(b,'TASKSTOP',TaskStop_BS,0);
  Labelrein(b,'SLEEP'  ,Sleep_BS  ,0);
  Labelrein(b,'WAIT'   ,Wait_BS   ,0);
  Labelrein(b,'SEND'   ,Send_BS   ,0);
  Labelrein(b,'TASKSTART',TaskStart_BS,0);
  Labelrein(b,'INITTASK',INITTASK_BS,0);
  Labelrein(b,'ENDTASK' ,ExitTASK_BS, 0);
  Labelrein(b,'INC'   ,INC_BS  ,0);
  Labelrein(b,'DEC'   ,DEC_BS  ,0);

  Labelrein(b,'ABS'   ,Abs_BS   ,0);
  Labelrein(b,'SIN'   ,Sin_BS   ,0);
  Labelrein(b,'COS'   ,Cos_BS   ,0);
  Labelrein(b,'TAN'   ,Tan_BS   ,0);
  Labelrein(b,'ASN'   ,Asn_BS   ,0);
  Labelrein(b,'ACS'   ,Acs_BS   ,0);
  Labelrein(b,'ATN'   ,Atn_BS   ,0);
  Labelrein(b,'EXP'   ,Exp_BS   ,0);
  Labelrein(b,'LN'    ,Ln_BS    ,0);
  Labelrein(b,'SQR'   ,Sqr_BS   ,0);
  Labelrein(b,'SGN'   ,Sgn_BS   ,0);
  Labelrein(b,'SQRT'  ,Sqrt_BS  ,0);
  Labelrein(b,'FRAC'  ,Frac_BS  ,0);
  Labelrein(b,'VAL'   ,Val_BS   ,0);
  Labelrein(b,'TRUNC' ,Trunc_BS ,0);
  Labelrein(b,'PEEK'  ,Peek_BS  ,0);
  Labelrein(b,'LPEEK' ,LPeek_BS  ,0);
  Labelrein(b,'LEN'   ,Len_BS   ,0);
  Labelrein(b,'ASC'   ,Asc_BS   ,0);
  Labelrein(b,'POS'   ,Pos_BS   ,0);
  Labelrein(b,'ADDR'  ,Addr_BS  ,0);
  Labelrein(b,'WPEEK' ,Wpeek_BS ,0);
  Labelrein(b,'KEYPRESS' ,Keypress_BS  ,0);
  Labelrein(b,'READTIMER',ReadTimer_BS ,0);
  Labelrein(b,'VBR'    ,VBR_BS ,0);
  Labelrein(b,'AWAITED',Awaited_BS,0);
  Labelrein(b,'BITOR' ,BitOr_BS ,0);
  Labelrein(b,'BITAND',BitAnd_BS,0);
  Labelrein(b,'BITEOR',BitEOr_BS,0);
  Labelrein(b,'BITNOT',BitNot_BS,0);
  Labelrein(b,'SETCLOCK' ,SetClock_BS  ,0);
  Labelrein(b,'READCLOCK',ReadClock_BS ,0);
  Labelrein(b,'CHR$'  ,ChrD_BS  ,0);
  Labelrein(b,'STR$'  ,StrD_BS  ,0);
  Labelrein(b,'LEFT$' ,LeftD_BS ,0);
  Labelrein(b,'RIGHT$',RightD_BS,0);
  Labelrein(b,'MID$'  ,MidD_BS  ,0);
  Labelrein(b,'SPC'   ,Spc_BS   ,0);

  Labelrein(b,'I2CINIT'    ,I2CInit_BS   ,0);
  Labelrein(b,'I2CSTART'   ,I2CStart_BS  ,0);
  Labelrein(b,'I2CRESTART' ,I2CRestart_BS,0);
  Labelrein(b,'I2CSEND'    ,I2CSend_BS   ,0);
  Labelrein(b,'I2CREADA'   ,I2CReadA_BS  ,0);
  Labelrein(b,'I2CREADNA'  ,I2CReadNA_BS ,0);
  Labelrein(b,'I2CSTOP'    ,I2CStop_BS   ,0);
  Labelrein(b,'I2CACK'     ,I2CAck_BS    ,0);
  Labelrein(b,'EEPROGBYTE' ,EEProgByte_BS,0);
  Labelrein(b,'EEPROGWORD' ,EEProgWord_BS,0);
  Labelrein(b,'EEPROGLONG' ,EEProgLong_BS,0);
  Labelrein(b,'EEPROGREAL' ,EEProgReal_BS,0);
  Labelrein(b,'EEPROGSTR'  ,EEProgStr_BS,0);
  Labelrein(b,'EEREADBYTE' ,EEReadByte_BS,0);
  Labelrein(b,'EEREADWORD' ,EEReadWord_BS,0);
  Labelrein(b,'EEREADLONG' ,EEReadLong_BS,0);
  Labelrein(b,'EEREADREAL' ,EEReadReal_BS,0);
  Labelrein(b,'EEREADSTR'  ,EEReadStr_BS,0);
  Labelrein(b,'FAK'        ,Fakultaet_BS,0);
  Labelrein(b,'TASTINIT'   ,TastInit_BS,0);
  Labelrein(b,'SCI1INIT'   ,SCI1Init_BS,0);
  Labelrein(b,'DAOUT'      ,DAOUT_BS,0);
  Labelrein(b,'ADIN'       ,ADIn_BS,0);
  Labelrein(b,'ADIN16'     ,ADIn16_BS,0);
  Labelrein(b,'SETIRQMASK' ,SetIrqMask_BS,0);
  Labelrein(b,'GETIRQMASK' ,GetIrqMask_BS,0);
  Labelrein(b,'RSINIT'     ,RSInit_BS,0);
  Labelrein(b,'RSREADY'    ,RSReady_BS,0);
  Labelrein(b,'RSSTAT'     ,RSStat_BS,0);
  Labelrein(b,'RSREAD'     ,RSRead_BS,0);
  Labelrein(b,'RSSEND'     ,RSSend_BS,0);


  Labelrein(b,'ASSEMBLER',Assembler_BS,0);
  Labelrein(b,'INCLUDE'  ,Include_BS  ,0);
  Labelrein(b,'TRON'  ,Tron_BS  ,0);
  Labelrein(b,'TROFF' ,Troff_BS ,0);
  Labelrein(b,'LCDINIT'  ,LCDInit_BS  ,0);
  Labelrein(b,'STRLENGTH',StrLength_BS,0);
  Labelrein(b,'GOHOST'   ,GoHost_BS,0);
END;

 PROCEDURE Basic_Scanner(VAR ScanResult: T_ScanResult;
                         StdBezBaum: T_Baum);

   PROCEDURE LiesWert;
   VAR WertString: Str80;
       Result: Integer;
       Neuwert,Altwert: Double;

       PROCEDURE LiesHexZahl;
       VAR HexHilf: LongInt;
       BEGIN
         Lies; Hexhilf:=0;
         IF NOT (Upcase(InputRec.z) IN ['0'..'9','A'..'F'])
            THEN Fehler('Hexziffer erwartet')
            ELSE WHILE Upcase(InputRec.z) IN ['0'..'9','A'..'F'] DO
                   BEGIN IF InputRec.z <= '9'
                            THEN Hexhilf:=16*Hexhilf+Ord(InputRec.z)-48
                            ELSE Hexhilf:=16*Hexhilf+Ord(Upcase(InputRec.z))-55;
                         Lies
                   END;
         {
         IF Hexhilf > 4294967295.0
            THEN Fehler('Hexzahl zu gross',Input)
            ELSE
            }
         Scanresult.Wert:=Hexhilf;
       END;


   PROCEDURE LiesRZahl;
   BEGIN
     Wertstring:=InputRec.z; Val(Wertstring,NeuWert,Result); Altwert:=NeuWert;
     WHILE Result=0 DO
       BEGIN Altwert:=NeuWert; Lies;
             IF Upcase(InputRec.z) = 'E'
                THEN BEGIN Wertstring:=Wertstring+'E'; Lies;
                           IF (InputRec.z='-') OR (InputRec.z='+')
                              THEN BEGIN Wertstring:=Wertstring+InputRec.z;
                                         Lies
                                   END
                     END;
             Wertstring:=Wertstring+InputRec.z;
             Val(Wertstring,NeuWert,Result)
       END;
     Scanresult.Wert:=Altwert;
     IF (Scanresult.Wert >= 2147483647.0) OR (Scanresult.Wert <= -214783648.0)
        THEN scanresult.BasicSymbol:=R_Zahl_BS
        ELSE IF scanresult.wert <> Trunc(scanresult.wert)
                THEN scanresult.BasicSymbol := R_Zahl_BS;
   END;

   BEGIN
     scanresult.BasicSymbol:=I_Zahl_BS;
     IF InputRec.z='$' THEN LiesHexZahl ELSE LiesRZahl
   END;

 PROCEDURE LiesName;
 VAR Dummy: LongInt;
     NeuName: String[80];
     StdBezSymbol: T_BasicSymbol;
 BEGIN
    Neuname:='';
    WHILE InputRec.z IN ['_','0'..'9','A'..'Z','a'..'z'] DO
      BEGIN Neuname:=Neuname + Upcase(InputRec.z); Lies; END;
    IF InputRec.z='$'
       THEN BEGIN scanresult.BasicSymbol := S_Ident_BS; Lies;
                  IF Length(Neuname)=9 THEN Neuname[9]:='$'
                                       ELSE Neuname:=Neuname+'$'
            END
       ELSE IF InputRec.z='%'
               THEN BEGIN
                      scanresult.BasicSymbol := I_Ident_BS; Lies;
                      IF Length(Neuname)=9
                         THEN Neuname[9]:='%' ELSE Neuname:=Neuname+'%'
                    END
               ELSE scanresult.BasicSymbol:=R_Ident_BS;
    IF L_vorhanden(StdBezBaum,Neuname,StdBezSymbol,Dummy)
       THEN scanresult.BasicSymbol:=StdBezSymbol;
    scanresult.Name:=Copy(Neuname,1,9);
 END;

BEGIN (* Scanner *)
 IF InputRec.C_ok
  THEN
   BEGIN
     WHILE InputRec.Z =' ' DO Lies;
     CASE InputRec.z OF
        '0'..'9','$': LiesWert;
        'A'..'Z',
        'a'..'z'    : LiesName;
        #0          : scanresult.BasicSymbol:=Endoftext_BS;
        '<'         : BEGIN
                         scanresult.BasicSymbol := Kleiner_BS; Lies;
                         IF InputRec.z='>' THEN BEGIN scanresult.BasicSymbol:=Ungleich_BS; Lies END
                                  ELSE IF InputRec.z='='
                                        THEN BEGIN scanresult.BasicSymbol:=Kleinergleich_BS;
                                                   Lies
                                             END
                      END;
        '>'         : BEGIN scanresult.BasicSymbol := Groesser_BS;  Lies;
                            IF InputRec.z='='
                              THEN BEGIN scanresult.BasicSymbol:=Groessergleich_BS; Lies END
                      END;
        ELSE BEGIN Case InputRec.z OF
                     #13,#10  : scanresult.BasicSymbol := Zeilenende_BS;
                     '?'      : scanresult.BasicSymbol := Print_BS;
                     ';'      : scanresult.BasicSymbol := Semikolon_BS;
                     '"'      : scanresult.BasicSymbol := Str_BS;
                     ','      : scanresult.BasicSymbol := Komma_BS;
                     '='      : scanresult.BasicSymbol := Gleich_BS;
                     '/'      : scanresult.BasicSymbol := Durch_BS;
                     '*'      : scanresult.BasicSymbol := Mal_BS;
                     '-'      : scanresult.BasicSymbol := Minus_BS;
                     '+'      : scanresult.BasicSymbol := Plus_BS;
                     ':'      : scanresult.BasicSymbol := Doppelpunkt_BS;
                     '('      : scanresult.BasicSymbol := Klammerauf_BS;
                     ')'      : scanresult.BasicSymbol := Klammerzu_BS;
                     '\'      : scanresult.BasicSymbol := Back_BS;
                     ELSE scanresult.BasicSymbol := unbekannt_BS;
                   END;
                   Lies
             END
     END
   END
   ELSE BEGIN scanresult.BasicSymbol:=unbekannt_BS; InputRec.z:=#0 END
END;

BEGIN END.

