{  19.10.96 Alf Anpassung DOS und Windows  }

UNIT COMMDOS; { Kommunikation mit Luxx und Lesen des Inputs }

INTERFACE

USES Luchstyp;

procedure INIT_SERIAL(BR: Word);
PROCEDURE Clear_Buffer(VAR b: Byte);
procedure PUT_Byte(ch:byte);
procedure PUT_word(w:Word);
PROCEDURE Put_Long(L: LongInt);
PROCEDURE Read_Byte_ohneHS(VAR b:byte; VAR Abbruch: Boolean);
PROCEDURE Read_Byte_HS(VAR b:byte; VAR Abbruch: Boolean);
PROCEDURE read_word_HS(VAR w: Word; VAR Abbruch: Boolean);
PROCEDURE Read_Long_HS(VAR L: LongInt; VAR Abbruch: Boolean);
FUNCTION  Read_Status: Byte;
PROCEDURE lies;
FUNCTION Next_Char:Char;
PROCEDURE ConvertReal(r:Real;VAR LuchsReal:T_LuchsReal);
PROCEDURE Lies_String(VAR X: String);
PROCEDURE Fehler(M : String);
FUNCTION HexZiffer(B:Byte):Char;
FUNCTION Hexbyte(B: Byte):Str4;
FUNCTION HexWord(Wert: Word): Str4;
FUNCTION HexLong(Wert: Longint): Str8;
PROCEDURE Sende_Block(B : T_CFeld; Anzahl : Word);
PROCEDURE Openinput(Filename,Compiler: String);
PROCEDURE Openinclude(Filename: String);
procedure CloseInput;
PROCEDURE Start_Kommunikation(VAR ok: Boolean);
PROCEDURE Rahmen(a,e: Integer);
PROCEDURE Show_Meldung;
PROCEDURE snd(w:Word);

IMPLEMENTATION

USES DOS, Crt,  GaugeDOS;

VAR RBR, THR, IER, IIR, LCR, MCR, LSR, MSR : Word; (* Modem Register *)

{ Input aus Quelldateien ---------------------------------------- }

PROCEDURE Rahmen(a,e: Integer);
VAR i : Integer;
BEGIN
Gotoxy(1,a);
Writeln
('Ŀ');
FOR i := a TO e DO
Writeln
('                                                                             ');
Writeln
('');
END;

PROCEDURE Show_Meldung;
VAR i : Integer;
BEGIN
  Rahmen (10,15);
  FOR i:=1 TO 6 DO
    BEGIN Gotoxy(3,10+i); write(InputRec.Meldung[i]); InputRec.Meldung[i]:='' END;
END;

PROCEDURE Openinput(Filename,Compiler: String);
VAR helpfile: File OF Byte;
    i: Word;
BEGIN
  assign(helpfile,Filename); Reset(HelpFile);
  InputRec.C_Ok:=Ioresult=0;
  IF InputRec.C_Ok THEN
    BEGIN InputRec.Quellgroesse:=Filesize(Helpfile);
          InputRec.Quellpos:=0;
          close(Helpfile);
          Assign(InputRec.Quell,Filename); Reset(InputRec.Quell);
    END;
  InputRec.Include   := false;
  InputRec.Dateiname :=Filename;
  InputRec.z         := ' ';
  InputRec.last.Satz := '';
  InputRec.last.ZNr  := 0;
  InputRec.last.INr  := 0;
  InputRec.last.Ptr  := 1;
  FOR i := 0 TO 2 DO InputRec.last.Txt[i] := '';
  for i := 1 to 6 do inputRec.meldung[i]:='';
  InputRec.Fehlermeldung:='Fehlermeldung nicht definiert';
  InitMainGauge(Compiler,Workfile.TName);
END;

PROCEDURE Openinclude(Filename: String);
VAR helpfile: File OF Byte;
    i: Word;
BEGIN
  assign(helpfile,Filename); Reset(HelpFile);
  InputRec.C_Ok:=Ioresult=0;
  IF InputRec.C_Ok THEN
    BEGIN InputRec.Inclgroesse:=Filesize(Helpfile);
          InputRec.Inclpos:=0;
          close(Helpfile);
          Assign(InputRec.Incl,Filename); Reset(InputRec.Incl);
    END;
  InputRec.Include   := True;
  InputRec.z         := ' ';
  InputRec.Last.Satz :='';
  InputRec.Last.Ptr  := 1;
  InputRec.Last.INr:=1;
  InitSubGauge(Filename);
END;

procedure CloseInput;
begin
  close(InputRec.Quell);
  exitmaingauge;
end;

PROCEDURE lies;

BEGIN
 IF InputRec.c_Ok
    THEN IF length(InputRec.last.Satz) >= InputRec.last.Ptr
	       THEN BEGIN InputRec.z := InputRec.last.Satz[InputRec.last.Ptr];Inc(InputRec.last.Ptr) END
	       ELSE BEGIN
		      InputRec.Last.Txt[2] := InputRec.last.Txt[1];
		      InputRec.Last.Txt[1] := InputRec.last.Txt[0];
		      InputRec.Last.Txt[0] := InputRec.last.Satz;
		      IF InputRec.Include
			 THEN IF Eof(InputRec.Incl)
				 THEN BEGIN InputRec.Include := false;
					    Close(InputRec.Incl);
                                            ExitSubGauge;
					    InputRec.Last.Ptr := 1; InputRec.Last.SAtz := ''; InputRec.z := #13;
				      END
				 ELSE BEGIN Readln(InputRec.Incl, InputRec.last.satz);
					    if (length(InputRec.Last.Satz) > 0) AND
                                                (inputrec.last.satz[length(inputrec.last.satz)]=#0)
                                               then inputrec.last.satz[length(inputrec.last.satz)]:=#13;
					    InputRec.z := #13; (* ' ' *);
                                            Inc(InputRec.InclPos, Length(InputRec.Last.Satz)+2);
                                            ShowSubGauge(InputRec.InclPos*100 div InputRec.InclGroesse);
					    InputRec.last.Ptr := 1;
					    Inc(InputRec.Last.INr);
				      END
			 ELSE IF Eof(InputRec.Quell)
				  THEN InputRec.z := #0
				  ELSE BEGIN Readln(InputRec.Quell, InputRec.last.satz);
					     InputRec.z := #13; (* ' ' *);
                                             Inc(InputRec.QuellPos, Length(InputRec.Last.Satz) + 2);
                                             ShowGauge(InputRec.QuellPos*100 div InputRec.QuellGroesse);
					     InputRec.Last.Ptr := 1;
					     Inc(InputRec.Last.ZNr);
				       END
		   END
	 ELSE InputRec.z := #0;
    IF inputRec.z = #9 THEN InputRec.z := #32
END;

FUNCTION Next_Char:Char;
BEGIN
  Next_Char := InputRec.last.satz[InputRec.last.ptr]
END;

PROCEDURE Print_Puffer(VAR Inp: T_Input);
var i: Integer;
BEGIN
  Inp.Meldung[5] := Inp.last.Satz;
  IF Inp.Last.ZNr > 1 THEN Inp.Meldung[4] := Inp.last.Txt[0];
  IF Inp.Last.ZNr > 2 THEN Inp.Meldung[3] := Inp.last.Txt[1];
  IF Inp.Last.ZNr > 3 THEN Inp.Meldung[2] := Inp.Last.Txt[2];
END;

PROCEDURE Lies_String(VAR X: String);
BEGIN
    X := '';
    WHILE (InputRec.z <> #39) AND not Eoln(InputRec.Quell)
      DO BEGIN X := X + InputRec.z;
               Lies
         END;
    IF EoLn(InputRec.Quell) AND (InputRec.z <> #39)
       THEN BEGIN InputRec.Meldung[1] :='String berschreitet Zeilenende';
                  InputRec.C_Ok := false
            END;
    Lies;
END;


PROCEDURE ConvertReal(r:Real;VAR LuchsReal:T_LuchsReal);
VAR i: Integer;
    Hilfexp: Real;
    NegFlag: Boolean;
BEGIN
  NegFlag:=r<0; r:= Abs(r);
  IF r > 0
    THEN BEGIN
            HilfExp:=ln(r)/ln(2)+1.00000006;
            IF Hilfexp<0 THEN Hilfexp:=Hilfexp-1;
            luchsReal[3]:=Lo(Trunc(Hilfexp));
            HilfExp:=Trunc(HilfExp);
            r:=128*(r/exp(HilfExp*ln(2))+6E-8);    (* letztes Bit runden *)
            Luchsreal[0]:=Trunc(r);
            IF NegFlag THEN LuchsReal[0]:=LuchsReal[0]+$80;
            r:=256*(r-trunc(r));
            LuchsReal[1]:=Trunc(r);
            r:=256*(r-Trunc(r));
            LuchsReal[2]:=Trunc(r)
         END
  ELSE FOR i:=0 TO 3 DO Luchsreal[i]:=0;
END;

PROCEDURE snd(w:Word);
BEGIN
  sound(w);
  delay(200);
  nosound
END;

{ Allgemeine Umwandlungsfunktionen ------------------------------ }

FUNCTION HexZiffer(B:Byte):Char;
BEGIN
  IF b<10 THEN HexZiffer:=Chr(B+48) ELSE HexZiffer:=Chr(B+55)
END;

FUNCTION Hexbyte(B: Byte):Str4;
BEGIN
   HexByte:=HexZiffer(B DIV 16)+HexZiffer(B AND $F)
END;

FUNCTION HexWord(Wert: Word): Str4;
BEGIN
   HexWord:=HexByte(Wert shr 8) + HexByte(Wert AND $FF);
END;

FUNCTION HexLong(Wert: Longint): Str8;
BEGIN
   HexLong:=HexWord(Wert shr 16) + HexWord(Wert AND $FFFF);
END;

{ Fehlerbehandlung ------------------------------------------- }

PROCEDURE Fehler(M : String);
VAR ZStr: String;
i:word;
BEGIN
  IF InputRec.C_Ok
     THEN BEGIN
             Print_Puffer(InputRec);
             IF InputRec.Include
                THEN BEGIN Str(InputRec.Last.INr, ZStr);
                           InputRec.Meldung[1] := 'Fehler in Zeile (Include): '+ ZStr;
                     END
                ELSE BEGIN Str(InputRec.Last.ZNr, ZStr);
                           InputRec.Meldung[1] := 'Fehler in Zeile : '+ ZStr;
                     END;
             InputRec.Meldung[6] :=  M;
             InputRec.C_ok := false
          END
END;

{ Bedienung der seriellen Schnittstelle ---------------------- }

FUNCTION Read_Status: Byte;
VAR R : Registers;
    S : Byte;
    i : Integer;
BEGIN
 IF SysInfo.Com >= 5
    THEN BEGIN
             R.AH := 3;
             R.DX := SysInfo.Com - 5;
             Intr($14,R);
             s:=R.AH
         END
    ELSE S := port[LSR];
 Read_Status:= s AND 1
END;

PROCEDURE Clear_Buffer(VAR b: Byte);
VAR R : Registers;
    ok: Boolean;
BEGIN
 ok:=True;
 IF Sysinfo.Com >= 5
    THEN WHILE Read_status = 1
          DO BEGIN
                    R.AH := 2;
                    R.DX := Sysinfo.Com - 5;
                    Intr($14,R);
             END
    ELSE WHILE Read_Status=1 DO b:= port[RBR];
end;

FUNCTION SSC: Boolean;     (* Shift Shift Control gedrueckt *)
Var R: Registers;
BEGIN R.AH:=2;
      Intr($16,R);
      ssc:= (R.AL AND 7 = 7)
END;

PROCEDURE Read_Byte_ohneHS(VAR b:byte; VAR Abbruch: Boolean);
VAR R : Registers;
BEGIN
 IF Sysinfo.Com >= 5
    THEN BEGIN
           REPEAT
             R.AH := 2;
             R.DX := Sysinfo.Com - 5;
             Intr($14,R);
             Abbruch:=SSC;
           UNTIL (R.AH = 0) OR Abbruch;
           b := R.AL;
         END
    ELSE BEGIN REPEAT Abbruch:=SSC UNTIL (PORT[LSR] AND $01 <>0) OR Abbruch;
               b:= port[RBR];
         END
end;



procedure INIT_SERIAL(BR: Word);
VAR R      : Registers;
    Base   : Word;
    dummy  : Byte;
    hr,min,sek,sekh1,sekH2: Word;
BEGIN
  IF SysInfo.Com = 3
     THEN Base := $3E0
     ELSE IF SysInfo.com=4 THEN Base := $2E0
     ELSE IF SysInfo.com=1 THEN Base := $3F0  (* wie Com1 *)
     ELSE IF SysInfo.com=2 THEN Base := $2F0; (* wie Com2 *)
  RBR := Base + $8;    (* Receiver Buffer Register *)
  THR := Base + $8;    (* Transmitter Holding Register *)
  IER := Base + $9;    (* Interrupt Enable Register *)
  IIR := Base + $A;    (* Interrupt Identification Register *)
  LCR := Base + $B;    (* Line Control Register *)
  MCR := Base + $C;    (* Modem Control Register *)
  LSR := Base + $D;    (* Line Status Register *)
  MSR := Base + $E;    (* Modem Status Register *)
  port[LCR] := 00;     (* Empfangsregister erreichen *)
  port[LCR] := $80;    (* Set Divisor Latch Adress Bit (DLAB) *)
  port[THR] := lo(BR); (* Set Divisor Low Byte (Baudrate) *)
  port[IER] := hi(BR); (* Set Divisor High Byte *)
  port[LCR] := $03;    (* 8 Databits, 1 Stopbit, No Parity, Reset DLAB *)
  port[IER]:=  $00;    (* keine Interrupts *)
  port[MCR]:=  $03;    (* DTR und RTS auf High *)
  GetTime(Hr,Min,Sek,SekH1);
  REPEAT GetTime(Hr,Min,Sek,SekH2) UNTIL SekH1<>SekH2;
  REPEAT GetTime(Hr,Min,Sek,SekH1) UNTIL SekH1<>SekH2;
 end;

procedure PUT_Byte(ch:byte);
VAR R : Registers;
    i : Integer;
BEGIN
 IF SysInfo.Com >= 5
    THEN BEGIN
             R.AH := 1; R.AL := ch;
             R.DX := SysInfo.Com - 5;
             Intr($14,R)
         END
    ELSE BEGIN port[THR] :=  ch;    (* Zeichen senden und warten bis es raus ist *)
               REPEAT  UNTIL Port[LSR] AND $20 = $20
         END
end;

PROCEDURE Read_Byte_HS(VAR b:byte; VAR Abbruch: Boolean);
BEGIN
  Read_Byte_ohneHS(b,Abbruch);
  IF NOT Abbruch THEN put_Byte(b)
END;

PROCEDURE read_word_HS(VAR w: Word; VAR Abbruch: Boolean);
VAR h,l: Byte;
BEGIN
  read_Byte_HS(h,Abbruch); Read_Byte_HS(l,Abbruch);
  w:=Word(h shl 8) + l
END;

PROCEDURE Read_Long_HS(VAR L: LongInt; VAR Abbruch: Boolean);
VAR wh,wl : Word;
BEGIN
  Read_Word_HS(wh,Abbruch); Read_Word_HS(wl,Abbruch);
  L :=wh * $10000 + wl;
END;

procedure PUT_word(w:Word);
begin
 Put_Byte(hi(w)); Put_Byte(lo(w))
end;

PROCEDURE Put_Long(L: LongInt);
BEGIN
  Put_Word(L shr 16); Put_Word(L AND $FFFF)
END;

PROCEDURE Sende_Block(B : T_CFeld; Anzahl : Word);
  VAR  j : Word;
  BEGIN
         Put_Byte(Bef_SetByte);
         Put_Byte(Anzahl);
         FOR j := 0 TO Anzahl DO Put_Byte(B[j])
  END;

PROCEDURE Start_Kommunikation(VAR ok: Boolean);
VAR Block     : T_CFeld;
    b         : Byte;
    i         : Integer;
    BR        : Word;
    Abbruch   : Boolean;

    FUNCTION FF_gefunden(VAR BR: Word):Boolean;
    VAR   hr,min,sek,sekh,sekHSeek: Word;
          Abbruch,gefunden,fertig : Boolean;
          b: Byte;
    BEGIN
     GetTime(Hr,Min,Sek,SekH);
     fertig:=False; b:=55;
     SekHSeek:=SekH+40; IF SekHSeek >= 100 THEN Dec(SekHSeek,100);
     WHILE (Abs(SekHSeek-SekH)>=10) AND (Not fertig) DO
        BEGIN IF Read_Status=$01 THEN Read_Byte_ohneHS(b,Abbruch)
                                 ELSE Gettime(Hr,Min,Sek,SekH);
              fertig:=True;
              IF      b=$FF THEN BEGIN BR:=BR115200; Sysinfo.Baudrate:='115200 Bd' END
              ELSE IF b=$FE THEN BEGIN BR:=BR57600;  Sysinfo.Baudrate:='57600 Bd' END
              ELSE IF b=$FC THEN BEGIN BR:=BR38400;  Sysinfo.Baudrate:='38400 Bd' END
              ELSE IF b=$E0 THEN BEGIN BR:=BR19200;  Sysinfo.Baudrate:='19200 Bd' END
              ELSE fertig:=False;
        END;
     FF_Gefunden:=fertig;
    END;

    FUNCTION Byte_gefunden(Such:Byte):Boolean;
    VAR   hr,min,sek,sekh,sekHSeek: Word;
          Abbruch,gefunden,fertig : Boolean;
          b: Byte;
    BEGIN
     GetTime(Hr,Min,Sek,SekH);
     fertig:=False; b:=55;
     SekHSeek:=SekH+40; IF SekHSeek >= 100 THEN Dec(SekHSeek,100);
     WHILE (Abs(SekHSeek-SekH)>=10) AND (Not fertig) DO
        BEGIN IF Read_Status=$01 THEN BEGIN Read_Byte_ohneHS(b,Abbruch);
                                            {write(' b=',b)}
                                      END
                                 ELSE Gettime(Hr,Min,Sek,SekH);
              Fertig:=b=Such;
        END;
     Byte_Gefunden:=fertig;
    END;

BEGIN
  Init_serial(BR115200);
  while Read_Status=$01 DO Read_Byte_ohneHS(b,Abbruch); (* Puffer leeren  *)
  ok:=FF_gefunden(BR); SysInfo.Baud:=BR;
  IF ok THEN Init_Serial(BR);
  ok:=Byte_gefunden($FF);                  (* ein Byte $FF lesen   *)
  IF ok THEN ok:=Byte_gefunden($FF);       (* zweites $FF lesen    *)
  IF ok THEN Put_Byte($CB);                (* jetzt anklingeln     *)
  IF ok THEN ok:=Byte_Gefunden(0);         (* Byte $00 erwarten    *)
  IF NOT ok THEN InputRec.Meldung[3]:='keine Kontaktaufnahme zum LUCHS mglich'
            ELSE Put_Byte(0);              (* Byte $00 quittieren  *)
END;



BEGIN END.
