
{   25.02.96 A+H Neuentwicklung fr DLLs   }

UNIT Commwin;

INTERFACE

USES Luchstyp,
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus;

procedure INIT_SERIAL(BR:Word;VAR ok: Boolean);
procedure exit_serial;
procedure PUT_Byte(ch:byte);
procedure PUT_word(w:Word);
PROCEDURE Put_Long(L: LongInt);
PROCEDURE Read_Byte(VAR b:byte; VAR Abbruch: Boolean);
PROCEDURE Read_Byte_HS(VAR b:byte; VAR Abbruch: Boolean);
PROCEDURE Read_Byte_Slave(VAR b:byte; VAR Abbruch: Boolean);
PROCEDURE read_word(VAR w: Word; VAR Abbruch: Boolean);
PROCEDURE Read_Long(VAR L: LongInt; VAR Abbruch: Boolean);
PROCEDURE Read_Long_HS(VAR L: LongInt; VAR Abbruch: Boolean);
FUNCTION  SerByte_da: Boolean;
PROCEDURE Start_Kommunikation(VAR ok: Boolean; VAR Fehler: String);
PROCEDURE Openinput(Filename,Compiler: String);
PROCEDURE Openinclude(Filename: String);
procedure CloseInput;
PROCEDURE lies;
FUNCTION Next_Char:Char;
PROCEDURE ConvertReal(r:Real;VAR LuchsReal:T_LuchsReal);
PROCEDURE Lies_String(VAR X: String);
PROCEDURE Fehler(M : String);
FUNCTION HexZiffer(B:Byte):Char;
FUNCTION Hexbyte(B: Byte):Str4;
FUNCTION HexWord(Wert: Word): Str4;
FUNCTION HexLong(Wert: Longint): Str8;
PROCEDURE Sende_Block(B : T_CFeld; Anzahl : Word);
function shortname(name: T_Filename):T_Filename;
procedure snd(w:word);

IMPLEMENTATION

uses gaugWin;

CONST Receive_Puffer=1000; Transmit_Puffer=1000;
VAR Com_CID: Integer;
    RBR, THR, IER, IIR, LCR, MCR, LSR, MSR : Word; (* Modem Register *)


procedure snd(w:word);
begin end;

function shortname(name: T_Filename):T_Filename;
begin
   while pos('\',Name)>0 do
      name:=Copy(Name,pos('\',Name)+1,length(Name)-pos('\',Name));
   Shortname:=Name
end;

{ Input aus Quelldateien ---------------------------------------- }


PROCEDURE Openinput(Filename,Compiler: String);
VAR helpfile: File OF Byte;
    i: Word;
BEGIN
  assign(helpfile,Filename); Reset(HelpFile);
  InputRec.C_Ok:=Ioresult=0;
  IF InputRec.C_Ok THEN
    BEGIN InputRec.Quellgroesse:=Filesize(Helpfile);
          InputRec.Quellpos:=0;
          close(Helpfile);
          Assign(InputRec.Quell,Filename); Reset(InputRec.Quell);
    END;
  InputRec.Include   := false;
  InputRec.Dateiname :=Filename;
  InputRec.z         := ' ';
  InputRec.last.Satz := '';
  InputRec.last.ZNr  := 0;
  InputRec.last.INr  := 0;
  InputRec.last.Ptr  := 1;
  FOR i := 0 TO 2 DO InputRec.last.Txt[i] := '';
  for i := 1 to 6 do InputRec.meldung[i]:='';
  InputRec.Fehlermeldung:='Fehlermeldung nicht definiert';
  InitMainGauge(Compiler,Workfile.TName);
END;

PROCEDURE Openinclude(Filename: String);
VAR helpfile: File OF Byte;
    i: Word;
BEGIN
  assign(helpfile,Filename); Reset(HelpFile);
  InputRec.C_Ok:=Ioresult=0;
  IF InputRec.C_Ok THEN
    BEGIN InputRec.Inclgroesse:=Filesize(Helpfile);
          InputRec.Inclpos:=0;
          close(Helpfile);
          Assign(InputRec.Incl,Filename); Reset(InputRec.Incl);
    END;
  InputRec.Include   := True;
  InputRec.z         := ' ';
  InputRec.Last.INr:=1;
  InputRec.Last.Satz :='';
  InputRec.Last.Ptr := 1;
  InitSubGauge(Workfile.TName);
END;

procedure CloseInput;
begin
  close(InputRec.Quell);
  exitmaingauge;
end;

PROCEDURE Print_Puffer;
var i: Integer;
BEGIN
  for i:=2 to 4 do InputRec.meldung[i]:='';
  InputRec.Meldung[5] := InputRec.last.Satz;
  IF InputRec.Last.ZNr > 1 THEN InputRec.Meldung[4] := InputRec.last.Txt[0];
  IF InputRec.Last.ZNr > 2 THEN InputRec.Meldung[3] := InputRec.last.Txt[1];
  IF InputRec.Last.ZNr > 3 THEN InputRec.Meldung[2] := InputRec.Last.Txt[2];
END;

PROCEDURE lies;
var i: word;
BEGIN
 IF InputRec.c_Ok
    THEN IF length(InputRec.last.Satz) >= InputRec.last.Ptr
	       THEN BEGIN InputRec.z := InputRec.last.Satz[InputRec.last.Ptr];
                          Inc(InputRec.last.Ptr);
                    END
	       ELSE BEGIN
		      InputRec.Last.Txt[2] := InputRec.last.Txt[1];
		      InputRec.Last.Txt[1] := InputRec.last.Txt[0];
		      InputRec.Last.Txt[0] := InputRec.last.Satz;
                      Print_puffer;
		      IF InputRec.Include
			 THEN IF Eof(InputRec.Incl)
				 THEN BEGIN InputRec.Include := false;
					    Close(InputRec.Incl);
                                            ExitSubGauge;
                                            InputRec.Last.Ptr := 1;
                                            InputRec.Last.Satz := ' ';
                                            Inputrec.z:=#13;
					    {lies}
				      END
				 ELSE BEGIN Readln(InputRec.Incl, InputRec.last.satz);
                                            IF (length(InputRec.Last.Satz)>0)
                                               and (inputrec.last.satz[length(inputrec.last.satz)]=#0)
                                               then inputrec.last.satz[length(inputrec.last.satz)]:=#13;
					    InputRec.InclPos:=InputRec.Inclpos
                                                     +length(InputRec.Last.Satz)+2;
                                            IF GetTickCount and $1 =0
                                               THEN UpdateMaingauge(InputRec.InclPos*100 div InputRec.InclGroesse);
                                            InputRec.z := #13; (* ' ' *);
					    InputRec.last.Ptr := 1;
					    Inc(InputRec.Last.INr);
				      END
			 ELSE
			       IF Eof(InputRec.Quell)
				  THEN InputRec.z := #0
				  ELSE BEGIN Readln(InputRec.Quell, InputRec.last.satz);
                                             InputRec.QuellPos:=InputRec.Quellpos
                                                     +Length(InputRec.Last.Satz)+2;
                                             IF GetTickCount and $7 =0
                                               THEN UpdateMaingauge(InputRec.QuellPos*100 div InputRec.QuellGroesse);
					     InputRec.z := #13; (* ' ' *);
					     InputRec.Last.Ptr := 1;
					     Inc(InputRec.Last.ZNr);
				       END
		   END
	 ELSE begin InputRec.z := #0; {luchs_info('0 am Ende von lies')} end
END;

FUNCTION Next_Char:Char;
BEGIN
  Next_Char := InputRec.last.satz[InputRec.last.ptr]
END;


PROCEDURE Lies_String(VAR X :String);
BEGIN
    X := '';
    WHILE (InputRec.z <> #39) AND (InputRec.z <> #13) {not Eoln(InputRec.Quell)}
      DO BEGIN X := X + InputRec.z;
               Lies
         END;
    IF (inputRec.z = #13) {EoLn(InputRec.Quell) AND (InputRec.z <> #39)}
       THEN BEGIN InputRec.Meldung[1] :='String ueberschreitet Zeilenende';
                  InputRec.C_Ok := false
            END;
    Lies;
END;



PROCEDURE ConvertReal(r:Real;VAR LuchsReal:T_LuchsReal);
VAR i: Integer;
    Hilfexp: Real;
    NegFlag: Boolean;
BEGIN
  NegFlag:=r<0; r:= Abs(r);
  IF r > 0
    THEN BEGIN
            HilfExp:=ln(r)/ln(2)+1.00000006;
            IF Hilfexp<0 THEN Hilfexp:=Hilfexp-1;
            luchsReal[3]:=Lo(Trunc(Hilfexp));
            HilfExp:=Trunc(HilfExp);
            r:=128*(r/exp(HilfExp*ln(2))+6E-8);    (* letztes Bit runden *)
            Luchsreal[0]:=Trunc(r);
            IF NegFlag THEN LuchsReal[0]:=LuchsReal[0]+$80;
            r:=256*(r-trunc(r));
            LuchsReal[1]:=Trunc(r);
            r:=256*(r-Trunc(r));
            LuchsReal[2]:=Trunc(r)
         END
  ELSE FOR i:=0 TO 3 DO Luchsreal[i]:=0;
END;

{ Allgemeine Umwandlungsfunktionen ------------------------------ }

FUNCTION HexZiffer(B:Byte):Char;
BEGIN
  IF b<10 THEN HexZiffer:=Chr(B+48) ELSE HexZiffer:=Chr(B+55)
END;

FUNCTION Hexbyte(B: Byte):Str4;
BEGIN
   HexByte:=HexZiffer(B DIV 16)+HexZiffer(B AND $F)
END;

FUNCTION HexWord(Wert: Word): Str4;
BEGIN
   HexWord:=HexByte(Wert shr 8) + HexByte(Wert AND $FF);
END;

FUNCTION HexLong(Wert: Longint): Str8;
BEGIN
   HexLong:=HexWord(Wert shr 16) + HexWord(Wert AND $FFFF);
END;

{ Fehlerbehandlung ------------------------------------------- }

PROCEDURE Fehler(M : String);
VAR ZStr: String;
BEGIN
  IF InputRec.C_Ok
     THEN BEGIN
             Print_Puffer;
             IF InputRec.Include
                THEN BEGIN Str(InputRec.Last.INr, ZStr);
                           InputRec.Meldung[1] := 'Fehler in/vor Zeile (Include): '+ ZStr;
                           InputRec.FehlerMeldung := 'Fehler in/vor Zeile (Include): '+ ZStr;
                     END
                ELSE BEGIN Str(InputRec.Last.ZNr, ZStr);
                           InputRec.Meldung[1] := 'Fehler in/vor Zeile : '+ ZStr;
                           InputRec.Fehlermeldung:= 'Fehler in/vor Zeile : '+ ZStr;
                     END;
             InputRec.Meldung[6] :=  M;
             InputRec.C_ok := false
          END;
END;

{ Bedienung der seriellen Schnittstelle ---------------------- }

FUNCTION Serbyte_da: boolean;
var ComStat: TComStat;
BEGIN
  IF SysInfo.Win_seriell
     THEN BEGIN GetCommError(Com_CID,ComStat);
                serbyte_da:=ComStat.cbInQue > 0
          END
     ELSE  SerByte_da:= ((port[LSR] AND 1) = 1)
END;

(* kann durch ssc abgebrochen werden *)

PROCEDURE Read_Byte(VAR b:byte; VAR Abbruch: Boolean);
VAR Startzeit: Real;
    Anzahl: Integer;
    Buf: ARRAY[0..1] OF Char;
    ok: Boolean;
BEGIN
  Startzeit:=Time;
  REPEAT
    Abbruch:=(Time-Startzeit> 1E-4)
  UNTIL SerByte_da OR Abbruch;
  IF Sysinfo.Win_Seriell
     THEN BEGIN Anzahl:=ReadComm(Com_CID,Buf,1);
                b:= ord(Buf[0]);
          END
     ELSE b:= port[RBR];
{
  Startzeit:=Time;
  REPEAT
    Anzahl:=ReadComm(Com_CID,Buf,1);
    Abbruch:=(Time-Startzeit> 1E-4) OR (Shiftstate AND $7=$7)
  UNTIL (Anzahl=1) OR Abbruch;
  b:= ord(Buf[0]);
}
end;


PROCEDURE Puffer_leeren;
VAR Dummy: Word;
    Buf: ARRAY[0..1] OF Char;
BEGIN
  while SerByte_da DO
    IF Sysinfo.Win_Seriell
       THEN Dummy:=ReadComm(Com_CID,Buf,1)
       ELSE Dummy:= port[RBR];
end;

procedure PUT_Byte(ch:byte);
var erg       : word;
    Buf       : Array[0..1] OF Char;
    ComStat   : TComStat;
BEGIN
  IF SysInfo.Win_Seriell
     THEN BEGIN
            REPEAT GetCommError(Com_CID,ComStat);
            UNTIL (ComStat.cbOutQue = 0);
            Buf[0]:=Chr(ch);
            Erg:=WriteComm(Com_Cid,Buf,1);
          END
     ELSE BEGIN
            REPEAT
            UNTIL (Port[LSR] AND $20 = $20) ;
            port[THR] :=  ch;
          END;
end;

procedure PUT_Byte_HS(b:byte);
var erg       : word;
    Buf       : Array[0..1] OF Char;
    ComStat   : TComStat;
    Abbruch   : Boolean;
BEGIN
  IF SysInfo.Win_Seriell
     THEN BEGIN
            Buf[0]:=Chr(b);
            Erg:=WriteComm(Com_Cid,Buf,1);
          END
     ELSE BEGIN
            port[THR] := b;
          END
end;

procedure exit_serial;
VAR ComStat: TComStat;
    Abbruch: Boolean;
    b: Byte;
BEGIN
  Put_Byte(Bef_Quit);
  Put_Byte(Bef_Quit);
  Put_Byte(Bef_Quit);
  IF SysInfo.Win_Seriell THEN CloseComm(Com_Cid);
END;

procedure INIT_SERIAL_Win(VAR ok: Boolean);
VAR DCB: TDCB;            (* mit fester Baudrate 38400 *)
    Result: Integer;
    ComStr: String;
    ComPChar: ARRAY[0..10] OF Char;
begin
  ComStr:='COM'+Chr($30+Sysinfo.COM);
  StrPCopy(ComPChar,ComStr);
  Com_CID:=OpenComm(ComPChar,Receive_Puffer,Transmit_Puffer);
{luchs_dialog('Opencomm, CID=',com_cid);       }
  ok:=Com_CID >= 0;
  IF ok THEN
   BEGIN result:=GetCommState(Com_CID,DCB);
{luchs_dialog('GetCommState, Result',result);}
         ok:=Result=0;
         DCB.BaudRate:=CBR_38400; (* CBR_38400?? *)
         DCB.ByteSize:=8;
         DCB.Parity:=NoParity;
         DCB.StopBits:=OneStopBit;
         IF ok THEN ok:=(SetCommState(DCB)=0);
{luchs_dialog('SetCommState, Result',result);}
         IF ok THEN BEGIN FlushComm(Com_CID,0); FlushComm(Com_CID,1) END;
             (* Puffer leeren *)
   END;
end;

(* Kommunikation auf Registerebene *)
procedure INIT_SERIAL_Reg(BR: Word; VAR ok: Boolean);
VAR Base   : Word;
    dummy  : Byte;
begin
{Luchs_dialog('Serinit mit COM'+chr($30+SysInfo.COM),0);}
  IF SysInfo.Com = 3
     THEN Base := $3E0
     ELSE IF SysInfo.com=4 THEN Base := $2E0
     ELSE IF SysInfo.com=1 THEN Base := $3F0  (* wie Com1 *)
     ELSE IF SysInfo.com=2 THEN Base := $2F0; (* wie Com2 *)
  RBR := Base + $8;    (* Receiver Buffer Register *)
  THR := Base + $8;    (* Transmitter Holding Register *)
  IER := Base + $9;    (* Interrupt Enable Register *)
  IIR := Base + $A;    (* Interrupt Identification Register *)
  LCR := Base + $B;    (* Line Control Register *)
  MCR := Base + $C;    (* Modem Control Register *)
  LSR := Base + $D;    (* Line Status Register *)
  MSR := Base + $E;    (* Modem Status Register *)
  port[LCR] := 00;     (* Empfangsregister erreichen *)
  port[LCR] := $80;    (* Set Divisor Latch Adress Bit (DLAB) *)
  port[THR] := lo(BR); (* Set Divisor Low Byte (Baudrate) *)
  port[IER] := hi(BR); (* Set Divisor High Byte *)
  port[LCR] := $03;    (* 8 Databits, 1 Stopbit, No Parity, Reset DLAB *)
  port[IER]:=  $00;    (* keine Interrupts *)
  port[MCR]:=  $03;    (* DTR und RTS auf High *)
end;

procedure INIT_SERIAL(BR:Word; VAR ok: Boolean);
BEGIN
  IF SysInfo.Win_Seriell
     THEN INIT_SERIAL_Win(ok)      (* nur 38400 Baud erlaubt *)
     ELSE Init_Serial_Reg(BR,ok)
END;

PROCEDURE read_word(VAR w: Word; VAR Abbruch: Boolean);
VAR h,l: Byte;
BEGIN
  read_Byte(h,Abbruch); Read_Byte(l,Abbruch);
  w:=Word(h shl 8) + l
END;

PROCEDURE Read_Long(VAR L: LongInt; VAR Abbruch: Boolean);
VAR wh,wl : Word;
BEGIN
  Read_Word(wh,Abbruch); Read_Word(wl,Abbruch);
  L :=wh * $10000 + wl;
END;

PROCEDURE Read_Byte_HS(VAR b:byte; VAR Abbruch: Boolean);
BEGIN
  Read_Byte(b,Abbruch);
  {IF not globVar.Host_ist_Slave then} put_Byte(b)
END;

(* Read_Byte_Slave kann durch ssc abgebrochen werden *)

PROCEDURE Read_Byte_Slave(VAR b:byte; VAR Abbruch: Boolean);
BEGIN
  Abbruch := false;
  REPEAT
  UNTIL SerByte_da;
  Read_Byte(b,abbruch); put_Byte(b)
END;

procedure PUT_word(w:Word);
begin
 Put_Byte(hi(w)); Put_Byte(lo(w))
end;

PROCEDURE Put_Long(L: LongInt);
BEGIN
  Put_Word(L shr 16); Put_Word(L AND $FFFF)
END;

PROCEDURE Sende_Block(B : T_CFeld; Anzahl : Word);
  VAR  j : Word;
  BEGIN
         Put_Byte(Bef_SetByte);
         Put_Byte(Anzahl);
         FOR j := 0 TO Anzahl DO Put_Byte(B[j])
  END;

PROCEDURE Read_Long_HS(VAR L: Longint; VAR Abbruch: Boolean);
VAR i,b: Byte;
BEGIN
 L:=0;
 FOR i:=1 TO 4 DO
  BEGIN Read_Byte_HS(B,Abbruch);L:=L shl 8 +b END;
END;

PROCEDURE Start_Kommunikation(VAR ok: Boolean; VAR Fehler: String);
VAR Block     : T_CFeld;
    b         : Byte;
    i         : Integer;
    Abbruch   : Boolean;
    br        : Word;

    PROCEDURE Pause;
    VAR   Startzeit: Real;
    BEGIN
     Startzeit:=Time;
     REPEAT UNTIL (Time-Startzeit > 1E-7)
    END;

    FUNCTION Byte_gefunden(Such:Byte):Boolean;
    VAR   Startzeit,Zeit: Real;
          Abbruch,gefunden,fertig : Boolean;
          b: Byte;
    BEGIN
     Startzeit:=Time;
     fertig:=False;
     WHILE (Time-Startzeit < 1E-7) AND (Not fertig) DO
        IF SerByte_da
           THEN BEGIN Read_Byte(b,Abbruch);
                      Fertig:=b=Such;
                END;
     Byte_Gefunden:=fertig;
    END;

    FUNCTION FF_gefunden(VAR BR: Word):Boolean;
    VAR   Startzeit: Real;
          Abbruch,gefunden,fertig : Boolean;
          b: Byte;
    BEGIN
     Startzeit:=Time;
     fertig:=False; b:=55;
     WHILE (Time-Startzeit<1E-6) AND (Not fertig) DO
        BEGIN IF SerByte_da THEN Read_Byte(b,Abbruch);
              fertig:=True;
              IF      b=$FF THEN BEGIN BR:=BR115200; Sysinfo.Baudrate:='115200 Bd' END
              ELSE IF b=$FE THEN BEGIN BR:=BR57600;  Sysinfo.Baudrate:='57600 Bd' END
              ELSE IF b=$FC THEN BEGIN BR:=BR38400;  Sysinfo.Baudrate:='38400 Bd' END
              ELSE IF b=$E0 THEN BEGIN BR:=BR19200;  Sysinfo.Baudrate:='19200 Bd' END
              ELSE fertig:=False;
        END;
     FF_Gefunden:=fertig;
END;


BEGIN
  Sysinfo.Baudrate:='38400 Bd';
  IF SysInfo.Win_Seriell THEN BR:=38400 ELSE BR:=BR115200;
  Init_serial(BR,ok); Pause;
  Puffer_leeren;
  IF SysInfo.Win_Seriell
     THEN ok:=True
     ELSE BEGIN ok:=FF_gefunden(BR); SysInfo.Baud:=BR;
                IF ok THEN BEGIN Init_serial(BR,ok); Pause END;
          END;
  IF not ok
    THEN Fehler:='Schnittstelle COM'+chr($30+Sysinfo.Com)+' belegt oder nicht verfgbar'
    ELSE BEGIN
            {
            while Read_Status=$01 DO Read_Byte(b,Abbruch); (* Puffer leeren  *)
            }
            ok:=Byte_gefunden($FF);                  (* ein Byte $FF lesen   *)
            IF ok THEN ok:=Byte_gefunden($FF);       (* zweites $FF lesen    *)
            IF ok THEN Put_Byte($CB);                (* jetzt anklingeln     *)
            IF ok THEN ok:=Byte_Gefunden(0);         (* Byte $00 erwarten    *)
            IF NOT ok THEN BEGIN Fehler:='Luchs meldet sich nicht';
                                 exit_Serial;
                           END
                      ELSE Put_Byte(0);              (* Byte $00 quittieren *)
         END;
END;

END.

