PROGRAM HitachiSH_7000_System;

{   19.10.96 Alf Gemeinsame Version fuer Windows und DOS}

USES Crt, Dos, FlashDos,EpromDos,
     LuchsTyp, CommDOS, EditDOS, FileDOS, MoniDOS, Pas7000, Bas7000,ass7000;

CONST Version = '[1.2]';

{ hier neu, damit die anderen Units keine Ausgaben machen }

PROCEDURE Titel;
VAR i: Integer;

  PROCEDURE Write_WFilename;
  BEGIN
     Gotoxy(2,4); Write('[Text : ');
     IF Workfile.WText THEN Write(Workfile.TName,']') ELSE Write('<leer>]');
     Gotoxy(2,5); Write('[Code : ');
     IF Workfile.WCode THEN Write(Workfile.CName,']') ELSE Write('<leer>]');
     Gotoxy(78,2)
  END;

BEGIN
  ClrScr; HighVideo;
  Rahmen(1,4); Gotoxy(2,2);
  Write('Luchs: Edit  Pascal  Basic  Ass  Mon  eXe  flaSh  File  epRom Quit ',Version);
  Write_WFilename;
  Show_Meldung;
  Gotoxy(78,2)
END;

PROCEDURE Init(VAR W: T_WorkFile);
BEGIN
  W.WText  := false;
  W.WCode  := false;
  W.TFehler:= 1;
END;

PROCEDURE Init_sys;

  PROCEDURE Read_SysInfo(VAR F : Text; Var Pfad: String);
  VAR c : Char;
      x : LongInt;
      w,s : String;
      code,i : Integer;
  BEGIN
    WHILE not Eof(F) DO
      BEGIN
         w := '';
         Read(f,c);
         WHILE (c<>' ') AND (c <> '=') AND not EOF(F) AND (c <>#13) DO
             BEGIN w := w + upcase(c); Read(F,c) END;
         WHILE (c<>'=') AND not eof(F) DO Read(F,c);
         IF not eof(F) THEN Readln(F,s);
         FOR i:=1 to Length(s) DO s[i]:=Upcase(s[i]);
         Val(s,x, code);
         WHILE s[1] = ' ' DO Delete(S,1,1);
       IF (w<> '') AND (w<>'REM') THEN
         IF code = 0
            THEN IF w = 'COM' THEN SysInfo.Com := x
                    ELSE IF w = 'SPEED'   THEN SysInfo.Speed      := x
                    ELSE IF w = 'CODE'    THEN SysInfo.CodeStart  := x
                    ELSE IF w = 'EPROM'   THEN SysInfo.EpromStart := x
                    ELSE InputRec.Meldung[5]:='unbekannter Befehl <'+w+'> in LuchsInfo'
                    ELSE IF w = 'PFAD'    THEN Pfad:= s
                    ELSE IF w = 'EDITOR'  THEN SysInfo.Editorname:= s
                    ELSE IF w = 'SYS'     THEN SysInfo.Sysname:= s
                    ELSE InputRec.Meldung[5]:='unbekannter Befehl <'+w+'> in LuchsInfo'
      END;
  END;

VAR F     : Text;
    Param, Pfad, Name, Ext  : String;
BEGIN                              (* Standardwerte :      *)
  Sysinfo.Com        := 2;             (* Schnittstelle = COM1 *)
  SysInfo.CodeStart  := $2004000;      (* Code ab  2004000     *)
{  SysInfo.Varstart   := $2008000;}
  SysInfo.Speed      := 16000000;      (* 16 MHz Quarz          *)
  SysInfo.Epromstart := $10000;
  Pfad := '';
  Param := ParamStr(0);
  FSplit(Param, Pfad, Name, Ext);
  SysInfo.SysName    :=Pfad+'SYSLUCHS.MCD';
  Assign(F, Pfad + 'LUCHSINF.MTX');
  Reset(F);
  IF Ioresult = 0 THEN BEGIN Read_sysInfo(F, Pfad);
                             Close(F)
                       END;
  SysInfo.Editorname  := '';
END;

FUNCTION Get_Befehl: Char;
BEGIN
  Get_Befehl := Upcase(Readkey)
END;

  PROCEDURE Erweitere_DOS_Speicher;
   VAR Regs : Registers;
       PtrtoHeap : Word;
   BEGIN
   (*
     PtrtoHeap := Seg(HeapPtr^);
     Regs.ah := $4A;
     Regs.es := PrefixSeg;
     Regs.bx := PtrtoHeap + 1 - PrefixSeg;
     MsDos(Regs)
   *)
   END;

   PROCEDURE Reduziere_DOS_Speicher;
   VAR Regs : Registers;
       EndofHeap : Word;
   BEGIN
   (*
     EndofHeap := Seg(HeapEnd^);
     Regs.ah := $4A;
     Regs.es := PrefixSeg;
     Regs.bx := EndofHeap - PrefixSeg;
     MsDos(Regs)
   *)
   END;


VAR Ende,MonStart: Boolean;
    ch       : Char;
    i        : Integer;
    ToH      : Pointer;
BEGIN
  GetDir(0,Startdir);
  CheckBreak:=True;
  Ende := False;
  FOR i:=1 TO 6 DO InputRec.Meldung[i]:='';
  Init(Workfile);
  Init_sys;
  InputRec.Meldung[3] := '          Copyright Himmerder, Wenzel und Toschke 1997';
  REPEAT
    Titel;
    CASE Get_Befehl OF
      'E'  : BEGIN IF not Workfile.WText
                      THEN Filer('Welches Textfile editieren ?',1, Workfile);
                   IF Workfile.WText
                      THEN  IF SysInfo.Editorname = ''
                                    THEN Edit(Workfile)
                                    ELSE BEGIN Erweitere_DOS_Speicher; SwapVectors;
                                               Exec(SysInfo.Editorname,Workfile.TName);
                                               SwapVectors; Reduziere_DOS_Speicher;
                                         END;
                   IF Copy(Workfile.TName,Length(Workfile.TName)-11,12)
                      ='LUCHSINF.MTX'
                      THEN Init_Sys
             END;
      'P'  : BEGIN IF not Workfile.WText
                      THEN BEGIN Filer('Welches Pascal-Textfile compilieren ?',1, Workfile);
                                 Titel
                           END;
                   IF WorkFile.WText THEN Pascal
             END;

      'A'  : BEGIN IF not Workfile.WText
                      THEN BEGIN Filer('Welches Textfile assemblieren ?',1, Workfile);
                                 Titel
                           END;
                   IF Workfile.WText THEN Assemble;
             END;
      'B'  : BEGIN IF not Workfile.WText
                      THEN BEGIN Filer('Welches Basic-Textfile bersetzen ?',1, Workfile);
                                 Titel
                           END;
                   IF Workfile.WText THEN Basic
             END;
      'M'  : Monitor;
      'X'  : BEGIN IF not Workfile.WCode
                      THEN BEGIN Filer('Welches Codefile starten ?',-1, Workfile);
                                 Titel
                           END;
                   IF Workfile.WCode THEN Execute;
                   Gotoxy(1,25); Write('Taste ...'); ch := Readkey
             END;
      'R'  : BEGIN IF not Workfile.WCode
                      THEN BEGIN Filer('Welches Eprom-Codefile erzeugen ?',-1, Workfile);
                                 Titel
                           END;
                   IF Workfile.WCode THEN Erzeuge_Eprom(Workfile);
                   Gotoxy(1,25); Write('Taste ...'); ch := Readkey
             END;
      'S'  : BEGIN
               ProgFlash;
               {IF Workfile.WCode THEN ProgEEprom(Workfile,Sys,true,InputRec.Meldung,Monstart);
                   }
                   IF MonStart THEN StartMonitor
             END;
      'F'  : Filer('Welche Datei auswhlen ?', 0, Workfile);
      'Q'  : Ende := True
    END;
  UNTIL Ende;
  GotoXY(1,18);
  chdir(StartDir);
END.

