unit MoniWin;
(*$I-*)
interface

uses
  LuchsTyp, Winluchs,
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Grids, Menus, Buttons,
  Gauges, Spin;

type
  Tmonform = class(TForm)
    MonBefehl: TEdit;
    Keyboard: TLabel;
    Ausgabe: TStringGrid;
    Register: TMemo;
    MonMode: TLabel;
    MTrace: TButton;
    OTrace: TButton;
    XTrace: TButton;
    brklabel: TLabel;
    KontButn: TButton;
    Menu: TBitBtn;
    endkomm: TBitBtn;
    LoadButton: TBitBtn;
    endbreak: TButton;
    LoadMonFile: TOpenDialog;
    MonGauge: TGauge;
    Display: TStringGrid;
    Taste42: TButton;
    Taste11: TButton;
    Taste12: TButton;
    Taste13: TButton;
    Taste21: TButton;
    Taste22: TButton;
    Taste23: TButton;
    Taste31: TButton;
    Button33: TButton;
    Taste33: TButton;
    Taste41: TButton;
    Taste43: TButton;
    Dateiname: TLabel;
    MainMenu1: TMainMenu;
    QuickStart1: TMenuItem;
    Quickneu: TMenuItem;
    Quickc1: TMenuItem;
    Quickc2: TMenuItem;
    Quickc3: TMenuItem;
    Quickc4: TMenuItem;
    Quickc5: TMenuItem;
    Quickc6: TMenuItem;
    Load1: TMenuItem;
    Stop1: TMenuItem;
    Menu1: TMenuItem;
    ZielPanel: TPanel;
    Label1: TLabel;
    Zielok: TBitBtn;
    Zielabort: TBitBtn;
    SpinButtonfein: TSpinButton;
    SpinButtongrob: TSpinButton;
    Label2: TLabel;
    Label3: TLabel;
    Zielnamelabel: TLabel;
    Zieledit: TEdit;
    SpinButton1: TSpinButton;
    Label4: TLabel;
    Label5: TLabel;
    BitBtn1: TBitBtn;
    Taste14: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    MonFontDialog: TFontDialog;
    Font1: TMenuItem;
    ComPort1: TMenuItem;
    procedure QuitMonClick(Sender: TObject);
    procedure MonBefehlKeyPress(Sender: TObject; var Key: Char);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure MonQuitClick(Sender: TObject);
    procedure MTraceClick(Sender: TObject);
    procedure OTraceClick(Sender: TObject);
    procedure XTraceClick(Sender: TObject);
    procedure KontButnClick(Sender: TObject);
    procedure EndKommClick(Sender: TObject);
    procedure MenuClick(Sender: TObject);
    procedure LoadButtonClick(Sender: TObject);
    procedure FormClick(Sender: TObject);
    procedure endbreakClick(Sender: TObject);
    procedure Taste42Click(Sender: TObject);
    procedure Taste11Click(Sender: TObject);
    procedure Taste12Click(Sender: TObject);
    procedure Taste13Click(Sender: TObject);
    procedure Taste21Click(Sender: TObject);
    procedure Taste22Click(Sender: TObject);
    procedure Taste23Click(Sender: TObject);
    procedure Taste31Click(Sender: TObject);
    procedure Button33Click(Sender: TObject);
    procedure Taste33Click(Sender: TObject);
    procedure Taste41Click(Sender: TObject);
    procedure Taste43Click(Sender: TObject);
    procedure xeingabeKeyPress(Sender: TObject; var Key: Char);
    procedure Menu1Click(Sender: TObject);
    procedure Quickc1Click(Sender: TObject);
    procedure Quickc2Click(Sender: TObject);
    procedure Quickc3Click(Sender: TObject);
    procedure Quickc4Click(Sender: TObject);
    procedure Quickc5Click(Sender: TObject);
    procedure Quickc6Click(Sender: TObject);
    procedure Load1Click(Sender: TObject);
    procedure Stop1Click(Sender: TObject);
    procedure ZielokClick(Sender: TObject);
    procedure ZielabortClick(Sender: TObject);
    procedure SpinButtongrobDownClick(Sender: TObject);
    procedure SpinButtongrobUpClick(Sender: TObject);
    procedure SpinButtonfeinDownClick(Sender: TObject);
    procedure SpinButtonfeinUpClick(Sender: TObject);
    procedure QuickneuClick(Sender: TObject);
    procedure SpinButton1DownClick(Sender: TObject);
    procedure SpinButton1UpClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure Font1Click(Sender: TObject);
    procedure Taste14Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ComPort1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

{PROCEDURE StartMonitor(Sys : T_SysInfo; VAR Meldung: T_Meldung);}

PROCEDURE Monitor;

PROCEDURE HostSlave;

PROCEDURE Codename_merken(Filename: T_Filename);

PROCEDURE Execute(Work: T_WorkFile; VAR Meldung: T_Meldung);

{$R *.DFM}

(* 14.3.96: HJ .BRAL und .BSRL als Pseudocodes eingefuehrt    *)
(*  1.4.96: HJ Monitorinhalte als WORDS lesen und schreiben
               Adressen werden immer auf gerade Werte gesetzt *)

 var  monform: Tmonform;

IMPLEMENTATION
USES CodeSave, CommWin, GaugWin;

CONST MonMaxY=10;
      MonMaxX=79;
      SlaveMaxY=4;
      SlaveMaxX=79;
      Quick=True;

TYPE str20   = String[20];
     str80   = String[80];
     Str8    = String[8];
     Str5    = String[5];
     Str4    = String[4];
     Str25   = String[25];
     T_Screentyp = (Mondisplay,SlaveDisplay);
     T_Screen    = Record Screentyp: T_Screentyp;
                          MaxX,MaxY,x,y: Word;
                          Feld: TStringgrid;
                   end;
     T_AdrRes = (Adr_ok,Adr_Per,Adr_Err);
     T_Reg   = ( o_R, b_R, w_R, l_R, ccR, k_R);
     T_SH    = RECORD PC,PR,SR,VBR,GBR,MACH,MACL: Longint;
                      R: Array[0..15] OF Longint;
               END;
     T_Input = RECORD Zeiger : Byte;
                      Taste  : Char;
                      EingabeZeile : Str80
               END;

     T_DisZ  = RECORD Adr       : Str8;
                      Befcode   : Str5;
                      LongOffset: Str8;
                      Befehl    : Str8;
                      Operand1, Operand2,Info: Str20;
                      Ende      : Str5;
                      Offset    : Char;
                      NextAdr   : Longint;
                      STCTyp,Slotaktiv: Boolean;
               END;

     T_M     = RECORD SH: T_SH;
                      Breakaktiv,Hostkommando,Traceaktiv,
                      EndKomm,Abbruch,ExecEnd: Boolean;
                      GoAdr,Breakadresse,Adresse,NextTrAdr: Longint;
                      BRR: Word;
               END;

VAR M: T_M;
    MonScreen,SlaveScreen: T_Screen;
    Slavekey: Char;


(*---------- ab hier Ein-Ausgaberoutinen auf den Bildschirm ----------*)



procedure Show_Code_Namen;
var i: word;

begin
  MonForm.Quickc1.Caption:=Sysinfo.Dateiname.Codename[1];
  MonForm.QuickC2.Caption:=Sysinfo.Dateiname.Codename[2];
  MonForm.QuickC3.Caption:=Sysinfo.Dateiname.Codename[3];
  MonForm.QuickC4.Caption:=Sysinfo.Dateiname.Codename[4];
  MonForm.QuickC5.Caption:=Sysinfo.Dateiname.Codename[5];
  MonForm.QuickC6.Caption:=Sysinfo.Dateiname.Codename[6];
end;

procedure Codename_merken(Filename: T_Filename);
var schon_da: boolean;
    i:word;
begin
  Filename:=Uppercase(Filename);
  schon_da:=False;
  for i:=1 to maxfiles do
      schon_da:=schon_da or (filename=Sysinfo.Dateiname.Codename[i]);
  IF (fileName<>'') and (not schon_da)
     THEN BEGIN for i:=maxfiles downto 2 do
                  Sysinfo.Dateiname.Codename[i]:=Sysinfo.Dateiname.Codename[i-1];
                Sysinfo.Dateiname.Codename[1]:=fileName;
          END;
  Show_Code_Namen;
end;

procedure Codedatei_laden(DateiName: T_Filename; quickld: Boolean); forward;

procedure mondialog(s:string);
var nix: word;
begin
 nix:=MessageDlg(s,mtinformation, [mbOk], 0)
end;

PROCEDURE MonFehler(s: Str80);
BEGIN mondialog(s) END;

FUNCTION Leerzeile(Screen: T_Screen): String;
VAR i: word; s: String;
BEGIN
  s:='';
  FOR i:=0 TO Screen.maxx DO s:=s+' ';
  Leerzeile:=s
END;

PROCEDURE Screen_ClrScr(VAR Screen: T_Screen);
var SRect: TGridRect;
    i: Word;
    s: String;
BEGIN
  s:=Leerzeile(Screen);
  for i:=0 to Screen.MaxY do
    Screen.Feld.Cells[0,i]:=s;
  Screen.y:=0; Screen.x:=0;
  SRect.Top := 1;     (* blau unterlegen in nicht def. Feld *)
  SRect.Left := 1;
  SRect.Bottom := 1;
  SRect.Right := 1;
  Screen.Feld.Selection := SRect;
END;

PROCEDURE TestScroll(VAR Screen: T_Screen);
VAR i: Word;
BEGIN
  IF Screen.y > Screen.MaxY
     THEN BEGIN FOR i:=0 TO Screen.MaxY-1 DO
                    Screen.Feld.Cells[0,i]:=Screen.Feld.Cells[0,i+1];
                Screen.y:=Screen.MaxY;
                Screen.Feld.Cells[0,Screen.y]:=Leerzeile(Screen);
          END;
END;

PROCEDURE Screen_writeln(VAR Screen: T_Screen; S: String);
var i: Integer;
BEGIN
  Screen.Feld.Cells[0,Screen.y]:=s;
  Inc(Screen.y);
  TestScroll(Screen);
  Screen.x:=0;
  Screen.Feld.Refresh;
END;

PROCEDURE Ausgabe_Control(VAR Screen: T_Screen; ch: Char);
var i: Integer;
    s: String;
BEGIN
 CASE ch OF
   #$08: IF Screen.X>0 THEN Dec(Screen.X);
   #$0D: Screen.x:=0;
   #$0A: BEGIN Inc(Screen.y); Testscroll(Screen) END;
   #$0C: Screen_ClrScr(Screen);
 END;
END;

PROCEDURE Ausgabe_write(VAR Screen: T_Screen; ch: Char);
var s: String;
BEGIN
 IF ch <=#$1F THEN Ausgabe_Control(Screen,ch) ELSE
  BEGIN
   TestScroll(Screen);
   s:=Screen.Feld.Cells[0,Screen.y];
   s[Screen.x+1]:=ch;
   Screen.Feld.Cells[0,Screen.y]:=s;
   inc(Screen.x);
   IF Screen.X > Screen.MaxX
      THEN BEGIN
            Inc(Screen.y);
            Screen.X:=0;
           END;
  end;
 Screen.Feld.Refresh;
end;

PROCEDURE Screen_Gotoxy(VAR Screen: T_Screen; x,y: Integer);
BEGIN
  IF (x<=Screen.MaxX) AND (y <= Screen.MaxY)
     THEN begin Screen.x:=x; Screen.y:=y end
END;

(*--------- Ende der Ein-Ausgaberoutinen auf den Bildschirm------------*)

procedure expandstring(quellstr: string; var zielstr: string);
var i: word;      (* ersetzt Controlzeichen durch #Nummer *)
    ch: char;
    strg: string;
begin
   zielstr:='';
   for i:=1 to length(quellstr) do
     begin ch:=quellstr[i];
           if ch >= #$20
              then zielstr:=zielstr+ch
              else if ch <=#9
                      then zielstr:=zielstr+'#'+chr(48+ord(ch))
                      else zielstr:=zielstr+'#'
                           +chr(48+ord(ch) div 10)
                           +chr(48+ord(ch) mod 10)
     end;
end;

PROCEDURE Slave; Forward;

PROCEDURE EndMon;
BEGIN
  Exit_Serial;
  MonForm.BrkLabel.Visible:=False;
  MonForm.MonMode.Caption:='Nicht verbunden';
  GlobVar.Mon_Aktiv:=False;
  monForm.hide;
{  luchs_dialog('Ausgang von EndMon',0);}
END;


PROCEDURE Read_Byte_Slave_mon(VAR b: Byte; VAR Abbruch: Boolean);
BEGIN
  Read_Byte_Slave(b,Abbruch);
  IF Abbruch THEN
     BEGIN MonDialog('Kontakt abgebrochen');
           EndMon
     END;
END;

PROCEDURE Read_Byte_HS_mon(VAR b: Byte; VAR Abbruch: Boolean);
BEGIN
  Read_Byte_HS(b,Abbruch);
  IF Abbruch THEN
     BEGIN MonDialog('Kontakt abgebrochen');
           EndMon
     END;
END;


   FUNCTION HexAdr(Long: LongInt): Str20;
   VAR HB,MB,LW: Word;
       Hilf: Str8;
   BEGIN
     Hexadr:=Hexword(Long shr 16)+Hexword(Long AND $FFFF)
   END;


   FUNCTION HexByteErw(B:Byte): Str20;
   BEGIN
     IF (b AND $80) = $0
        THEN HexByteErw:=HexByte(B)
        ELSE HexByteErw:=Hexadr(B OR $FFFFFF00);
   END;

PROCEDURE holbyte(VAR b: Byte; VAR Abbruch: Boolean; VAR Adr: Longint);
BEGIN
  Put_Byte(Bef_Readbyte); put_Byte(1);
  Read_Byte_HS_mon(b,Abbruch); inc(Adr)
END;

PROCEDURE holWord(VAR W: Word; VAR Abbruch: Boolean; VAR Adr: Longint);
VAR bh, bl : Byte;
BEGIN
  Holbyte(bh, Abbruch,Adr); HolByte(bl, Abbruch,Adr);
  w := $100*bh + bl
END;

PROCEDURE Set_Adresse(Adr: Longint);
BEGIN
  put_Byte(Bef_Setadresse);
  put_long(Adr)
END;


PROCEDURE MEM_Vorschau(    newadr,oldadr: LongInt;
                       VAR Inhalt: Longint;
                           Gr: Char;
                       VAR Result: T_AdrRes);
VAR ist_Peripherie: Boolean;
    Byt: Byte;
    Wrd: Word;
    Abbruch: Boolean;
BEGIN
  newadr:=Newadr AND $0FFFFFFF;    (* high nibble ignorieren *)
  ist_Peripherie:=((newadr>=$05000000) AND (newadr<=$06FFFFFF))
                  OR ((newadr>=$0D000000) AND (newadr <=$0EFFFFFF));
  IF Ist_Peripherie
     THEN Result:=Adr_Per
     ELSE BEGIN Result:=Adr_Ok;
                Set_Adresse(NewAdr);
                CASE Gr OF
                 'B': BEGIN HolByte(Byt,Abbruch,NewAdr); Inhalt:=Byt END;
                 'W': IF odd(NewAdr) THEN Result:=Adr_Err
                                     ELSE BEGIN HolWord(Wrd,Abbruch,NewAdr);
                                                Inhalt:=Wrd
                                          END;
                 'L': IF (Newadr AND 3) =0 THEN BEGIN Put_Byte(Bef_Readbyte);
                                                      put_Byte(4);
                                                      Read_Long_HS(Inhalt,Abbruch)
                                                END
                                           ELSE Result:=Adr_Err
                END;
                Set_Adresse(Oldadr);
          END
END;

PROCEDURE Lies_Quelladr(VAR DisZ: T_DisZ; Memadr,Adr: Longint;Gr:Char);
VAR Inhalt : Longint;
    Inh_Str: Str20;
    Result : T_AdrRes;
BEGIN
  DisZ.Info:=HexAdr(Memadr); Inh_Str:=''; Result:=Adr_Err;
  MEM_Vorschau(Memadr,Adr,Inhalt,Gr,Result);
  CASE Result OF
    Adr_Ok:  BEGIN IF   Gr='B'    THEN Inh_str:=HexByte(Inhalt)
                   ELSE IF Gr='W' THEN Inh_str:=HexWord(Inhalt)
                   ELSE Inh_str:=HexAdr(Inhalt);
             END;
    Adr_Per: Inh_Str:='Peripherie_Adr'; (* Peripherie: nichts anzeigen *)
    Adr_Err: Inh_Str:='Quell_Err';
  END;
  DisZ.Info:=DisZ.Info+': '+Inh_Str;
END;

PROCEDURE Make_Zieladr(VAR DisZ: T_DisZ; Adr: Longint; Gr: Char);
BEGIN
  IF ((Gr='L') AND ((Adr AND 3) <> 0)) OR ((Gr='W') AND odd(Adr))
     THEN DisZ.Info:='Ziel_Err: '+HexAdr(Adr)
     ELSE DisZ.Info:='Ziel_Adr: '+Hexadr(Adr)
END;


PROCEDURE DisassZeile(VAR DisZ : T_DisZ);
VAR Hexcode: Word;

{ ================= Disassembler ====================================== }

  FUNCTION MakeRn(Rn: Byte): Str5;
  VAR Hilf: Str5;
  BEGIN
    IF Rn >= 10
       THEN BEGIN Hilf:='R1'; Rn:=Rn-10 END
       ELSE Hilf:='R';
    MakeRn:=Hilf+Chr(Rn+$30);
  END;

  FUNCTION MakeMovGr(Gr: Byte): Str5;
  BEGIN
    CASE (Gr AND 3) OF
      0: MakeMovGr:='MOV.B';
      1: MakeMovGr:='MOV.W';
      2: MakeMovGr:='MOV.L';
    END;
  END;

  FUNCTION MakeMach(Fx: Byte): Str5;
  BEGIN
    CASE Fx OF
       0: MakeMach:='MACH';
       1: MakeMach:='MACL';
       2: MakeMach:='PR';
    END;
  END;

  FUNCTION MakeSr(Fx: Byte): Str5;
  BEGIN
    CASE Fx OF
       0: MakeSr:='SR';
       1: MakeSr:='GBR';
       2: MakeSr:='VBR';
    END;
  END;

  PROCEDURE DisBra8(VAR DisZ: T_DisZ; Bef: Str5; Adr: Longint;
                        Off: Byte; VAR Statusreg: Longint);
  VAR T_Bit: Boolean;
  BEGIN
    T_Bit:=((Statusreg AND 1)=1);
    DisZ.Befehl:=Bef;
    IF off <= $7F THEN Adr:=Adr+2*off+2
                  ELSE Adr:=Adr-2*($100-off)+2;
    IF (Bef[2]='F') AND (NOT T_Bit)
       OR ((Bef[2]='T') AND T_Bit) THEN DisZ.NextAdr:=Adr;
    DisZ.Operand1:=HexAdr(Adr)
  END;


  PROCEDURE Page0(Rn,Fx,LSB:Byte; VAR DisZ: T_DisZ);

    PROCEDURE Page0STC;
    BEGIN
      (* IF (CPU7600 AND (Fx=0)) OR (Fx IN [1,2]) *) (*???? FX=0 fuer 7000 verboten *)
      IF Fx <= 2 THEN BEGIN DisZ.Befehl:='STC';
                            DisZ.STCTyp:=True;
                            DisZ.Operand1:=MakeSr(Fx);
                            DisZ.Operand2:=MakeRn(Rn);
                      END;
    END;

    PROCEDURE Page0Br;
    BEGIN
     (*$IFDef CPU7600 *)
        IF Fx=0 THEN
           BEGIN DisZ.Befehl:='BSRF'; DisZ.Operand1:='@'+MakeRn(Rn) END
        ELSE IF Fx=$2 THEN
           BEGIN DisZ.Befehl:='BRAF'; DisZ.Operand1:='@'+MakeRn(Rn) END;
     (*$ENDIF *)
    END;

    PROCEDURE Page0_4;
    BEGIN
      CASE LSB OF
        $4..$6: BEGIN DisZ.Befehl:=MakeMovGr(LSB);
                      DisZ.Operand1:=MakeRn(Fx);
                      DisZ.Operand2:='@(R0,'+MakeRn(Rn)+')';
                      Make_Zieladr(DisZ,M.SH.R[0]+M.SH.R[Rn],DisZ.Befehl[5]);
                END;
        $7    : (*$IFDef CPU7600 *)
                BEGIN DisZ.Befehl:='MUL';
                      DisZ.Operand1:=MakeRn(Fx);
                      DisZ.Operand2:=MakeRn(Rn)
                END
                (*$ENDIF *);
      END;
    END;

    PROCEDURE PAGE0_8;
    BEGIN
      IF Rn=0 THEN
         CASE Fx OF
           0: DisZ.Befehl:='CLRT';
           1: DisZ.Befehl:='SETT';
           2: DisZ.Befehl:='CLRMAC';
        END;
    END;

    PROCEDURE PAGE0_9;
    BEGIN
           IF (Rn=0) AND (Fx=0) THEN DisZ.Befehl:='NOP'
      ELSE IF (Rn=0) AND (Fx=1) THEN DisZ.Befehl:='DIV0U'
      ELSE IF Fx=2 THEN BEGIN DisZ.Befehl:='MOVT';
                              DisZ.Operand1:=MakeRn(Rn)
                        END
    END;

    PROCEDURE PAGE0_A;
    BEGIN
      IF Fx <= 2 THEN
         BEGIN DisZ.Befehl:='STS'; DisZ.STCTyp:=True;
               CASE Fx OF
                 0: DisZ.Operand1:='MACH';
                 1: DisZ.Operand1:='MACL';
                 2: DisZ.Operand1:='PR';
               END;
               DisZ.Operand2:=MakeRn(Rn);
         END
    END;

    PROCEDURE PAGE0_B;
    VAR dummy: Boolean;
    BEGIN
      IF Rn=0 THEN
         CASE Fx OF
           0: BEGIN DisZ.Befehl:='RTS';
                    DisZ.NextAdr:=M.SH.PR;
                    DisZ.Slotaktiv:=True
              END;
           1: DisZ.Befehl:='SLEEP';
           2: BEGIN DisZ.Befehl:='RTE';
                    DisZ.Slotaktiv:=True;
                    Lies_Quelladr(DisZ,M.SH.R[15],M.Adresse,'L');
                    Set_Adresse(M.SH.R[15]);
                    put_Byte(Bef_ReadByte); put_Byte(4);
                    Read_Long_HS(DisZ.Nextadr,M.Abbruch);
                    Set_Adresse(M.Adresse);
              END
         END;
    END;

    PROCEDURE Page0_C;
    BEGIN
      CASE LSB OF
        $C..$E: BEGIN DisZ.Befehl:=MakeMovGr(LSB);
                      Disz.Operand1:='@(R0,'+MakeRn(Fx)+')';
                      DisZ.Operand2:=MakeRn(Rn);
                      Lies_Quelladr(DisZ,M.SH.R[0]+M.SH.R[Fx],M.Adresse,DisZ.Befehl[5]);
                END;
        $F    : (*$IFDef CPU7600 *)
                BEGIN DisZ.Befehl:='MAC.L';
                      DisZ.Operand1:='@'+MakeRn(Fx)+'+';
                      DisZ.Operand2:='@'+MakeRn(Rn)+'+'
                END
                (*$ENDIF *);
      END;
    END;

    PROCEDURE Page0Bkpt;
    BEGIN
      Disz.Befehl:='.bkpt';
      Str(Rn*16+Fx,Disz.Operand1);
      Disz.Operand1:='#'+DisZ.Operand1
    END;

    PROCEDURE Page0Trace;
    BEGIN
      IF Fx=0 THEN Disz.Befehl:='.tron';
      IF Fx=1 THEN Disz.Befehl:='.troff';
    END;

  BEGIN
    CASE LSB OF
      $0    : Page0BKPT;                (* Sonderbefehl COCK *)
      $1    : IF Rn=0 THEN Page0Trace;  (* Sonderbefehle     *)
      $2    : Page0STC;
      $3    : Page0Br;
      $4..$7: Page0_4;
      $8    : Page0_8;
      $9    : Page0_9;
      $A    : Page0_A;
      $B    : Page0_B;
      $C..$F: Page0_C;
    END;
  END;

  PROCEDURE Page1(Rn,Rm,LSB:Byte; VAR DisZ: T_DisZ);
  BEGIN
    DisZ.Befehl:='MOV.L';
    DisZ.Operand1:=MakeRn(Rm);
    DisZ.Operand2:='@('+HexByte(LSB*4)+','+MakeRn(Rn)+')';
    Make_Zieladr(DisZ,LSB*4+M.SH.R[Rn],'L');
  END;

  PROCEDURE Page2(Rn,Rm,LSB:Byte; VAR DisZ: T_DisZ);
  VAR Kor: Word;
  BEGIN
    CASE LSB OF
      $0..$2: BEGIN DisZ.Befehl:=MakeMovGr(LSB);
                    Disz.Operand1:=MakeRn(Rm);
                    DisZ.Operand2:='@'+MakeRn(Rn);
                    Make_Zieladr(DisZ,M.SH.R[Rn],DisZ.Befehl[5]);
              END;
      $3    : ;
      $4..$6: BEGIN DisZ.Befehl:=MakeMovGr(LSB);
                    Disz.Operand1:=MakeRn(Rm);
                    DisZ.Operand2:='@-'+MakeRn(Rn);
                    IF DisZ.Befehl[5]='B' THEN Kor:=1
                    ELSE IF DisZ.Befehl[5]='W' THEN Kor:=2
                    ELSE Kor:=4;    (* Zieladresse nach unten korrig. *)
                    Make_Zieladr(DisZ,M.SH.R[Rn]-Kor,DisZ.Befehl[5]);
              END;
      $7..$F: BEGIN CASE LSB OF
                       $7: DisZ.Befehl:='DIV0S';
                       $8: DisZ.Befehl:='TST';
                       $9: DisZ.Befehl:='AND';
                       $A: DisZ.Befehl:='XOR';
                       $B: DisZ.Befehl:='OR';
                       $C: DisZ.Befehl:='CMP/STR';
                       $D: DisZ.Befehl:='XTRCT';
                       $E: DisZ.Befehl:='MULU.W';
                       $F: DisZ.Befehl:='MULS.W';
                    END;
                    Disz.Operand1:=MakeRn(Rm);
                    DisZ.Operand2:=MakeRn(Rn);
              END;
    END;
  END;

  PROCEDURE Page3(Rn,Rm,LSB:Byte; VAR DisZ: T_DisZ);
  BEGIN
    CASE LSB OF
      $0: DisZ.Befehl:='CMP/EQ';
      $2: DisZ.Befehl:='CMP/HS';
      $3: DisZ.Befehl:='CMP/GE';
      $4: DisZ.Befehl:='DIV1';
      $5: (*$IFDef CPU7600 *) DisZ.Befehl:='DMULU.L' (*$ENDIF *);
      $6: DisZ.Befehl:='CMP/HI';
      $7: DisZ.Befehl:='CMP/GT';
      $8: DisZ.Befehl:='SUB';
      $A: DisZ.Befehl:='SUBC';
      $B: DisZ.Befehl:='SUBV';
      $C: DisZ.Befehl:='ADD';
      $D: (*$IFDef CPU7600 *) DisZ.Befehl:='DMULS.L' (*$ENDIF *);
      $E: DisZ.Befehl:='ADDC';
      $F: DisZ.Befehl:='ADDV';
    END;
    IF DisZ.Befehl <> '.word'
       THEN BEGIN DisZ.Operand1:=MakeRn(Rm); DisZ.Operand2:=MakeRn(Rn) END;
  END;

  PROCEDURE Page4(Rn,Fx,LSB:Byte; VAR DisZ: T_DisZ);

    PROCEDURE Page4_0;
    BEGIN
      CASE Fx OF
        0: DisZ.Befehl:='SHLL';
        1: (*$IFDef CPU7600 *) DisZ.Befehl:='DT' (*$ENDIF *);
        2: DisZ.Befehl:='SHAL';
      END;
      IF DisZ.Befehl <> '.word' THEN DisZ.Operand1:=MakeRn(Rn)
    END;

    PROCEDURE Page4_1;
    BEGIN
      IF Fx <= 2
         THEN BEGIN
               CASE Fx OF
                 0: DisZ.Befehl:='SHLR';
                 1: DisZ.Befehl:='CMP/PZ';
                 2: DisZ.Befehl:='SHAR';
               END;
               DisZ.Operand1:=MakeRn(Rn)
              END
    END;

    PROCEDURE Page4_2;
    BEGIN
      IF Fx <= 2
         THEN BEGIN
               DisZ.STCTyp:=True;
               DisZ.Befehl:='STS.L';
               DisZ.Operand1:=MakeMACH(Fx);
               DisZ.Operand2:='@-'+MakeRn(Rn);
               Make_Zieladr(DisZ,M.SH.R[Rn]-4,'L');
              END
    END;

    PROCEDURE Page4_3;
    BEGIN
      IF Fx <= 2
         THEN BEGIN
               DisZ.STCTyp:=True;
               DisZ.Befehl:='STC.L';
               DisZ.Operand1:=MakeSR(Fx);
               DisZ.Operand2:='@-'+MakeRn(Rn);
               Make_Zieladr(DisZ,M.SH.R[Rn]-4,'L');
              END
    END;

    PROCEDURE Page4_4;
    BEGIN
      IF Fx IN [0,2]
         THEN BEGIN
               CASE Fx OF
                 0: DisZ.Befehl:='ROTL';
                 2: DisZ.Befehl:='ROTCL';
               END;
               DisZ.Operand1:=MakeRn(Rn)
              END
    END;

    PROCEDURE Page4_5;
    BEGIN
      IF Fx <= 2
         THEN BEGIN
               CASE Fx OF
                 0: DisZ.Befehl:='ROTR';
                 1: DisZ.Befehl:='CMP/PL';
                 2: DisZ.Befehl:='ROTCR';
               END;
               DisZ.Operand1:=MakeRn(Rn)
              END
    END;

    PROCEDURE Page4_6;
    BEGIN
      IF Fx <= 2
         THEN BEGIN
               DisZ.STCTyp:=True;
               DisZ.Befehl:='LDS.L';
               DisZ.Operand2:=MakeMACH(Fx);
               DisZ.Operand1:='@'+MakeRn(Rn)+'+'
              END
    END;

    PROCEDURE Page4_7;
    BEGIN
      IF Fx <= 2
         THEN BEGIN
               DisZ.Slotaktiv:=True;
               DisZ.Befehl:='LDC.L';
               Inc(DisZ.Nextadr,2);
               DisZ.Operand2:=MakeSr(Fx);
               DisZ.Operand1:='@'+MakeRn(Rn)+'+'
              END
    END;

    PROCEDURE Page4_8(Bef: Str5);
    BEGIN
      IF Fx <= 2
         THEN BEGIN
               DisZ.Befehl:=Bef;
               CASE Fx OF
                 0: DisZ.Befehl:=Bef+'2';
                 1: DisZ.Befehl:=Bef+'8';
                 2: DisZ.Befehl:=Bef+'16';
               END;
               DisZ.Operand1:=MakeRn(Rn);
              END
    END;

    PROCEDURE Page4_A;
    BEGIN
      IF Fx <= 2
         THEN BEGIN
               DisZ.STCTyp:=True;
               DisZ.Befehl:='LDS';
               DisZ.Operand2:=MakeMACH(Fx);
               DisZ.Operand1:=MakeRn(Rn)
              END
    END;

    PROCEDURE Page4_B;
    BEGIN
      IF Fx <= 2
         THEN BEGIN
               CASE Fx OF
                 0: DisZ.Befehl:='JSR';
                 1: DisZ.Befehl:='TAS.B';
                 2: DisZ.Befehl:='JMP';
               END;
               DisZ.Operand1:='@'+MakeRn(Rn);
               IF Fx <> 1 THEN BEGIN DisZ.Slotaktiv:=True;
                                     DisZ.Nextadr:=M.SH.R[Rn]
                               END;
              END
    END;

    PROCEDURE Page4_E;
    BEGIN
      IF Fx <= 2
         THEN BEGIN
               DisZ.Slotaktiv:=True;
               DisZ.Befehl:='LDC';
               Inc(DisZ.Nextadr,2);
               DisZ.Operand1:=MakeRn(Rn);
               DisZ.Operand2:=MakeSr(Fx);
              END
    END;

    PROCEDURE Page4_F;
    BEGIN
      DisZ.Befehl:='MAC.W';
      DisZ.Operand1:='@'+MakeRn(Fx)+'+';
      DisZ.Operand2:='@'+MakeRn(Rn)+'+'
    END;

  BEGIN
    CASE LSB OF
      $0: Page4_0;
      $1: Page4_1;
      $2: Page4_2;
      $3: Page4_3;
      $4: Page4_4;
      $5: Page4_5;
      $6: Page4_6;
      $7: Page4_7;
      $8: Page4_8('SHLL');
      $9: Page4_8('SHLR');
      $A: Page4_A;
      $B: Page4_B;
      $C,$D: ;     (* verboten *)
      $E: Page4_E;
      $F: Page4_F;
    END
  END;

  PROCEDURE Page5(Rn,Rm,LSB:Byte; VAR DisZ: T_DisZ);
  BEGIN
    DisZ.Befehl:='MOV.L';
    DisZ.Operand1:='@('+HexByte(4*LSB)+','+MakeRn(Rm)+')';
    DisZ.Operand2:=MakeRn(Rn);
    Lies_Quelladr(DisZ,4*LSB+M.SH.R[Rm],M.Adresse,'L');
  END;

  PROCEDURE Page6(Rn,Rm,LSB:Byte; VAR DisZ: T_DisZ);
  BEGIN
    CASE LSB OF
      0..2,4..6: DisZ.Befehl:=MakeMovGr(LSB);
      3        : DisZ.Befehl:='MOV';
      7        : DisZ.Befehl:='NOT';
      8        : DisZ.Befehl:='SWAP.B';
      9        : DisZ.Befehl:='SWAP.W';
      $A       : DisZ.Befehl:='NEGC';
      $B       : DisZ.Befehl:='NEG';
      $C       : DisZ.Befehl:='EXTU.B';
      $D       : DisZ.Befehl:='EXTU.W';
      $E       : DisZ.Befehl:='EXTS.B';
      $F       : DisZ.Befehl:='EXTS.W';
    END;
    CASE LSB OF
      $0,$1,$2 : BEGIN DisZ.Operand1:='@'+MakeRn(Rm);
                       Lies_Quelladr(DisZ,M.SH.R[Rm],M.Adresse,DisZ.Befehl[5]);
                 END;
      $4,$5,$6 : BEGIN DisZ.Operand1:='@'+MakeRn(Rm)+'+';
                       Lies_Quelladr(DisZ,M.SH.R[Rm],M.Adresse,DisZ.Befehl[5]);
                 END;
      $3,$7..$F: DisZ.Operand1:=MakeRn(Rm);
    END;
    DisZ.Operand2:=MakeRn(Rn);

  END;

  PROCEDURE Page7(Rn,Rm,LSB:Byte; VAR DisZ: T_DisZ);
  BEGIN
    DisZ.Befehl:='ADD';
    DisZ.Operand1:='#H'''+HexByteErw(16*Rm+LSB);
    DisZ.Operand2:=MakeRn(Rn);
  END;

  PROCEDURE Page8(MD,Rn,LSB:Byte; VAR DisZ: T_DisZ; Adresse: Longint);
  VAR Imm: Byte;
  BEGIN
    Imm:=16*Rn+LSB;
    CASE MD OF
     $0: BEGIN DisZ.Befehl:='MOV.B';
               DisZ.Operand1:='R0';
               DisZ.Operand2:='@('+HexByte(LSB)+','+MakeRn(Rn)+')';
               Make_Zieladr(DisZ,LSB+M.SH.R[Rn],'B');
         END;
     $1: BEGIN DisZ.Befehl:='MOV.W';
               DisZ.Operand1:='R0';
               DisZ.Operand2:='@('+HexByte(2*LSB)+','+MakeRn(Rn)+')';
               Make_Zieladr(DisZ,2*LSB+M.SH.R[Rn],'W');
         END;
     $2,$3,$6,$7,$A,$C,$E: ; (* verboten *)
     $4: BEGIN DisZ.Befehl:='MOV.B';
               DisZ.Operand2:='R0';
               DisZ.Operand1:='@('+HexByte(LSB)+','+MakeRn(Rn)+')';
               Lies_Quelladr(Disz,LSB+M.SH.R[Rn],Adresse,'B')
         END;
     $5: BEGIN DisZ.Befehl:='MOV.W';
               DisZ.Operand2:='R0';
               DisZ.Operand1:='@('+HexByte(2*LSB)+','+MakeRn(Rn)+')';
               Lies_Quelladr(Disz,2*LSB+M.SH.R[Rn],Adresse,'W')
         END;
     $8: BEGIN DisZ.Befehl:='CMP/EQ';
               DisZ.Operand1:='#H'''+HexByteErw(Imm);
               DisZ.Operand2:='R0';
         END;
     $9: DisBra8(DisZ,'BT',Adresse,Imm,M.SH.SR);
     $B: DisBra8(DisZ,'BF',Adresse,Imm,M.SH.SR);
     $D: (*$IFDef CPU7600 *) DisBra8(DisZ,'BT/S',Adresse,Imm,M.SH.SR) (*$ENDIF*);
     $F: (*$IFDef CPU7600 *) DisBra8(DisZ,'BF/S',Adresse,Imm,M.SH.SR) (*$ENDIF *);
    END;
  END;

  PROCEDURE Page9(Rn,imm:Byte; VAR DisZ: T_DisZ; Adresse: Longint);
  VAR ZielAdr,Inhalt: Longint;
  BEGIN
    DisZ.Befehl:='MOV.W';
    Zieladr:=Adresse+2*imm+2;
    DisZ.Operand1:='@('+HexWord(Imm*2)+',PC)';
    DisZ.Operand2:=MakeRn(Rn);
    Lies_Quelladr(DisZ,Zieladr,Adresse,'W')
  END;

  PROCEDURE PageBra(Bef: Str5; Rn,Rm,LSB:Byte; VAR DisZ:T_DisZ; Adr:Longint);
  VAR Displ: Word;
      Ziel: LongInt;
  BEGIN
    DisZ.Befehl:=Bef;
    Displ:=Rn*256+Rm*16+LSB;
    IF Displ <= $7FF
       THEN Ziel:=Adr+2*Displ+2 ELSE Ziel:=Adr-2*($1000-Displ)+2;
    DisZ.Operand1:=HexAdr(Ziel);
    DisZ.NextAdr:=Ziel; DisZ.Slotaktiv:=True;
  END;

  PROCEDURE PageC(MD,imm:Byte; VAR DisZ: T_DisZ; Adresse:Longint);

    PROCEDURE PageC_8(Bef: Str5);
    BEGIN
      DisZ.Befehl:=Bef;
      DisZ.Operand1:='#H'''+HexByte(imm);
      DisZ.Operand2:='R0';
    END;

    PROCEDURE PageC_C(Bef: Str5);
    BEGIN
      DisZ.Befehl:=Bef;
      DisZ.Operand1:='#H'''+HexByte(imm);
      DisZ.Operand2:='@(R0,GBR)';
    END;

    PROCEDURE DisPseudoBraL(VAR DisZ: T_DisZ; imm: Byte);
    VAR DistanzH,DistanzL: Word;
        Ziel,Distanz     : LongInt;
    BEGIN
      CASE imm OF
        $29: DisZ.Befehl:='.BRAL';
        $2A: DisZ.Befehl:='.BSRL';
        $2B: BEGIN DisZ.Befehl:='.MOVAL'; DisZ.Operand2:='R0' END;
      END;
      Ziel:=M.Adresse;
      Holword(DistanzH,M.Abbruch,M.Adresse);
      Holword(DistanzL,M.Abbruch,M.Adresse);
      DisZ.LongOffset:=HexWord(DistanzH)+HexWord(DistanzL);
      Distanz:=DistanzH;
      Distanz:=((Distanz shl 8) shl 8 + DistanzL + 4);
      Ziel:=Ziel+Distanz;
      DisZ.Operand1:=Hexlong(Ziel);
      IF imm=$2B
         THEN BEGIN DisZ.Nextadr:=M.Adresse; M.NextTrAdr:=M.Adresse END
         ELSE BEGIN DisZ.Nextadr:=Ziel; M.NextTrAdr:=Ziel END;
    END;

  BEGIN
    CASE MD OF
      $0: BEGIN DisZ.Befehl:='MOV.B';
                DisZ.Operand1:='R0';
                DisZ.Operand2:='@('+HexByte(imm)+',GBR)';
                Make_Zieladr(DisZ,M.SH.GBR+imm,'B');
          END;
      $1: BEGIN DisZ.Befehl:='MOV.W';
                DisZ.Operand1:='R0';
                DisZ.Operand2:='@('+HexWord(2*imm)+',GBR)';
                Make_Zieladr(DisZ,M.SH.GBR+2*imm,'W');
          END;
      $2: BEGIN DisZ.Befehl:='MOV.L';
                DisZ.Operand1:='R0';
                DisZ.Operand2:='@('+HexWord(4*imm)+',GBR)';
                Make_Zieladr(DisZ,M.SH.GBR+4*imm,'L');
          END;
      $3: IF imm IN [$29,$2A,$2B]
             THEN DisPseudoBral(DisZ,imm)
             ELSE BEGIN DisZ.Befehl:='TRAPA';
                        DisZ.Operand1:='#H'''+Hexbyte(imm);
                        Lies_Quelladr(DisZ,M.SH.VBR+4*imm,Adresse,'L');
                  END;
      $4: BEGIN DisZ.Befehl:='MOV.B';
                DisZ.Operand2:='R0';
                DisZ.Operand1:='@('+HexByte(imm)+',GBR)';
                lies_Quelladr(DisZ,imm+M.SH.GBR,Adresse,'B');
          END;
      $5: BEGIN DisZ.Befehl:='MOV.W';
                DisZ.Operand2:='R0';
                DisZ.Operand1:='@('+HexWord(2*imm)+',GBR)';
                lies_Quelladr(DisZ,2*imm+M.SH.GBR,Adresse,'W');
          END;
      $6: BEGIN DisZ.Befehl:='MOV.L';
                DisZ.Operand2:='R0';
                DisZ.Operand1:='@('+HexWord(4*imm)+',GBR)';
                lies_Quelladr(DisZ,4*imm+M.SH.GBR,Adresse,'L');
          END;
      $7: BEGIN DisZ.Befehl:='MOVA';
                DisZ.Operand1:='@('+HexWord(4*imm)+',PC)';
                Lies_Quelladr(DisZ,(Adresse+2) AND $FFFFFFFC+4*imm,Adresse,'L');
                DisZ.Operand2:='R0'
          END;
      $8: PageC_8('TST');
      $9: PageC_8('AND');
      $A: PageC_8('XOR');
      $B: PageC_8('OR');
      $C: PageC_C('TST.B');
      $D: PageC_C('AND.B');
      $E: PageC_C('XOR.B');
      $F: PageC_C('OR.B');
    END;
  END;

  PROCEDURE PageD(Rn,imm:Byte; VAR DisZ: T_DisZ);
  VAR Zieladr,Inhalt: LongInt;
  BEGIN
    DisZ.Befehl:='MOV.L';
    ZielAdr:=(M.Adresse+2) AND $FFFFFFFC+4*imm;
    DisZ.Operand1:='@('+HexWord(4*imm)+',PC)';
    DisZ.Operand2:=MakeRn(Rn);
    Lies_Quelladr(DisZ,Zieladr,M.Adresse,'L');
  END;

  PROCEDURE PageE(Rn,Rm,LSB:Byte; VAR DisZ: T_DisZ);
  BEGIN
    DisZ.Befehl:='MOV';
    DisZ.Operand1:='#H'''+HexbyteErw(RM*16+LSB);
    DisZ.Operand2:=MakeRn(Rn)
  END;

VAR MSB,Rn,Fx,LSB,imm: Byte;

BEGIN  (* DisassZeile *)
  DisZ.Adr:=HexAdr(M.Adresse);
  Holword(Hexcode,M.Abbruch,M.Adresse);
  DisZ.BefCode := HexWord(HexCode);  DisZ.LongOffset:='';
  DisZ.Befehl := '.word';
  DisZ.Operand1 := ''; DisZ.Operand2:=''; DisZ.Info:='';
  DisZ.Ende  := '';    DisZ.Offset := 'X';
  Disz.NextAdr:=M.Adresse; DisZ.Slotaktiv:=False; DisZ.STCTyp:=False;
  MSB:=Hexcode shr 12;
  Rn:=(Hexcode AND $0F00) shr 8;
  Fx :=(Hexcode AND $00F0) shr 4;
  LSB:=Hexcode AND $000F;
  imm:=HexCode AND $FF;
  CASE MSB OF
    $0: Page0(Rn,Fx,LSB,DisZ);
    $1: Page1(Rn,Fx,LSB,DisZ);
    $2: Page2(Rn,Fx,LSB,DisZ);
    $3: Page3(Rn,Fx,LSB,DisZ);
    $4: Page4(Rn,Fx,LSB,DisZ);
    $5: Page5(Rn,Fx,LSB,DisZ);
    $6: Page6(Rn,Fx,LSB,DisZ);
    $7: Page7(Rn,Fx,LSB,DisZ);
    $8: Page8(Rn,Fx,LSB,DisZ,M.Adresse);
    $9: Page9(Rn,imm,DisZ,M.Adresse);
    $A: PageBra('BRA',Rn,Fx,LSB,DisZ,M.Adresse);
    $B: PageBra('BSR',Rn,Fx,LSB,DisZ,M.Adresse);
    $C: PageC(Rn,imm,DisZ,M.Adresse);
    $D: PageD(Rn,imm,DisZ);
    $E: PageE(Rn,Fx,LSB,DisZ);
    $F: ;    (* verboten *)
  END;
  IF DisZ.Befehl='.word' THEN DisZ.Operand1:=DisZ.BefCode
END;

PROCEDURE Ausgabe(DisZ : T_DisZ);
VAR Ausgabezeile: Str80;

  FUNCTION lbg(s: String; laenge : Integer): String;
  BEGIN
    WHILE length(s) < laenge DO s := s + ' ';
    lbg := s
  END;

BEGIN
  Ausgabezeile:=DisZ.Adr+':'+lbg(DisZ.Befcode,5)+DisZ.LongOffset+' '
                +lbg(DisZ.Befehl,8)
                +DisZ.Operand1;
  IF DisZ.Operand2[0]>#0 THEN Ausgabezeile:=Ausgabezeile+','+DisZ.Operand2;
  Ausgabezeile:=lbg(Ausgabezeile,40);
  IF DisZ.Info[0]>#0 THEN Ausgabezeile:=Ausgabezeile+DisZ.Info;
  Ausgabezeile:=lbg(Ausgabezeile,60);
  Ausgabezeile:=Ausgabezeile+'   next='+hexadr(disz.nextadr);
  Screen_writeln(MonScreen,Ausgabezeile);
END;

PROCEDURE Disassemble;
VAR DisZ      : T_DisZ;
    taste     : Char;
    Hexcode   :Word;
    i: Byte;
    NextAdr   : Longint;
BEGIN
  Set_Adresse(M.Adresse);
  FOR i:=0 TO MonScreen.Maxy-3 DO
    BEGIN Disasszeile(DisZ);
          Ausgabe(DisZ);
    end
END;

  PROCEDURE lies(VAR Input: T_Input);
  BEGIN
    IF Input.Zeiger>Length(Input.Eingabezeile)
       THEN Input.Taste:=#13
       ELSE BEGIN Input.Taste:=Input.Eingabezeile[Input.Zeiger];
                  Inc(Input.Zeiger)
            END
  END;

  PROCEDURE liesUpcase(VAR Input : T_Input);
  BEGIN
    Lies(Input); Input.Taste:=Upcase(Input.Taste);
  END;

  PROCEDURE Lieswert(VAR Input: T_Input; VAR wert: LongInt);
  BEGIN
    wert:=0;
    WHILE Input.Taste=' ' DO liesUpcase(Input);
    IF ((Input.Taste>='0') AND (Input.Taste<='9')) OR
       ((Input.Taste>='A') AND (Input.Taste<='F'))
      THEN WHILE ((Input.Taste>='0') AND (Input.Taste<='9')) OR
                 ((Input.Taste>='A') AND (Input.Taste<='F'))
             DO BEGIN Wert := Wert * 16 + ord(Input.Taste);
                      IF Input.Taste <= '9' THEN Dec(wert,48)
                                            ELSE Dec(wert,55);
                      liesUpcase(Input)
                END
      ELSE MonFehler('Hexwert erwartet')
  END;

  PROCEDURE lies_und_sende_adresse(VAR Input :T_Input; VAR Adresse: LongInt);
  BEGIN
    Lieswert(Input, Adresse);
    IF Adresse >=$8000000 THEN Adresse:=Adresse AND $FFFFFFFE;
    Set_Adresse(Adresse);
  END;

  PROCEDURE lies_und_sende_Word(VAR Input :T_Input; VAR Adresse: LongInt);
  VAR lHilf: LongInt;
      hilf: Word;
  BEGIN
    Lieswert(Input, lhilf);
    Hilf := LHilf mod $10000;
    put_Byte(Bef_SetByte); put_byte(2); put_byte(Hi(Hilf)); Put_Byte(lo(hilf));
    inc(Adresse,2)
  END;

  PROCEDURE lies_und_sende_Byte(VAR Input :T_Input; VAR Adresse: LongInt);
  VAR lHilf: LongInt;
      hilf: Word;
  BEGIN
    Lieswert(Input, lhilf);
    Hilf := LHilf mod $100;
    put_Byte(Bef_SetByte); put_byte(1); put_byte(Hilf);
    inc(Adresse,1)
  END;

  PROCEDURE hole_und_zeige_Mem(VAR S,AscS: Str80; VAR Adr : LongInt);
  VAR l,h : Byte;
      Abbruch: Boolean;

     FUNCTION MonChr(b:Byte):Char;
     BEGIN IF b < $1F THEN MonChr:=' ' ELSE MonChr:=Chr(b) END;

  BEGIN
     IF (Adr >= $1000000) AND (Adr < $8000000)
        THEN BEGIN
               put_Byte(Bef_ReadByte); put_Byte(1);
               Read_Byte_HS(l,Abbruch);
               S := S + ' ' +HexByte(l); Adr:=Adr+1;
               IF l <= $1F THEN l:=$20;
               AscS:=AscS+MonChr(l)
             END
        ELSE BEGIN
               put_Byte(Bef_ReadByte); put_Byte(2);
               Read_Byte_HS(h,Abbruch); Read_Byte_HS(l,Abbruch);
               S := S + ' ' + hexByte(h)+HexByte(l); Adr:=Adr+2;
               IF l <= $1F THEN l:=$20;
               AscS:=AscS+MonChr(h)+MonChr(l)
             END
  END;

  PROCEDURE zeige_adresse(VAR S: Str80; Adresse : LongInt);
  BEGIN S := ''; s:=hexAdr(Adresse); S:=S + ': ' END;

  PROCEDURE Get_Register;
  VAR i: Integer;
  BEGIN
    Put_Byte(4);
    Read_Long_HS(M.SH.VBR,M.Abbruch); Read_Long_HS(M.SH.GBR,M.Abbruch);
    Read_Long_HS(M.SH.MACH,M.Abbruch); Read_Long_HS(M.SH.MACL,M.Abbruch);
    FOR i:=0 TO 15 DO Read_Long_HS(M.SH.R[i],M.Abbruch);
    Inc(M.SH.R[15],12);         (* Korrektur, da R15 zu tief liegt *)
    Read_Long_HS(M.SH.PR,M.Abbruch);
    Read_Long_HS(M.SH.PC,M.Abbruch); Read_Long_HS(M.SH.SR,M.Abbruch);
  END;

  PROCEDURE Put_Register;
  VAR i: Byte;
  BEGIN
    Dec(M.SH.R[15],12);   (* Korrektur von R15 ist noetig *)
    Put_Byte(3);
    Put_Long(M.SH.VBR); Put_Long(M.SH.GBR);
    Put_Long(M.SH.MACH); Put_Long(M.SH.MACL);
    FOR i:=0 TO 15 DO Put_Long(M.SH.R[i]);
    Put_long(M.SH.PR);
    Put_Long(M.SH.PC); Put_Long(M.SH.SR);
  END;


  PROCEDURE show_register;
  VAR i: byte;
      s: String;

      FUNCTION Ziffer(z:Byte):Char;
      BEGIN
        Ziffer:=chr(Ord('0')+z)
      END;

  BEGIN
    MonForm.Register.Clear;
    FOR i:=0 to 2 DO MonForm.Register.lines.Add(' ');
    s:=
     '   PC '+HexLong(M.SH.PC)
    +'       PR '+Hexlong(M.SH.PR)
    +'       SR '+Hexlong(M.SH.SR)
    +'     M='+Ziffer((M.SH.SR shr 8) AND 1)
    +'  Q='+Ziffer((M.SH.SR shr 7) AND 1)
    +' I=';
    IF M.SH.SR shr 4 > 9 THEN s:=s+Ziffer(((M.SH.SR shr 4)AND $F) DIV 10);
    s:=s+ Ziffer((M.SH.SR shr 4) mod 10)
    +' S='+Ziffer((M.SH.SR shr 1) AND 1)
    +' T='+Ziffer(M.SH.SR AND 1);
    monform.register.Lines[0]:=s;
    MonForm.Register.Lines[1]:=
       '  VBR '+hexlong(M.SH.VBR)
      +'      GBR '+Hexlong(M.SH.GBR)
      +'     MACH '+Hexlong(M.SH.MACH)
      +'     MACL '+HexLong(M.SH.MACL);
    s:='R0-7 ';
    FOR i:=0 TO 7 DO s:=s+' '+Hexlong(M.SH.R[i]);
    MonForm.Register.lines[2]:=s;
    s:='R8-15';
    FOR i:=8 TO 15 DO s:=s+' '+Hexlong(M.SH.R[i]);
    MonForm.Register.lines[3]:=s;
  END;

  PROCEDURE read_register;
  VAR i: byte;
  BEGIN
    get_register; show_register;
  END;

  PROCEDURE readmanyWords(VAR Adr :LongInt; Endadr : LongInt);
  VAR S: Str80;
      AscS: Str80;
      Taste : Char;
  BEGIN
    REPEAT zeige_adresse(S,Adr);
           AscS:='';
           REPEAT hole_und_zeige_mem(S,AscS,Adr)
           UNTIL (adr>Endadr) OR (adr AND $F = 0);
           while length(s)<=60 do s:=s+' '; s:=s+AscS;
           Screen_Writeln(MonScreen,s);

    UNTIL  (Adr>Endadr);
  END;

  PROCEDURE Movebefehl(VAR QuellAdresse: LongInt; Endadresse: LongInt;
                       VAR Input: T_Input);
  VAR ZielSAdresse : LongInt;
      b: byte;
  BEGIN
    Put_Byte(Bef_Move); put_Long(Endadresse);
    liesUpcase(Input); lieswert(Input,ZielSAdresse);
    Put_Long(ZielSAdresse);
    Read_Byte_Slave_mon(b,M.Abbruch);  (* (lange) warten, bis Move fertig *)
  END;

  PROCEDURE VerifyBefehl(VAR Adresse: LongInt; Endadresse: LongInt;
                         VAR Input: T_Input);

  VAR ZielSAdresse : LongInt;
      b            : Byte;
      Zeile        : Str80;
      Taste        : Char;
      M_old        : T_M;
  BEGIN
   Get_Register;    (* Registersatz lesen *)
   M_Old:=M;
   liesUpcase(Input); lieswert(Input,ZielSAdresse);
   M.SH.R[5]:=Adresse; M.SH.R[6]:=Endadresse; M.SH.R[7]:=ZielSAdresse;
   REPEAT
      Taste:=#0;
      Put_Register;                     (* Registersatz schreiben *)
      Put_Byte(Bef_Verify);             (* Verify starten *)
      read_byte_Slave_mon(b,M.Abbruch);     (* (lange) auf Antwort warten *)
      IF b = 1                          (* Unterschied gefunden *)
         THEN BEGIN
                Get_Register;
                Zeile:=Hexadr(M.SH.R[5])+':'+Hexbyte(M.SH.R[3])
                       +'  '+HexAdr(M.SH.R[7])+':'+Hexbyte(M.SH.R[4]);
                IF Messagedlg(Zeile+' weiter vergleichen?',mtconfirmation,
                              [mbyes,mbno],0)=idyes
                   then b:=1 else b:=2;
                inc(M.SH.R[5]); Inc(M.SH.R[7])  (* Zeiger erhoehen *)
              END
    UNTIL (b <> 1) OR M.Abbruch OR (M.SH.R[5]>Endadresse);
    m:=M_Old; Put_Register;
    IF b=0 THEN MonDialog('Verify ok');
  END;

  PROCEDURE lies_Endadresse(VAR Adresse: LongInt; Endadresse: LongInt;
                            VAR Input: T_Input);
  BEGIN          { muss hier Endadresse nicht VAR sein ???? }
    liesUpcase(Input);
    lieswert(Input, Endadresse);
    CASE Input.Taste OF
      #13: readmanywords(Adresse, EndAdresse);
      'M': Movebefehl(Adresse, EndAdresse, Input);
      'V': Verifybefehl(Adresse, EndAdresse, Input)
    END
  END;

  PROCEDURE SetMem(VAR Adresse: LongInt; VAR Input: T_Input);
  BEGIN REPEAT liesUpcase(Input);
               IF Adresse < $8000000
                  THEN Lies_und_sende_Byte(Input,Adresse)
                  ELSE lies_und_sende_Word(Input, Adresse);
        UNTIL Input.Taste <> ' '
  END;

PROCEDURE Set_Trace;
BEGIN
  Set_Adresse($5FFFF90);       (* BreakAdressregister     *)
  put_Byte(Bef_SetByte); put_byte(10); Put_Long(M.NextTrAdr);
  put_Long(0); put_Word(M.BRR);     (* BMR aus, BRR aktivieren *)
  Set_Adresse(M.GoAdr); Put_Byte(Bef_Go);
  M.Traceaktiv:=False;
  Slave;
END;

  PROCEDURE set_register(VAR Adresse : LongInt; VAR Input : T_Input);
  VAR RegName: Str20;
      Wert: LongInt;
      Index: Integer;
      RegOk: Boolean;
  BEGIN { Set_Register }
    get_register;
    RegName:='';
    WHILE input.Taste IN ['0'..'9','A'..'Z'] DO
      BEGIN RegName:=RegName+Input.Taste; LiesUpcase(Input) END;
    IF Input.Taste=':'
       THEN BEGIN Input.Taste:=' '; Lieswert(Input,Wert) END
       ELSE RegOk:=False;
    IF RegName[1]='R'
       THEN BEGIN IF (RegName[0]=#2) AND (RegName[2] IN ['0'..'9'])
                     THEN BEGIN Index:=ord(RegName[2])-$30; RegOk:=True END;
                  IF (RegName[0]=#3) AND (RegName[2] ='1')
                     AND (RegName[3] IN ['0'..'5'])
                     THEN BEGIN Index:=ord(RegName[3])-$30+10; RegOk:=True END;
                  M.SH.R[Index]:=Wert
            END
    ELSE IF RegName='MACL' THEN BEGIN M.SH.MACL:=Wert; RegOk:=True END
    ELSE IF RegName='MACH' THEN BEGIN M.SH.MACH:=Wert; RegOk:=True END
    ELSE IF RegName='PC'   THEN BEGIN M.SH.PC:=Wert; RegOk:=True END
    ELSE IF RegName='VBR'  THEN BEGIN M.SH.VBR:=Wert; RegOk:=True END
    ELSE IF RegName='GBR'  THEN BEGIN M.SH.GBR:=Wert; RegOk:=True END
    ELSE IF RegName='I'
            THEN BEGIN IF Wert IN [$10..$15] THEN Wert:=Wert-6; (* Hex-Dez *)
                       RegOk:=(Wert IN [0..15]);
                       IF RegOk THEN M.SH.SR:=(M.SH.SR AND $FFFFFF0F)+Wert shl 4
                 END
    ELSE IF RegName='T'
            THEN BEGIN RegOk:=(Wert IN [0,1]);
                       IF Regok THEN M.SH.SR:=(M.SH.SR AND $FFFFFFFE) + Wert
                 END;
    IF RegOk THEN begin Put_Register; Read_Register; Show_Register END
             ELSE MonDialog('unbekannter Befehl')
  END;

  PROCEDURE Register(VAR Adresse: Longint; VAR Input: T_Input);
  BEGIN
    IF (Input.EingabeZeile[0]=#1) AND (Input.Taste ='R')
       THEN Read_Register
       ELSE Set_Register(Adresse,Input);
  END;

  PROCEDURE Lies_sende_Block(VAR Code : T_Code;
                             VAR diskok : Boolean);
  VAR Anzahl, Anfang, i, j : Word;
  BEGIN
     IF Code.size < PufferBlock
        THEN Anzahl := Code.size
        ELSE Anzahl := PufferBlock;
     Blockread(Code.F, Code.Block, Anzahl);
     Diskok := Ioresult = 0;
     dec(Code.size, Anzahl);
     FOR i := 1 TO Anzahl DO
       BEGIN Put_Byte(Bef_SetByte);
             Put_Byte(128);
             Anfang := (i-1) * 128;
             FOR j := 0 TO 127 DO Put_Byte(Code.Block[Anfang+j])
       END
  END;

  PROCEDURE Loadfile(VAR Input : T_Input);
  VAR Go_Kommando, ok: Boolean;
      i: Word;
  BEGIN                         (* Loadfile *)
    Code.Name:=''; Lies(Input);
    WHILE NOT (Input.Taste IN [' ',#13,',']) DO
      BEGIN Code.Name:=Code.Name+Input.Taste; Lies(Input) END;
     IF Code.Name <> ''
       THEN BEGIN IF Input.Taste=','
                     THEN BEGIN LiesUpcase(Input);
                                Lieswert(Input, Code.StartAdresse);
                          END
                     ELSE Code.Startadresse:=-1;
                   Codedatei_Laden(Code.Name,NOT quick);
           END
  END;

PROCEDURE TraceIt;
VAR DisZ:  T_DisZ;
    Taste: Char;
BEGIN
  M.Breakaktiv:=False;
  Read_register;
  M.Adresse:=M.SH.PC; M.GoAdr:=M.Adresse; M.BRR:=$54;
  Set_Adresse(M.Adresse);
  Disasszeile(DisZ);
  MonScreen.Y:=MonScreen.MaxY;  (* in die letzte Zeile schreiben *)
  Ausgabe(DisZ); M.NextTrAdr:=DisZ.NextAdr;
  IF (DisZ.Befehl[1]='.')
     AND NOT ((DisZ.Befehl='.BRAL') OR (DisZ.Befehl='.BSRL')
              OR (DisZ.Befehl='.MOVAL')) THEN M.BRR:=0;
  WHILE DisZ.STCTyp
       DO BEGIN Disasszeile(DisZ);
                Ausgabe(DisZ); M.NextTrAdr:=DisZ.NextAdr
          END;
  IF DisZ.Slotaktiv
     THEN BEGIN Disasszeile(DisZ); Ausgabe(DisZ) END;
  MonForm.KontButn.Visible:=False;
  MonForm.EndBreak.Visible:=False;
  MonForm.OTrace.Visible:=True;
  MonForm.MTrace.Visible:=True;
  MonForm.XTrace.Visible:=True;
  MonForm.Brklabel.Visible:=True;
  MonForm.BrkLabel.Caption:='Trace-Unterbrechung vor $'
                            +Hexlong(M.Goadr);
  MonForm.Keyboard.Caption:='Befehl';
  MonForm.MonMode.Caption:='Host=Master';
END;
  
PROCEDURE Start_Master;
BEGIN
  MonForm.Show;
  MonForm.LoadButton.Enabled:=True;
  MonForm.Keyboard.Caption:='Befehl';
  MonForm.MonMode.Caption:='Host=Master';
  MonForm.BrkLabel.Caption:='';
  MonForm.MonBefehl.Text:='';
  MonForm.MonBefehl.enabled:=True;
  MonForm.MonBefehl.Setfocus;
  GlobVar.Host_ist_Slave:=False;
  MonForm.EndBreak.Visible:=False;
  MonForm.KontButn.Visible:=False;
END;

  PROCEDURE Hostslave;

  PROCEDURE IllIRQ;
    VAR b,Typ: Byte;
    BEGIN Read_Byte(Typ,M.Abbruch);
{         write('nicht initialisierter ');
          CASE Typ OF
            0: write('SCI');
            1: write('SPI');
            2: write('Pulse Akku Input Edge');
            3: write('Pulse Akku Output');
            4: write('Timer Overflow');
            5: write('TOC3');
            6: write('TOC2');
            7: write('TOC1');
            8: write('TIC3');
            9: write('TIC2');
           10: write('TIC1');
           11: write('RTI');
           12: write('externer IRQ');
           13: write('SWI')
          END;
          Writeln('-Interrupt',#7);
}
          REPEAT Read_Byte(b,M.Abbruch) UNTIL b=0; (* warte auf Monitorfreigabe *)
    END;

    PROCEDURE Breakpoint;
    VAR BkptNr : Byte;
        BkptStr: String;
    BEGIN
      read_Byte_HS_mon(BkptNr,M.abbruch);
      Str(BkptNr,BkptStr);
      Get_Register;
      Bkptstr:='Breakpoint #'+Bkptstr+' bei Adresse '
                             +hexadr(M.SH.pc);
      MonDialog('Unterbrechung durch '+Bkptstr);
      M.Adresse:=M.SH.PC; M.Breakadresse:=M.Adresse+2;
      M.Breakaktiv:=true; M.Traceaktiv:=False;
      GlobVar.Host_ist_Slave:=False;
      MonForm.KontButn.Visible:=True;
      MonForm.XTrace.Visible:=False;
      MonForm.MTrace.Visible:=False;
      MonForm.OTrace.Visible:=False;
      MonForm.BrkLabel.Visible:=True;
      MonForm.EndBreak.Visible:=True;
      MonForm.BrkLabel.Caption:=bkptstr;
      MonForm.Keyboard.Caption:='Befehl';
      MonForm.MonMode.Caption:='Host=Master';
    END;

    PROCEDURE Mon_Error(Meldung: Str80);
    VAR DisZ : T_DisZ;
    BEGIN
       MonDialog('Fehler: '+Meldung);
       Read_register; M.Adresse:=M.SH.PC; Set_Adresse(M.Adresse);
       Disasszeile(DisZ); Ausgabe(DisZ);
    END;

    PROCEDURE Mon_Message;
    VAR Nr: Byte; Nr_Str: String;
    BEGIN
      Read_Byte_HS_mon(Nr,M.Abbruch);
      str(Nr,Nr_Str);
      CASE Nr OF
        0: Mon_Error('Illegaler Opcode');
        1: Mon_Error('Illegale Slot-Anweisung nach einem Sprungbefehl mit Ziel:');
        2: Mon_Error('Adresszugriff zwei Anweisungen vor:');
        3: Mon_Error('DMA-Adresszugriff, aktueller PC:');
        4: Mon_Error('nicht initialisierter Interrupt, aktueller PC:');
        5: TraceIt;
      ELSE MonDialog('Woher kommt Meldung '+Nr_str+'??')
      END;
      GlobVar.Host_ist_Slave:=False;
    END;

    PROCEDURE SlaveGotoxy;
    VAR x,y: Byte;
    BEGIN
      Read_Byte_HS_Mon(x,M.Abbruch);
      Read_Byte_HS_Mon(y,M.Abbruch);
      Screen_Gotoxy(Slavescreen,x,y)
    END;

  VAR B     : Byte;      (* HostSlave *)
      Taste : Char;
      strg:string;
      Startzeit: ReaL;
      nix: Integer;
  BEGIN
   {IF GlobVar.Wait_For_Key
      THEN BEGIN IF Slavekey<>#0
                    THEN BEGIN
                           put_Byte(ord(Slavekey));
                           Slavekey:=#0;
                           GlobVar.Wait_For_Key:=False;
                         END
           END
      ELSE}
   IF SerByte_da then
   BEGIN
    read_Byte_Slave_mon(b,M.Abbruch);
    IF M.Abbruch OR (b=255)
                THEN BEGIN GlobVar.Host_ist_Slave:=False;
                           nix:=Messagedlg('Verbindung zum Luchs abgebrochen',
                                           MTinformation,[mbok],0);
                           endmon
                     END
    ELSE IF b=0 THEN BEGIN Luchs_Info('LUCHS-Programm beendet');Start_Master END
    ELSE IF b=1 THEN BEGIN IF Slavekey>#0 THEN Put_Byte(1) ELSE Put_Byte(0) END
    ELSE IF b=2 THEN begin IF Slavekey<>#0
                              then begin put_byte(ord(Slavekey)); Slavekey:=#0 end
                              else GlobVar.Wait_For_Key:=True
                     end
    ELSE IF b=3 THEN BEGIN GlobVar.Host_Ist_Slave:=False;
                           M.EndKomm:=True;
                           nix:=Messagedlg('Verbindung zum Luchs beendet',
                                           MTinformation,[mbok],0);
                           endmon;
                     END
    ELSE IF b=4 THEN Mon_Message
    ELSE IF b=5 THEN IllIrq
    ELSE IF b=6 THEN Breakpoint
    ELSE IF b=$1E THEN SlaveGotoxy
    ELSE Ausgabe_write(SlaveScreen,chr(b));
 {   Startzeit:=Time;
    REPEAT Until SerByte_da OR (Time-Startzeit>1e-5);}
   END;
 { IF MonForm.visible then MonForm.MonBefehl.SetFocus}
  END;

PROCEDURE InitM;
BEGIN
 M.Adresse:=0; M.EndKomm:=False;
 M.ExecEnd:=False; M.Traceaktiv:=False;
 M.Breakaktiv:=False; M.Abbruch:=False;
END;

PROCEDURE Slave;
BEGIN
   MonForm.Keyboard.Caption:='Eingabe';
   MonForm.MonMode.Caption:='Host=Slave';
   GlobVar.Host_ist_Slave:=True;
   MonForm.Loadbutton.Enabled:=False;
   GlobVar.Wait_For_Key:=False;
   Slavekey:=#0;
END;

PROCEDURE Start_Slave;
BEGIN
   InitM;
   Put_Byte(Bef_Go);
   Slave;
END;

PROCEDURE Continue;
BEGIN
  IF M.Breakaktiv
     THEN BEGIN
            Set_Adresse(M.BreakAdresse);
            Put_Byte(Bef_Go);
            M.Breakaktiv:=False;
            MonForm.BrkLabel.Visible:=False;
            MonForm.KontButn.Visible:=False;
            MonForm.Endbreak.visible:=False;
            Slave;
          END
     ELSE MonDialog('BREAK ist nicht aktiv')
END;

PROCEDURE Execute(Work: T_WorkFile; VAR Meldung: T_Meldung);

PROCEDURE StartFile(Filename: T_FileName; VAR ok : Boolean);
  BEGIN
    Assign(Code.f,FileName); reset(Code.f); ok:=Ioresult = 0;
    IF ok
       THEN BEGIN
              Code.size := Filesize(Code.F)- 1;
              Blockread(Code.f, Code.Block, 1);
              Code.Startadresse := Code.Block[0] * $1000000 +
                                   Code.Block[1] * $10000 +
                                   Code.Block[2] * $100 +
                                   Code.Block[3];
          {   Code.Laenge :=       Code.Block[4] SHL 24 +
                                   Code.Block[5] SHL 16 +
                                   Code.Block[6] SHL  8 +
                                   Code.Block[7]; }
              Set_adresse(Code.Startadresse);
              WHILE (Code.size > 0) AND ok DO
                 Lies_Sende_Block(Code,ok);
                 IF NOT ok THEN {Fehler('Lesefehler');}
              Close(Code.f);
              Set_Adresse(Code.StartAdresse)
            END
       ELSE { Fehler('File ' + CName + ' nicht vorhanden');  }
END;


VAR Taste      : Char;
    b          : Byte;
    ok         : Boolean;
BEGIN                       (* Execute *)
{
  M.Abbruch:=False;
  Start_Kommunikation(Sys,ok,Meldung);
  IF ok
     THEN BEGIN
            StartFile(Work.CName, Ok);
            IF ok
               THEN BEGIN
                      Meldung[1]:='Programm im RAM starten?';
                      Meldung[3]:='        S(tandalone';
                      Meldung[4]:='        H(ostrechner';
                      Meldung[5]:='        N(icht starten';
                      (*
                      Show_Meldung(Meldung);
                      Taste:=Upcase(Readkey);
                      *)
                      IF (Taste='S') OR (Taste='H')
                       THEN Put_Byte(Bef_Go);
                      IF Taste='S' THEN Meldung[3]:='Programm gestartet...';
                      IF Taste='H'
                       THEN BEGIN
                             (*clrscr;*)
                             InitM(M);
                             REPEAT
                              IF M.Hostkommando
                               THEN Monitor_main(M)
                               ELSE HostSlave(M);
                              IF M.ExecEnd THEN Put_Byte(Bef_Quit)
                             UNTIL M.EndKomm OR M.ExecEnd OR M.Abbruch
                            END;
                      IF Taste='N' THEN Put_Byte(Bef_Quit);
                    END
               ELSE Meldung[5]:='Fehler beim Einlesen von '+Work.CName;
          END
          }
END;

procedure Tmonform.QuitMonClick(Sender: TObject);
begin
  EndMon
end;


  PROCEDURE Monitoradresse(VAR Input : T_Input);
  VAR S,AscS: Str80;
      EndAdresse : LongInt;
  BEGIN
    lies_und_sende_adresse(Input, M.Adresse);
    CASE Input.Taste OF
         ':':  setmem(M.Adresse, Input);
         '.':  Lies_Endadresse(M.Adresse, EndAdresse, Input);
         'Z':  Disassemble;
         'G':  Start_Slave;
         'T':  BEGIN M.NextTrAdr:=M.Adresse;
                     M.GoAdr:=M.Adresse;
                     M.BRR:=$54;
                     Set_Trace
                END;
         ELSE  BEGIN zeige_adresse(S,M.Adresse);
                     AscS:='';
                     hole_und_zeige_mem(S,AscS,M.Adresse);
                     Screen_writeln(MonScreen,s+'   '+AscS);
               END
      END
  END;


Procedure Screen_Init;
VAR ChrBreite:Integer;
BEGIN
  MonForm.Top:=Screeninfo.MonWin.WinTop;
  MonForm.Left:=Screeninfo.MonWin.WinLeft;
  MonForm.Height:=Screeninfo.MonWin.WinHeight;
  MonForm.Width:=Screeninfo.MonWin.WinWidth;
  {
  MonForm.Register.Font.Size:=Screeninfo.MonWin.WinFont.Size;
  MonForm.Register.Font.assign(Mainform.Courierlabel.font);

  MonForm.Register.Font  := Screeninfo.MonWin.WinFont;
  MonForm.MonBefehl.Font := Screeninfo.MonWin.Winfont;
  MonForm.Ausgabe.Font   := Screeninfo.MonWin.WinFont;
  MonForm.Display.Font   := Screeninfo.MonWin.WinFont;
  }
  MonScreen.MaxX:=MonMaxX; MonScreen.MaxY:=MonMaxY;
  MonScreen.Feld:=MonForm.Ausgabe;
  SlaveScreen.MaxX:=Sysinfo.SlaveMaxX-1;
  SlaveScreen.MaxY:=Sysinfo.SlaveMaxY-1;
  ChrBreite := 9; {MainForm.Courierlabel.Canvas.TextWidth('-')};
  MonForm.Display.height:=SysInfo.SlaveMaxY*(-MonForm.Display.Font.Height+2)+5;
  MonForm.Display.Width:=(SlaveScreen.MaxX)*(ChrBreite+1);
  MonForm.Display.DefaultRowHeight:=-MonForm.Display.Font.Height+2;
{
luchs_dialog('ChrBreite=',chrBreite);
luchs_dialog('FontSize=',MonForm.Display.Font.size);
 }
  MonForm.Display.Left:=MonForm.Taste11.Left-MonForm.Display.Width-20;
  SlaveScreen.Feld:=MonForm.Display;
  Screen_Clrscr(MonScreen); Screen_Clrscr(Slavescreen);
END;

procedure Monitor;
var ok:boolean;
    Ergebnis: Word;
    Fehler: String;
begin
  Show_Code_Namen;
  IF GlobVar.Mon_aktiv
     THEN BEGIN MonForm.Show;
                MonForm.MonBefehl.enabled:=True;
                MonForm.MonBefehl.Setfocus;
          END
     ELSE BEGIN
            Start_Kommunikation(ok,Fehler);
            if not ok
               THEN Mondialog(Fehler)
               ELSE BEGIN
                     GlobVar.Mon_aktiv:=ok;
                     MonForm.Show;
                     InitM;
                     Get_Register; Show_Register;
                     Start_Master;
                   END
          END;
end;

procedure MonBefehlAusfuehren;
VAR Startadresse,EndAdresse : LongInt;
    Input      : T_Input;
BEGIN
  Input.eingabezeile:=MonForm.MonBefehl.Text;
  IF (monform.MonBefehl.Text[0]=#1)
      AND (Upcase(MonForm.MonBefehl.Text[1])='Q')
   THEN EndMon
   ELSE BEGIN
    Input.Zeiger:=1; Input.Taste := ' ';
    REPEAT liesUpcase(Input) UNTIL Input.Taste <> ' ';
         IF Input.Taste=#13  THEN BEGIN Endadresse:=M.Adresse OR $F;
                                        readmanywords(M.Adresse, EndAdresse)
                                  END
    ELSE IF Input.Taste=':'  THEN setmem(M.Adresse, Input)
    ELSE IF Input.Taste='Z'  THEN disassemble
    ELSE IF Input.Taste='L'  THEN Loadfile(Input)
    ELSE IF Input.Taste='K'  THEN BEGIN
                                    IF M.Traceaktiv
                                       THEN BEGIN Set_Trace;
                                                  MonForm.MonBefehl.SetFocus
                                             END
                                       ELSE Continue
                                  END
    ELSE IF Input.Taste IN ['0'..'9','A'..'F']
                             THEN Monitoradresse(Input)
    ELSE Register(M.Adresse, Input)
   END
end;

Procedure Tasteneingabe(ch: Char);
var Zielstring: String;
begin
    if GlobVar.Host_ist_Slave
     then if GlobVar.Wait_For_Key
             then begin put_Byte(ord(ch));
                        Slavekey:=#0;
                        GlobVar.Wait_For_Key:=False;
                  end
             else Slavekey:=ch;
    MonForm.MonBefehl.SetFocus
end;


procedure Tmonform.MonBefehlKeyPress(Sender: TObject; var Key: Char);
var zielstr: string;
begin
  if GlobVar.Host_ist_Slave
     then begin Tasteneingabe(key);
                key:=#0
          end
     else begin
           if key =#13
             then begin key:=#0;
                        MonBefehlausfuehren;
                        MonForm.MonBefehl.Text:=''
                  end;
           end
end;

procedure Tmonform.FormClose(Sender: TObject; var Action: TCloseAction);
var nix: word;
begin
  IF GlobVar.Mon_Aktiv
    THEN BEGIN nix:=MessageDlg('Monitor noch aktiv!', mtError,[mbok], 0);
               Action := caNone
         END;
end;

procedure Tmonform.MonQuitClick(Sender: TObject);
begin
  EndMon
end;

procedure Tmonform.MTraceClick(Sender: TObject);
begin
   MonForm.MonBefehl.Setfocus;
   Set_Trace;  (* weitermachen   *)
end;

procedure Tmonform.OTraceClick(Sender: TObject);
begin
  MonForm.MonBefehl.Setfocus;
  MonForm.OTrace.Visible:=False;
  MonForm.MTrace.Visible:=False;
  MonForm.XTrace.Visible:=False;
  MonForm.BrkLabel.Visible:=False;
  M.BRR:=0; Set_Trace;   (* Trace beenden, aber weitermachen *)
end;

procedure Tmonform.XTraceClick(Sender: TObject);
VAR b: Byte;
begin                             (* Programm abbrechen *)
  put_Byte(Bef_Abbruch);
  Read_Byte_Slave_mon(b,M.Abbruch);   (* Luchs sendet eine 0 *)
  MonDialog('Programm abgebrochen');
  MonForm.MonBefehl.Setfocus;
  MonForm.BrkLabel.Visible:=False;
  MonForm.OTrace.Visible:=False;
  MonForm.MTrace.Visible:=False;
  MonForm.XTrace.Visible:=False;
  GlobVar.Host_ist_Slave:=False;
  MonForm.Keyboard.Caption:='Befehl';
  MonForm.MonMode.Caption:='Host=Master';
  Start_Master;
end;

procedure Tmonform.KontButnClick(Sender: TObject);
begin
  MonForm.MonBefehl.Setfocus;
  Continue;
end;

procedure Tmonform.endkommclick(Sender: TObject);
begin
  endmon
end;

procedure Tmonform.MenuClick(Sender: TObject);
begin
  MainForm.BringToFront; {monform.hide;}
end;

FUNCTION StartAdr_ok: Boolean;
VAR i   : Word;
    Wert: LongInt;
    ok  : Boolean;
    AdrString: String;
BEGIN
  AdrString:=MonForm.ZielEdit.Text;
  ok:=AdrString[1]='$';
  Wert:=0;
  FOR i:=2 to length(AdrString) DO
      CASE Upcase(AdrString[i]) OF
       '0'..'9': Wert:=Wert*16+Ord(Upcase(AdrString[i]))-48;
       'A'..'F': Wert:=Wert*16+Ord(Upcase(AdrString[i]))-55;
       ELSE      ok:=False
     END;
  Code.Startadresse:=Wert;
  StartAdr_ok:=ok
END;

PROCEDURE Dateiladen;
VAR Nr,Groesse: Word;
    ok: Boolean;
begin
  ok:=True;
  MonForm.MonGauge.Progress:=0;
  MonForm.MonGauge.Visible:=True;
  MonForm.Update;
  Monform.Zielpanel.Visible:=False;
  Set_Adresse(Code.Startadresse);
  Nr:=0; Groesse:=(Code.Size+1) div 2;
  WHILE (Code.size > 0) AND ok DO
        BEGIN Lies_Sende_Block(Code, ok);
              Inc(Nr);
              MonForm.MonGauge.Progress:=Nr * 100 DIV Groesse;
        END;
  Close(Code.f);
  MonForm.MonGauge.Visible:=False;
  ExitMainGauge;
  Set_Adresse(Code.StartAdresse);
  IF ok THEN
     IF Code.Quickload
        THEN begin Put_Byte(Bef_go); slave;
                    Codename_merken(Code.Name)
             end
        ELSE BEGIN IF messagedlg(Code.Name+' ab Adresse=$'
                      +Hexlong(Code.Startadresse)+' starten?',
                      mtConfirmation,[mbyes,mbno],0)=idyes
                      THEN begin Put_Byte(Bef_go); slave end;
                    Codename_merken(Code.Name);
             END;
  MonForm.Dateiname.Caption:='Datei: '+Code.Name+'  $'+HexLong(Code.Startadresse);
  MonForm.Dateiname.Visible:=True;
  MonForm.MonBefehl.Setfocus;
  MonForm.MonGauge.Visible:=False;
end;

PROCEDURE CodeDatei_laden(DateiName: T_Filename; quickld: Boolean);
VAR ok: Boolean;
    Nr,Groesse: Word;
BEGIN
  Code.Quickload:=Quickld;
  Workfile.CName:=Dateiname;
  MonForm.Dateiname.Visible:=True;
  Code.Name:=Dateiname;
  Assign(Code.f,Code.Name);
  reset(Code.f);
  ok:=Ioresult in [0,105];  (* 105 = nur zum lesen geoeffnet *)
  IF ok
     THEN BEGIN
            Code.size := Filesize(Code.F)- 1;
            Blockread(Code.f, Code.Block, 1);
            Code.Startadresse := Code.Block[0] * $1000000 +
                                 Code.Block[1] * $10000 +
                                 Code.Block[2] * $100 +
                                 Code.Block[3];
            IF Code.Quickload
               THEN Dateiladen
               ELSE BEGIN
                       MonForm.Zielnamelabel.Caption:='Laden von '+Code.Name;
                       MonForm.Zielpanel.Visible:=True;
                       MonForm.Zieledit.Text:='$'+Hexlong(Code.Startadresse);
                    END;
          END;
  IF NOT ok THEN MonFehler('Lesefehler bei '+Code.Name);
END;

procedure Tmonform.LoadButtonClick(Sender: TObject);
begin
  IF Workfile.CName<>'' THEN LoadMonFile.Filename:=Workfile.CName;
  IF MonForm.LoadMonFile.Execute
     THEN Codedatei_laden(MonForm.LoadMonFile.Filename,NOT quick);
end;

procedure Tmonform.FormClick(Sender: TObject);
begin
   MonForm.Show; MonForm.enabled:=True;
   MonForm.MonBefehl.SetFocus;
end;

procedure Tmonform.endbreakClick(Sender: TObject);
begin
   Start_Master
end;

procedure Tmonform.Taste42Click(Sender: TObject);
begin
  Tasteneingabe('0')
end;

procedure Tmonform.Taste11Click(Sender: TObject);
begin
  Tasteneingabe('1');
end;

procedure Tmonform.Taste12Click(Sender: TObject);
begin
  Tasteneingabe('2');
end;

procedure Tmonform.Taste13Click(Sender: TObject);
begin
  Tasteneingabe('3');
end;

procedure Tmonform.Taste21Click(Sender: TObject);
begin
  Tasteneingabe('4');
end;

procedure Tmonform.Taste22Click(Sender: TObject);
begin
  Tasteneingabe('5');
end;

procedure Tmonform.Taste23Click(Sender: TObject);
begin
  Tasteneingabe('6');
end;

procedure Tmonform.Taste31Click(Sender: TObject);
begin
  Tasteneingabe('7');
end;

procedure Tmonform.Button33Click(Sender: TObject);
begin
  Tasteneingabe('8');
end;

procedure Tmonform.Taste33Click(Sender: TObject);
begin
  Tasteneingabe('9');
end;

procedure Tmonform.Taste41Click(Sender: TObject);
begin
  Tasteneingabe('A');
end;

procedure Tmonform.Taste43Click(Sender: TObject);
begin
  Tasteneingabe('B');
end;

procedure Tmonform.xeingabeKeyPress(Sender: TObject; var Key: Char);
begin
   MonBefehlKeypress(Sender,key)
end;


procedure Tmonform.Menu1Click(Sender: TObject);
begin
  MainForm.BringToFront;
  Monbefehl.enabled:=false
end;

procedure Tmonform.Quickc1Click(Sender: TObject);
begin
    Codedatei_laden(Sysinfo.Dateiname.Codename[1],quick);
end;

procedure Tmonform.Quickc2Click(Sender: TObject);
begin
   Codedatei_laden(Sysinfo.Dateiname.Codename[2],quick);
end;

procedure Tmonform.Quickc3Click(Sender: TObject);
begin
   Codedatei_laden(Sysinfo.Dateiname.Codename[3],quick);
end;

procedure Tmonform.Quickc4Click(Sender: TObject);
begin
   Codedatei_laden(Sysinfo.Dateiname.Codename[4],quick);
end;

procedure Tmonform.Quickc5Click(Sender: TObject);
begin
   Codedatei_laden(Sysinfo.Dateiname.Codename[5],quick);
end;

procedure Tmonform.Quickc6Click(Sender: TObject);
begin
   Codedatei_laden(Sysinfo.Dateiname.Codename[6],quick);
end;

procedure Tmonform.Load1Click(Sender: TObject);
begin
  IF Workfile.CName<>'' THEN LoadMonFile.Filename:=Workfile.CName;
  IF MonForm.LoadMonFile.Execute
     THEN Codedatei_laden(MonForm.LoadMonFile.Filename,not quick);
end;

procedure Tmonform.Stop1Click(Sender: TObject);
begin
   endmon
end;

procedure closefile;
begin close(code.f) end;

procedure Tmonform.ZielokClick(Sender: TObject);
begin
    IF StartAdr_ok
     THEN Dateiladen
     ELSE luchs_Info('Startadresse '+MonForm.Zieledit.Text+' fehlerhaft')
end;

procedure Tmonform.ZielabortClick(Sender: TObject);
begin
  Monform.Zielpanel.Visible:=False;
  Closefile;
  MonForm.MonBefehl.Setfocus;
  MonForm.MonGauge.Visible:=False;
end;

procedure changestartadr(wert,Maske: Longint);
begin
  Code.Startadresse:=(Code.Startadresse AND Maske)+Wert;
  Monform.Zieledit.Text:='$'+Hexlong(Code.Startadresse)
end;

procedure Tmonform.SpinButtongrobDownClick(Sender: TObject);
begin
   changestartadr(-$1000,$FFFFF000);
end;

procedure Tmonform.SpinButtongrobUpClick(Sender: TObject);
begin
   changestartadr($1000,$FFFFF000);
end;

procedure Tmonform.SpinButtonfeinDownClick(Sender: TObject);
begin
   changestartadr(-$80,$FFFFFF80);
end;

procedure Tmonform.SpinButtonfeinUpClick(Sender: TObject);
begin
   changestartadr($80,$FFFFFF80);
end;

procedure Tmonform.QuickneuClick(Sender: TObject);
begin
  IF MonForm.LoadMonFile.Execute
     THEN Codedatei_laden(MonForm.LoadMonFile.Filename,quick);
end;

procedure Tmonform.SpinButton1DownClick(Sender: TObject);
begin
   changestartadr(-$4,$FFFFFFFC);
end;

procedure Tmonform.SpinButton1UpClick(Sender: TObject);
begin
   changestartadr($4,$FFFFFFFC);
end;

procedure Tmonform.BitBtn1Click(Sender: TObject);
begin
     Application.HelpJump('Monitor');
end;

procedure Tmonform.FormActivate(Sender: TObject);
begin
   Screen_Init;
end;

procedure Tmonform.FormDeactivate(Sender: TObject);
begin
  Screeninfo.MonWin.WinTop:=MonForm.Top;
  Screeninfo.MonWin.WinLeft:=MonForm.Left;
  Screeninfo.MonWin.WinHeight:=MonForm.Height;
  Screeninfo.MonWin.WinWidth:=MonForm.Width;
  Screeninfo.Monwin.WinFont:=MonForm.Register.Font;
end;

procedure Tmonform.Font1Click(Sender: TObject);
begin
  MonFontDialog.Font := MonForm.Register.Font;
  if MonFontDialog.Execute
     then BEGIN MonForm.Register.Font  := MonFontDialog.Font;
                MonForm.MonBefehl.Font := MonFontDialog.Font;
                MonForm.Ausgabe.Font   := MonFontDialog.Font;
                MonForm.Display.Font   := MonFontDialog.Font;
          END
end;


procedure Tmonform.Taste14Click(Sender: TObject);
begin
  Tasteneingabe('F');
end;

procedure Tmonform.Button2Click(Sender: TObject);
begin
  Tasteneingabe('E');
end;

procedure Tmonform.Button3Click(Sender: TObject);
begin
  Tasteneingabe('D');
end;

procedure Tmonform.Button4Click(Sender: TObject);
begin
  Tasteneingabe('C');
end;

procedure Tmonform.ComPort1Click(Sender: TObject);
begin
   IF Sysinfo.Win_seriell
      THEN Luchs_info('COM_Windows='+chr($30+Sysinfo.Com)+' Baudrate='+Sysinfo.Baudrate)
      ELSE Luchs_info('COM_Register='+chr($30+Sysinfo.Com)+' Baudrate='+Sysinfo.Baudrate)
end;

end.
