unit Winluchs;

(* 23.10.96 H-J automatische Erzeugung von Luchs.INI *)
(* 23.10.96 H-J neue Textdatei erzeugen, falls noch nicht vorhanden *)

interface

uses
  luchstyp,
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, StdCtrls,Buttons, ExtCtrls,
  Gauges, Grids;

type
  Tmainform = class(TForm)
    Luchs: TBitBtn;
    Editor: TBitBtn;
    AssButton: TBitBtn;
    OpenDialog: TOpenDialog;
    infobutton: TBitBtn;
    Infopanel: TPanel;
    infomemo: TMemo;
    Infolabel: TLabel;
    Infoyes: TBitBtn;
    infocancel: TBitBtn;
    QuitButton: TBitBtn;
    Gauge: TGauge;
    basbutton: TBitBtn;
    Textname: TLabel;
    MainMenu1: TMainMenu;
    QuickWahl1: TMenuItem;
    Quickneu: TMenuItem;
    Quickt1: TMenuItem;
    Quickt2: TMenuItem;
    Quickt3: TMenuItem;
    Quickt4: TMenuItem;
    Quickt5: TMenuItem;
    Quickt6: TMenuItem;
    Monitor1: TMenuItem;
    Editor1: TMenuItem;
    Quit1: TMenuItem;
    Info1: TMenuItem;
    Basic1: TMenuItem;
    Assembler1: TMenuItem;
    Pasbutton: TBitBtn;
    BitBtn2: TBitBtn;
    Pascal1: TMenuItem;
    Mainhelp: TBitBtn;
    Eprombutton: TBitBtn;
    BitBtn1: TBitBtn;
    procedure formcreate(Sender: TObject);
    procedure idle_proc(Sender: TObject; var done: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure EditorClick(Sender: TObject);
    procedure LuchsClick(Sender: TObject);
    procedure infocancelClick(Sender: TObject);
    procedure infobuttonClick(Sender: TObject);
    procedure InfoyesClick(Sender: TObject);
    procedure QuitButtonClick(Sender: TObject);
    procedure QuickneuClick(Sender: TObject);
    procedure Quickt1Click(Sender: TObject);
    procedure Quickt2Click(Sender: TObject);
    procedure Quickt3Click(Sender: TObject);
    procedure Quickt4Click(Sender: TObject);
    procedure Quickt5Click(Sender: TObject);
    procedure Quickt6Click(Sender: TObject);
    procedure Monitor1Click(Sender: TObject);
    procedure Editor1Click(Sender: TObject);
    procedure Quit1Click(Sender: TObject);
    procedure Info1Click(Sender: TObject);
    procedure Basic1Click(Sender: TObject);
    procedure Assembler1Click(Sender: TObject);
    procedure PasbuttonClick(Sender: TObject);
    procedure MainhelpClick(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure EprombuttonClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);

  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  mainform: Tmainform;

implementation

{$R *.DFM}
{  26.05.95 Alf Basis der MOPS-Version 2.2
   20.10.96 Alf gemeinsame DOS/Windows-Version }

USES  CommWin, MoniWin, Editwin, Ass7000, Bas7000, Pas7000, Err_Unit,
      Epromwin,Flashwin;

CONST Version = '[1.1]';



PROCEDURE Init(VAR W: T_WorkFile);
BEGIN
  W.WText  := false;
  W.WCode  := false;
  W.TFehler:= 1;
END;


procedure Tmainform.FormClose(Sender: TObject; var Action: TCloseAction);
var nix: Word;
begin
    IF GlobVar.Mon_Aktiv
    THEN IF MessageDlg('Monitor noch aktiv! Trotzdem abbrechen?',
                         mtconfirmation,[mbyes,mbno], 0)=idyes
            THEN Action := caNone
            ELSE Application.HelpCommand(Help_Quit, 0);
end;

procedure Tmainform.Idle_Proc(Sender: TObject; var Done: Boolean);
begin
  if Globvar.Host_ist_slave
     then HostSlave;
{  MainForm.label1.caption:=chr($30+ord(globvar.host_ist_slave));}
  Done := false;
end;

procedure Show_Datei_Namen;
begin
  Mainform.QuickT1.Caption:=Sysinfo.Dateiname.Textname[1];
  Mainform.Quickt2.Caption:=Sysinfo.Dateiname.Textname[2];
  Mainform.Quickt3.Caption:=Sysinfo.Dateiname.Textname[3];
  Mainform.Quickt4.Caption:=Sysinfo.Dateiname.Textname[4];
  Mainform.Quickt5.Caption:=Sysinfo.Dateiname.Textname[5];
  Mainform.Quickt6.Caption:=Sysinfo.Dateiname.Textname[6];
  Mainform.Textname.Caption:='Textdatei: '+Workfile.TName
end;

procedure textname_merken;
var schon_da: boolean;
    i:word;
begin
  schon_da:=False;
  for i:=1 to maxfiles do
      schon_da:=schon_da or (Workfile.Tname=Sysinfo.Dateiname.Textname[i]);
  IF (Workfile.TName<>'') and (not schon_da)
     THEN BEGIN for i:=maxfiles downto 2 do
                  Sysinfo.Dateiname.Textname[i]:=Sysinfo.Dateiname.Textname[i-1];
                Sysinfo.Dateiname.Textname[1]:=Workfile.TName;
          END;
  Show_Datei_Namen;
end;

PROCEDURE Lies_Dateinamen;
VAR Dateifile: File OF T_Dateiname;
    IO_Ok: Boolean;
    i: Word;
BEGIN
  Sysinfo.Dateifilename:=Copy(SysInfo.ProgName,1,length(SysInfo.Progname)-7)+'.FIL';
  assign(Dateifile,Sysinfo.Dateifilename); Reset(Dateifile); IO_ok:=Ioresult=0;
  IF IO_Ok
     THEN BEGIN Read(Dateifile,Sysinfo.Dateiname);
                IO_Ok:=IO_Ok AND (IOResult=0);
                Close(Dateifile);
                IO_Ok:=IO_Ok AND (IOResult=0)
          END;
  IF NOT IO_Ok THEN FOR i:=1 TO Maxfiles DO
                    BEGIN Sysinfo.Dateiname.Textname[i]:='';
                          Sysinfo.Dateiname.Codename[i]:='';
                    END;
  Show_Datei_namen;
END;

procedure read_info_file;
VAR c : Char;
    x : LongInt;
    w,s : String;
    code,i : Integer;
    Infofile: Text;
    Pfadname: String;
begin
 SysInfo.COM:=1;
 SysInfo.Slavemaxx:=40;
 Sysinfo.Slavemaxy:=4;
 SysInfo.Speed:=16000000;
 SysInfo.Win_Seriell:=False;
 SysInfo.Editorname:='';
 SysInfo.Codestart:=$A004000;
 SysInfo.Progname:=Paramstr(0);
 Pfadname:=Paramstr(0);
 WHILE NOT (Pfadname[length(pfadname)] IN [':','\'])
   DO Pfadname:=Copy(Pfadname,1,length(Pfadname)-1);
 SysInfo.Sysname:=Pfadname+'SYSLUCHS.MCD';
 Application.HelpFile :=Copy(SysInfo.ProgName,1,length(SysInfo.Progname)-7-5)+ 'Luchshlp.hlp';
 SysInfo.Infoname:=Copy(SysInfo.ProgName,1,length(SysInfo.Progname)-7)+'.INI';
 assign(Infofile,SysInfo.Infoname); Reset(Infofile);
 IF Ioresult<>0
  THEN BEGIN
         Rewrite(Infofile);
         writeln(Infofile,'COMRegister=1');
         writeln(Infofile,'CodeStart=$0A004000');
         writeln(Infofile,'Rows=4');
         writeln(Infofile,'Columns=40');
         writeln(Infofile,'rem editor=C:\DOS\Edit.COM');
         close(Infofile)
       END
  ELSE
   BEGIN
    WHILE not Eof(InfoFile) DO
     BEGIN
       w := '';
       Read(Infofile,c);
       WHILE (c<>' ') AND (c <> '=') AND not EOF(InfoFile) AND (c <>#13) DO
           BEGIN w := w + upcase(c); Read(InfoFile,c) END;
       WHILE (c<>'=') AND not eof(InfoFile) DO Read(InfoFile,c);
       IF not eof(InfoFile) THEN Readln(InfoFile,s);
       FOR i:=1 to Length(s) DO s[i]:=Upcase(s[i]);
       Val(s,x,code);
       WHILE s[1] = ' ' DO Delete(S,1,1);
       IF (w<> '') AND (w<>'REM') THEN
         IF code = 0
            THEN BEGIN IF w = 'COMWINDOWS'
                            THEN BEGIN Sysinfo.Com:= x;
                                       SysInfo.Win_seriell:=True;
                                 END
                    ELSE IF w = 'COMREGISTER'
                            THEN BEGIN Sysinfo.Com:= x;
                                       SysInfo.Win_seriell:=False;
                                 END
                    ELSE IF w = 'COLUMNS'
                            THEN Sysinfo.SlaveMaxX:= x
                    ELSE IF w = 'ROWS'
                            THEN Sysinfo.SlaveMaxY:= x
                    ELSE IF w = 'CODESTART'
                            THEN Sysinfo.CodeStart   := x
                    ELSE IF w = 'SPEED'
                            THEN Sysinfo.Speed      := x
                    ELSE Luchs_Info('unbekannter Befehl <'+w+'> in '+SysInfo.Infoname)
                 END
      ELSE IF w = 'EDITOR'
              THEN Sysinfo.Editorname:= s
              ELSE Luchs_Info('unbekannter Befehl <'+w+'> in '+SysInfo.Infoname)
     END;
     Close(Infofile);
   END;
end;

procedure read_Screen_info;
VAR c : Char;
    x : LongInt;
    w,s : String;
    code,i : Integer;
    Screeninfofile: File OF T_Screeninfo;
    Screeninfoname: T_Filename;
    ok: Boolean;
begin
 SysInfo.ScreenInfoname:=Copy(SysInfo.ProgName,1,length(SysInfo.Progname)-7)+'.INF';
 Screeninfo.MainWin.WinTop:=0;      Screeninfo.MainWin.WinLeft:=0;
 Screeninfo.MainWin.WinHeight:=480; Screeninfo.MainWin.WinWidth:=640;
 Screeninfo.MonWin.WinTop:=20;      Screeninfo.MonWin.WinLeft:=0;
 Screeninfo.MonWin.WinHeight:=460;  Screeninfo.MonWin.WinWidth:=640;
{ Screeninfo.MonWin.WinFont.Assign(Courier);}
 Screeninfo.ErrWin.WinTop:=200;     Screeninfo.ErrWin.WinLeft:=280;
 Screeninfo.ErrWin.WinHeight:=280;  Screeninfo.ErrWin.WinWidth:=450;
 Screeninfo.EditWin.WinTop:=0;      Screeninfo.EditWin.WinLeft:=0;
 Screeninfo.EditWin.WinHeight:=480; Screeninfo.EditWin.WinWidth:=640;

 assign(ScreenInfofile,SysInfo.Screeninfoname); Reset(ScreenInfofile);
 ok:=Ioresult=0;
 IF ok
    THEN BEGIN Read(Screeninfofile,Screeninfo);
               ok:=Ioresult=0; Close(Screeninfofile) END;
 if ok
    then begin
           MainForm.Top:=Screeninfo.MainWin.WinTop;
           MainForm.Left:=Screeninfo.MainWin.WinLeft;
           MainForm.Height:=Screeninfo.MainWin.WinHeight;
           MainForm.Width:=Screeninfo.MainWin.WinWidth;
         end
end;

procedure Write_Screen_info;
VAR Screeninfofile: File OF T_Screeninfo;
    Screeninfoname: T_Filename;
begin
 Screeninfo.MainWin.WinTop:=MainForm.Top;
 Screeninfo.MainWin.WinLeft:=MainForm.Left;
 Screeninfo.MainWin.WinHeight:=MainForm.Height;
 Screeninfo.MainWin.WinWidth:=MainForm.Width;
 (* Monitor usw setzen selbst die Screeninfowerte *)
 assign(ScreenInfofile,SysInfo.Screeninfoname); Rewrite(ScreenInfofile);
 IF Ioresult=0
    THEN BEGIN Write(Screeninfofile,Screeninfo); Close(Screeninfofile);
         END ;
end;

procedure Tmainform.Formcreate(Sender: TObject);
begin
  application.onidle:=idle_Proc;
  GlobVar.Host_ist_Slave:=False;
  GlobVar.Mon_aktiv:=False;
  GlobVar.Err_aktiv:=False;
  GlobVar.Edit_aktiv:=False;
  MainForm.Textname.Caption:='';
  WorkFile.TName:='';
  Workfile.CName:='';
  Read_Info_File;
  Read_Screen_Info;
  Lies_Dateinamen;
end;

procedure starteditor;
var Startzeile: String;
    StartPChar: ARRAY[0..255] OF Char;
begin
  IF SysInfo.Editorname=''
     THEN Editform.show
     ELSE BEGIN
            StartZeile:=SysInfo.Editorname+' '+Workfile.TName;
            IF WinExec(StrPCopy(StartPChar,StartZeile),SW_Show)<=32
               THEN Luchs_Info('Kann '+Sysinfo.Editorname+' nicht starten');
          END;
 end;

procedure Tmainform.EditorClick(Sender: TObject);
begin
  Starteditor
end;


procedure Tmainform.LuchsClick(Sender: TObject);
begin
  Monitor
end;

procedure Tmainform.infocancelClick(Sender: TObject);
begin
  infopanel.hide
end;

procedure Tmainform.infobuttonClick(Sender: TObject);
begin
  Infomemo.lines.loadfromfile(SysInfo.Infoname);
  Infopanel.show;
  Infopanel.bringtofront
end;

procedure Tmainform.InfoyesClick(Sender: TObject);
begin
  InfoMemo.lines.savetofile(SysInfo.Infoname);
  InfoPanel.Hide;
  IF NOT GlobVar.Mon_Aktiv THEN Read_Info_File
end;

procedure QuitLuchs;
VAR Dateifile: File OF T_Dateiname;
begin
  assign(Dateifile,Sysinfo.Dateifilename); Rewrite(Dateifile);
  IF Ioresult=0
     THEN BEGIN write(Dateifile,Sysinfo.Dateiname); Close(Dateifile) END
     ELSE Luchs_Info('Fehler beim Schreiben von '+Sysinfo.Dateifilename);
  Write_Screen_Info;
  application.terminate;
end;

procedure quitanweisung;
BEGIN
  IF GlobVar.Mon_Aktiv
      THEN BEGIN IF MessageDlg('Monitor noch aktiv! Trotzdem abbrechen?',
                         mtconfirmation,[mbyes,mbno], 0)=idyes
                     THEN quitluchs
           END
      ELSE quitluchs
end;

procedure Tmainform.QuitButtonClick(Sender: TObject);
begin
  quitanweisung
end;

PROCEDURE Leeres_Textfile_erzeugen; (* falls noch nicht vorhanden *)
VAR Textdatei: Text;
BEGIN
   Assign(Textdatei,WorkFile.Tname); Reset(Textdatei);
   IF Ioresult <> 0 THEN Begin Rewrite(Textdatei); writeln(Textdatei) END;
   Close(Textdatei)
END;

procedure Tmainform.QuickneuClick(Sender: TObject);
begin
 IF Opendialog.execute
    THEN BEGIN
            Textname.Caption:='Textdatei: '+Opendialog.filename;
            Workfile.Tname := Opendialog.Filename;
            Textname_merken;
            Leeres_Textfile_erzeugen;
         END
end;

procedure Tmainform.Quickt1Click(Sender: TObject);
begin
  WorkFile.TName:=Sysinfo.Dateiname.Textname[1];
  Textname_merken
end;

procedure Tmainform.Quickt2Click(Sender: TObject);
begin
  WorkFile.TName:=Sysinfo.Dateiname.Textname[2];
  Textname_merken
end;

procedure Tmainform.Quickt3Click(Sender: TObject);
begin
  WorkFile.TName:=Sysinfo.Dateiname.Textname[3];
  Textname_merken
end;

procedure Tmainform.Quickt4Click(Sender: TObject);
begin
  WorkFile.TName:=Sysinfo.Dateiname.Textname[4];
  Textname_merken
end;

procedure Tmainform.Quickt5Click(Sender: TObject);
begin
  WorkFile.TName:=Sysinfo.Dateiname.Textname[5];
  Textname_merken
end;

procedure Tmainform.Quickt6Click(Sender: TObject);
begin
  WorkFile.TName:=Sysinfo.Dateiname.Textname[6];
  Textname_merken
end;

procedure Tmainform.Monitor1Click(Sender: TObject);
begin
   Monitor
end;

procedure Tmainform.Editor1Click(Sender: TObject);
begin
  Starteditor
end;

procedure Tmainform.Quit1Click(Sender: TObject);
begin
   Quitanweisung
end;

procedure Tmainform.Info1Click(Sender: TObject);
begin
  Infomemo.lines.loadfromfile(SysInfo.Infoname);
  Infopanel.show;
  Infopanel.bringtofront
end;

procedure Tmainform.Basic1Click(Sender: TObject);
BEGIN
  IF Workfile.TName<>''
     THEN Basic
     ELSE IF MainForm.OpenDialog.Execute
          THEN BEGIN Workfile.TName:=MainForm.OpenDialog.Filename;
                     Basic
               END;
  IF not InputRec.C_Ok
     THEN Err_ausgabe('Basic')
     ELSE BEGIN Codename_merken(Workfile.CName);
                Luchs_Info(InputRec.OkMeldung);
          END
END;

procedure Tmainform.Assembler1Click(Sender: TObject);
BEGIN
  IF Workfile.TName<>''
     THEN Assemble
     ELSE IF MainForm.OpenDialog.Execute
          THEN BEGIN Workfile.TName:=MainForm.OpenDialog.Filename;
                     Assemble
               END;
    IF not InputRec.C_Ok
       THEN Err_ausgabe('Assembler')
       ELSE BEGIN Codename_merken(Workfile.CName);
                  Luchs_Info(InputRec.OkMeldung);
            END
END;

procedure Tmainform.PasbuttonClick(Sender: TObject);
BEGIN
  IF Workfile.TName<>''
     THEN Pascal
     ELSE IF MainForm.OpenDialog.Execute
          THEN BEGIN Workfile.TName:=MainForm.OpenDialog.Filename;
                     Pascal
               END;
  IF not InputRec.C_Ok
     THEN Err_ausgabe('Pascal')
     ELSE BEGIN Codename_merken(Workfile.CName);
                  Luchs_Info(InputRec.OkMeldung);
          END
END;

procedure Tmainform.MainhelpClick(Sender: TObject);
begin
     Application.HelpJump('Inhalt');
end;

procedure Tmainform.BitBtn2Click(Sender: TObject);
begin
  Progflash
end;

procedure Tmainform.EprombuttonClick(Sender: TObject);
begin
   Erzeuge_Eprom
end;

procedure Tmainform.FormActivate(Sender: TObject);
begin
 Textname_Merken
end;

procedure Tmainform.BitBtn1Click(Sender: TObject);
begin
  Luchs_Info('LUCHS-Bild gezeichnet von'+#13+#10+'Evelyn Himmeroeder')
end;

end.
